// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 139 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
 /* -*-C++-*- */
#include "frontends/parsers/parserDriver.h"
#include "frontends/parsers/p4/p4lexer.hpp"
#include "frontends/parsers/p4/p4parser.hpp"

using namespace P4;

#define YYLLOC_DEFAULT(Cur, Rhs, N)                                             \
    ((Cur) = (N) ? YYRHSLOC(Rhs, 1) + YYRHSLOC(Rhs, N)                          \
                 : Util::SourceInfo(driver.sources, YYRHSLOC(Rhs, 0).getEnd()))

#undef yylex
#define yylex lexer.yylex


#line 57 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"


#include "p4parser.hpp"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 23 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
namespace P4 {
#line 155 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"

  /// Build a parser object.
  P4Parser::P4Parser (P4::P4ParserDriver& driver_yyarg, P4::AbstractP4Lexer& lexer_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      lexer (lexer_yyarg)
  {}

  P4Parser::~P4Parser ()
  {}

  P4Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  P4Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  P4Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  P4Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  P4Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  P4Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  P4Parser::symbol_kind_type
  P4Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  P4Parser::stack_symbol_type::stack_symbol_type ()
  {}

  P4Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
        value.YY_MOVE_OR_COPY< ConstType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotation: // annotation
        value.YY_MOVE_OR_COPY< IR::Annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argument: // argument
        value.YY_MOVE_OR_COPY< IR::Argument* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.YY_MOVE_OR_COPY< IR::BlockStatement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.YY_MOVE_OR_COPY< IR::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_direction: // direction
        value.YY_MOVE_OR_COPY< IR::Direction > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entry: // entry
        value.YY_MOVE_OR_COPY< IR::Entry* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.YY_MOVE_OR_COPY< IR::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.YY_MOVE_OR_COPY< IR::ID* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_actionList: // actionList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::ActionListElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::Declaration>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::Declaration_ID>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvList: // kvList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::NamedExpression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::Parameter>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::ParserState>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::Property>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::SerEnumMember>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::StatOrDecl>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::StructField>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.YY_MOVE_OR_COPY< IR::IndexedVector<IR::Type_Var>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.YY_MOVE_OR_COPY< IR::KeyElement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.YY_MOVE_OR_COPY< IR::Method* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.YY_MOVE_OR_COPY< IR::NamedExpression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.YY_MOVE_OR_COPY< IR::Node* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameter: // parameter
        value.YY_MOVE_OR_COPY< IR::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserState: // parserState
        value.YY_MOVE_OR_COPY< IR::ParserState* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.YY_MOVE_OR_COPY< IR::Path* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.YY_MOVE_OR_COPY< IR::Property* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.YY_MOVE_OR_COPY< IR::SelectCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.YY_MOVE_OR_COPY< IR::SerEnumMember* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.YY_MOVE_OR_COPY< IR::StatOrDecl* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.YY_MOVE_OR_COPY< IR::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structField: // structField
        value.YY_MOVE_OR_COPY< IR::StructField* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.YY_MOVE_OR_COPY< IR::SwitchCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.YY_MOVE_OR_COPY< IR::TypeParameters* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.YY_MOVE_OR_COPY< IR::Type_Control* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.YY_MOVE_OR_COPY< IR::Type_Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.YY_MOVE_OR_COPY< IR::Type_Error* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeName: // typeName
        value.YY_MOVE_OR_COPY< IR::Type_Name* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.YY_MOVE_OR_COPY< IR::Type_Parser* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Annotation>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.YY_MOVE_OR_COPY< IR::Vector<IR::AnnotationToken>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Argument>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Entry>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Expression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::KeyElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Method>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::SelectCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.YY_MOVE_OR_COPY< IR::Vector<IR::SwitchCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.YY_MOVE_OR_COPY< IR::Vector<IR::Type>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.YY_MOVE_OR_COPY< OptionalConst > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.YY_MOVE_OR_COPY< Token > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.YY_MOVE_OR_COPY< UnparsedConstant > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.YY_MOVE_OR_COPY< cstring > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  P4Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
        value.move< ConstType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotation: // annotation
        value.move< IR::Annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argument: // argument
        value.move< IR::Argument* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.move< IR::BlockStatement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.move< IR::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_direction: // direction
        value.move< IR::Direction > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entry: // entry
        value.move< IR::Entry* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.move< IR::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.move< IR::ID* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_actionList: // actionList
        value.move< IR::IndexedVector<IR::ActionListElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.move< IR::IndexedVector<IR::Declaration>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.move< IR::IndexedVector<IR::Declaration_ID>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvList: // kvList
        value.move< IR::IndexedVector<IR::NamedExpression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.move< IR::IndexedVector<IR::Parameter>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.move< IR::IndexedVector<IR::ParserState>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.move< IR::IndexedVector<IR::Property>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.move< IR::IndexedVector<IR::SerEnumMember>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.move< IR::IndexedVector<IR::StatOrDecl>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.move< IR::IndexedVector<IR::StructField>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.move< IR::IndexedVector<IR::Type_Var>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.move< IR::KeyElement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.move< IR::Method* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.move< IR::NamedExpression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.move< IR::Node* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parameter: // parameter
        value.move< IR::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserState: // parserState
        value.move< IR::ParserState* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.move< IR::Path* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.move< IR::Property* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.move< IR::SelectCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.move< IR::SerEnumMember* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.move< IR::StatOrDecl* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.move< IR::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_structField: // structField
        value.move< IR::StructField* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.move< IR::SwitchCase* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.move< IR::TypeParameters* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.move< IR::Type_Control* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.move< IR::Type_Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.move< IR::Type_Error* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeName: // typeName
        value.move< IR::Type_Name* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.move< IR::Type_Parser* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.move< IR::Vector<IR::Annotation>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.move< IR::Vector<IR::AnnotationToken>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.move< IR::Vector<IR::Argument>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.move< IR::Vector<IR::Entry>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.move< IR::Vector<IR::Expression>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.move< IR::Vector<IR::KeyElement>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.move< IR::Vector<IR::Method>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.move< IR::Vector<IR::SelectCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.move< IR::Vector<IR::SwitchCase>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.move< IR::Vector<IR::Type>* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.move< OptionalConst > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.move< Token > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.move< UnparsedConstant > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.move< cstring > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  P4Parser::stack_symbol_type&
  P4Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
        value.copy< ConstType* > (that.value);
        break;

      case symbol_kind::S_annotation: // annotation
        value.copy< IR::Annotation* > (that.value);
        break;

      case symbol_kind::S_argument: // argument
        value.copy< IR::Argument* > (that.value);
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.copy< IR::BlockStatement* > (that.value);
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.copy< IR::Declaration* > (that.value);
        break;

      case symbol_kind::S_direction: // direction
        value.copy< IR::Direction > (that.value);
        break;

      case symbol_kind::S_entry: // entry
        value.copy< IR::Entry* > (that.value);
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.copy< IR::Expression* > (that.value);
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.copy< IR::ID* > (that.value);
        break;

      case symbol_kind::S_actionList: // actionList
        value.copy< IR::IndexedVector<IR::ActionListElement>* > (that.value);
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.copy< IR::IndexedVector<IR::Declaration>* > (that.value);
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.copy< IR::IndexedVector<IR::Declaration_ID>* > (that.value);
        break;

      case symbol_kind::S_kvList: // kvList
        value.copy< IR::IndexedVector<IR::NamedExpression>* > (that.value);
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.copy< IR::IndexedVector<IR::Parameter>* > (that.value);
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.copy< IR::IndexedVector<IR::ParserState>* > (that.value);
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.copy< IR::IndexedVector<IR::Property>* > (that.value);
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.copy< IR::IndexedVector<IR::SerEnumMember>* > (that.value);
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.copy< IR::IndexedVector<IR::StatOrDecl>* > (that.value);
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.copy< IR::IndexedVector<IR::StructField>* > (that.value);
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.copy< IR::IndexedVector<IR::Type_Var>* > (that.value);
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.copy< IR::KeyElement* > (that.value);
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.copy< IR::Method* > (that.value);
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.copy< IR::NamedExpression* > (that.value);
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.copy< IR::Node* > (that.value);
        break;

      case symbol_kind::S_parameter: // parameter
        value.copy< IR::Parameter* > (that.value);
        break;

      case symbol_kind::S_parserState: // parserState
        value.copy< IR::ParserState* > (that.value);
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.copy< IR::Path* > (that.value);
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.copy< IR::Property* > (that.value);
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.copy< IR::SelectCase* > (that.value);
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.copy< IR::SerEnumMember* > (that.value);
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.copy< IR::StatOrDecl* > (that.value);
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.copy< IR::Statement* > (that.value);
        break;

      case symbol_kind::S_structField: // structField
        value.copy< IR::StructField* > (that.value);
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.copy< IR::SwitchCase* > (that.value);
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.copy< IR::TypeParameters* > (that.value);
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.copy< IR::Type_Control* > (that.value);
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.copy< IR::Type_Declaration* > (that.value);
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.copy< IR::Type_Error* > (that.value);
        break;

      case symbol_kind::S_typeName: // typeName
        value.copy< IR::Type_Name* > (that.value);
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.copy< IR::Type_Parser* > (that.value);
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.copy< IR::Vector<IR::Annotation>* > (that.value);
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.copy< IR::Vector<IR::AnnotationToken>* > (that.value);
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.copy< IR::Vector<IR::Argument>* > (that.value);
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.copy< IR::Vector<IR::Entry>* > (that.value);
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.copy< IR::Vector<IR::Expression>* > (that.value);
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.copy< IR::Vector<IR::KeyElement>* > (that.value);
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.copy< IR::Vector<IR::Method>* > (that.value);
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.copy< IR::Vector<IR::SelectCase>* > (that.value);
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.copy< IR::Vector<IR::SwitchCase>* > (that.value);
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.copy< IR::Vector<IR::Type>* > (that.value);
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.copy< OptionalConst > (that.value);
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.copy< Token > (that.value);
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.copy< UnparsedConstant > (that.value);
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.copy< cstring > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  P4Parser::stack_symbol_type&
  P4Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
        value.move< ConstType* > (that.value);
        break;

      case symbol_kind::S_annotation: // annotation
        value.move< IR::Annotation* > (that.value);
        break;

      case symbol_kind::S_argument: // argument
        value.move< IR::Argument* > (that.value);
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        value.move< IR::BlockStatement* > (that.value);
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        value.move< IR::Declaration* > (that.value);
        break;

      case symbol_kind::S_direction: // direction
        value.move< IR::Direction > (that.value);
        break;

      case symbol_kind::S_entry: // entry
        value.move< IR::Entry* > (that.value);
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        value.move< IR::Expression* > (that.value);
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        value.move< IR::ID* > (that.value);
        break;

      case symbol_kind::S_actionList: // actionList
        value.move< IR::IndexedVector<IR::ActionListElement>* > (that.value);
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        value.move< IR::IndexedVector<IR::Declaration>* > (that.value);
        break;

      case symbol_kind::S_identifierList: // identifierList
        value.move< IR::IndexedVector<IR::Declaration_ID>* > (that.value);
        break;

      case symbol_kind::S_kvList: // kvList
        value.move< IR::IndexedVector<IR::NamedExpression>* > (that.value);
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        value.move< IR::IndexedVector<IR::Parameter>* > (that.value);
        break;

      case symbol_kind::S_parserStates: // parserStates
        value.move< IR::IndexedVector<IR::ParserState>* > (that.value);
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        value.move< IR::IndexedVector<IR::Property>* > (that.value);
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        value.move< IR::IndexedVector<IR::SerEnumMember>* > (that.value);
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        value.move< IR::IndexedVector<IR::StatOrDecl>* > (that.value);
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        value.move< IR::IndexedVector<IR::StructField>* > (that.value);
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        value.move< IR::IndexedVector<IR::Type_Var>* > (that.value);
        break;

      case symbol_kind::S_keyElement: // keyElement
        value.move< IR::KeyElement* > (that.value);
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        value.move< IR::Method* > (that.value);
        break;

      case symbol_kind::S_kvPair: // kvPair
        value.move< IR::NamedExpression* > (that.value);
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        value.move< IR::Node* > (that.value);
        break;

      case symbol_kind::S_parameter: // parameter
        value.move< IR::Parameter* > (that.value);
        break;

      case symbol_kind::S_parserState: // parserState
        value.move< IR::ParserState* > (that.value);
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        value.move< IR::Path* > (that.value);
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        value.move< IR::Property* > (that.value);
        break;

      case symbol_kind::S_selectCase: // selectCase
        value.move< IR::SelectCase* > (that.value);
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        value.move< IR::SerEnumMember* > (that.value);
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        value.move< IR::StatOrDecl* > (that.value);
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        value.move< IR::Statement* > (that.value);
        break;

      case symbol_kind::S_structField: // structField
        value.move< IR::StructField* > (that.value);
        break;

      case symbol_kind::S_switchCase: // switchCase
        value.move< IR::SwitchCase* > (that.value);
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        value.move< IR::TypeParameters* > (that.value);
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        value.move< IR::Type_Control* > (that.value);
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        value.move< IR::Type_Declaration* > (that.value);
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        value.move< IR::Type_Error* > (that.value);
        break;

      case symbol_kind::S_typeName: // typeName
        value.move< IR::Type_Name* > (that.value);
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        value.move< IR::Type_Parser* > (that.value);
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        value.move< IR::Vector<IR::Annotation>* > (that.value);
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        value.move< IR::Vector<IR::AnnotationToken>* > (that.value);
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        value.move< IR::Vector<IR::Argument>* > (that.value);
        break;

      case symbol_kind::S_entriesList: // entriesList
        value.move< IR::Vector<IR::Entry>* > (that.value);
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        value.move< IR::Vector<IR::Expression>* > (that.value);
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        value.move< IR::Vector<IR::KeyElement>* > (that.value);
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        value.move< IR::Vector<IR::Method>* > (that.value);
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        value.move< IR::Vector<IR::SelectCase>* > (that.value);
        break;

      case symbol_kind::S_switchCases: // switchCases
        value.move< IR::Vector<IR::SwitchCase>* > (that.value);
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        value.move< IR::Vector<IR::Type>* > (that.value);
        break;

      case symbol_kind::S_optCONST: // optCONST
        value.move< OptionalConst > (that.value);
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        value.move< Token > (that.value);
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        value.move< UnparsedConstant > (that.value);
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        value.move< cstring > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  P4Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  P4Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        switch (yykind)
    {
      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1947 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1953 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_LE: // "<="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1959 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_GE: // ">="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1965 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_SHL: // "<<"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1971 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_AND: // "&&"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1977 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_OR: // "||"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1983 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_NE: // "!="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1989 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_EQ: // "=="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 1995 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PLUS: // "+"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2001 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MINUS: // "-"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2007 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PLUS_SAT: // "|+|"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2013 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MINUS_SAT: // "|-|"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2019 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MUL: // "*"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2025 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_INVALID: // "{#}"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2031 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_DIV: // "/"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2037 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MOD: // "%"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2043 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BIT_OR: // "|"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2049 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BIT_AND: // "&"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2055 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BIT_XOR: // "^"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2061 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_COMPLEMENT: // "~"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2067 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_L_BRACKET: // "["
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2073 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_R_BRACKET: // "]"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2079 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_L_BRACE: // "{"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2085 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_R_BRACE: // "}"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2091 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_L_ANGLE: // "<"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2097 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2103 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_R_ANGLE: // ">"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2109 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2115 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_L_PAREN: // "("
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2121 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_R_PAREN: // ")"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2127 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_NOT: // "!"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2133 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_COLON: // ":"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2139 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_COMMA: // ","
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2145 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_QUESTION: // "?"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2151 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_DOT: // "."
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2157 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN: // "="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2163 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_PLUS: // "+="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2169 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_MINUS: // "-="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2175 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_MUL: // "*="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2181 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_DIV: // "/="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2187 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_MOD: // "%="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2193 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2199 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2205 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_XOR: // "^="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2211 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_SHL: // "<<="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2217 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_SHR: // ">>="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2223 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2229 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2235 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_SEMICOLON: // ";"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2241 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_AT: // "@"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2247 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PP: // "++"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2253 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_DONTCARE: // "_"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2259 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MASK: // "&&&"
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2265 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_DOTS: // "..."
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2271 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_RANGE: // ".."
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2277 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TRUE: // TRUE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2283 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_FALSE: // FALSE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2289 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_THIS: // THIS
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2295 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ABSTRACT: // ABSTRACT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2301 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ACTION: // ACTION
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2307 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ACTIONS: // ACTIONS
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2313 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_APPLY: // APPLY
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2319 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BOOL: // BOOL
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2325 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BIT: // BIT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2331 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_BREAK: // BREAK
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2337 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_CONST: // CONST
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2343 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_CONTINUE: // CONTINUE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2349 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_CONTROL: // CONTROL
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2355 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_DEFAULT: // DEFAULT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2361 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ELSE: // ELSE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2367 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ENTRIES: // ENTRIES
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2373 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ENUM: // ENUM
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2379 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_ERROR: // ERROR
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2385 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_EXIT: // EXIT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2391 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_EXTERN: // EXTERN
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2397 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_FOR: // FOR
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2403 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_HEADER: // HEADER
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2409 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2415 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_IF: // IF
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2421 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_IN: // IN
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2427 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_INOUT: // INOUT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2433 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_INT: // INT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2439 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_KEY: // KEY
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2445 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_LIST: // LIST
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2451 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_SELECT: // SELECT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2457 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2463 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TYPE: // TYPE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2469 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_OUT: // OUT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2475 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PACKAGE: // PACKAGE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2481 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PARSER: // PARSER
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2487 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PRAGMA: // PRAGMA
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2493 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_PRIORITY: // PRIORITY
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2499 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_RETURN: // RETURN
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2505 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_STATE: // STATE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2511 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_STRING: // STRING
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2517 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_STRUCT: // STRUCT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2523 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_SWITCH: // SWITCH
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2529 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TABLE: // TABLE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2535 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TRANSITION: // TRANSITION
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2541 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TUPLE: // TUPLE
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2547 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TYPEDEF: // TYPEDEF
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2553 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_VARBIT: // VARBIT
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2559 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_VALUESET: // VALUESET
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2565 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_VOID: // VOID
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2571 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < cstring > (); }
#line 2577 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < cstring > (); }
#line 2583 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < cstring > (); }
#line 2589 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_INTEGER: // INTEGER
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < UnparsedConstant > (); }
#line 2595 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_fragment: // fragment
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Node* > (); }
#line 2601 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2607 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_declaration: // declaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Node* > (); }
#line 2613 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ID* > (); }
#line 2619 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_name: // name
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ID* > (); }
#line 2625 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_nonTableKwName: // nonTableKwName
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ID* > (); }
#line 2631 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_optCONST: // optCONST
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < OptionalConst > (); }
#line 2637 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Annotation>* > (); }
#line 2643 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_annotations: // annotations
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Annotation>* > (); }
#line 2649 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_annotation: // annotation
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Annotation* > (); }
#line 2655 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_annotationBody: // annotationBody
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::AnnotationToken>* > (); }
#line 2661 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_annotationName: // annotationName
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ID* > (); }
#line 2667 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_annotationToken: // annotationToken
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < Token > (); }
#line 2673 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_kvList: // kvList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::NamedExpression>* > (); }
#line 2679 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_kvPair: // kvPair
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::NamedExpression* > (); }
#line 2685 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parameterList: // parameterList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Parameter>* > (); }
#line 2691 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Parameter>* > (); }
#line 2697 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parameter: // parameter
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Parameter* > (); }
#line 2703 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_direction: // direction
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Direction > (); }
#line 2709 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 2715 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_instantiation: // instantiation
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 2721 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_objInitializer: // objInitializer
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::BlockStatement* > (); }
#line 2727 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 2733 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_objDeclaration: // objDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 2739 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Parameter>* > (); }
#line 2745 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserDeclaration: // parserDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 2751 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Declaration>* > (); }
#line 2757 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserLocalElement: // parserLocalElement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 2763 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Parser* > (); }
#line 2769 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserStates: // parserStates
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::ParserState>* > (); }
#line 2775 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserState: // parserState
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ParserState* > (); }
#line 2781 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserStatements: // parserStatements
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 2787 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserStatement: // parserStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::StatOrDecl* > (); }
#line 2793 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::BlockStatement* > (); }
#line 2799 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_transitionStatement: // transitionStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2805 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_stateExpression: // stateExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2811 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_selectExpression: // selectExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2817 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::SelectCase>* > (); }
#line 2823 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_selectCase: // selectCase
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::SelectCase* > (); }
#line 2829 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_keysetExpression: // keysetExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2835 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 2841 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 2847 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2853 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 2859 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 2865 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_controlDeclaration: // controlDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 2871 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Control* > (); }
#line 2877 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Declaration>* > (); }
#line 2883 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 2889 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_controlBody: // controlBody
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::BlockStatement* > (); }
#line 2895 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_externDeclaration: // externDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Node* > (); }
#line 2901 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Method>* > (); }
#line 2907 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Method* > (); }
#line 2913 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_methodPrototype: // methodPrototype
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Method* > (); }
#line 2919 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeRef: // typeRef
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2925 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_namedType: // namedType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2931 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_prefixedType: // prefixedType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Path* > (); }
#line 2937 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeName: // typeName
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Name* > (); }
#line 2943 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_p4listType: // p4listType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2949 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_tupleType: // tupleType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2955 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_headerStackType: // headerStackType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2961 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_specializedType: // specializedType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2967 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_baseType: // baseType
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2973 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeOrVoid: // typeOrVoid
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 2979 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::TypeParameters* > (); }
#line 2985 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeParameters: // typeParameters
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::TypeParameters* > (); }
#line 2991 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Type_Var>* > (); }
#line 2997 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeArg: // typeArg
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 3003 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Type>* > (); }
#line 3009 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_realTypeArg: // realTypeArg
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < ConstType* > (); }
#line 3015 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Type>* > (); }
#line 3021 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typeDeclaration: // typeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3027 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3033 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3039 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3045 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3051 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_structFieldList: // structFieldList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StructField>* > (); }
#line 3057 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_structField: // structField
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::StructField* > (); }
#line 3063 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_enumDeclaration: // enumDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3069 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::SerEnumMember>* > (); }
#line 3075 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::SerEnumMember* > (); }
#line 3081 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Error* > (); }
#line 3087 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Node* > (); }
#line 3093 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_identifierList: // identifierList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Declaration_ID>* > (); }
#line 3099 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Type_Declaration* > (); }
#line 3105 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3111 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3117 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_emptyStatement: // emptyStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3123 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_exitStatement: // exitStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3129 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_returnStatement: // returnStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3135 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_conditionalStatement: // conditionalStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3141 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_breakStatement: // breakStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3147 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_continueStatement: // continueStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3153 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_directApplication: // directApplication
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3159 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_statement: // statement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3165 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_blockStatement: // blockStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::BlockStatement* > (); }
#line 3171 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_statOrDeclList: // statOrDeclList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 3177 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_switchStatement: // switchStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3183 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_switchCases: // switchCases
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::SwitchCase>* > (); }
#line 3189 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_switchCase: // switchCase
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::SwitchCase* > (); }
#line 3195 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_switchLabel: // switchLabel
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3201 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::StatOrDecl* > (); }
#line 3207 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forStatement: // forStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Statement* > (); }
#line 3213 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forInitStatements: // forInitStatements
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 3219 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 3225 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::StatOrDecl* > (); }
#line 3231 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 3237 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 3243 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3249 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_tableDeclaration: // tableDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3255 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::Property>* > (); }
#line 3261 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_tableProperty: // tableProperty
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Property* > (); }
#line 3267 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_keyElementList: // keyElementList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::KeyElement>* > (); }
#line 3273 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_keyElement: // keyElement
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::KeyElement* > (); }
#line 3279 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_actionList: // actionList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::IndexedVector<IR::ActionListElement>* > (); }
#line 3285 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_actionRef: // actionRef
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3291 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_entry: // entry
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Entry* > (); }
#line 3297 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_entryPriority: // entryPriority
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3303 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_entriesList: // entriesList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Entry>* > (); }
#line 3309 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_actionDeclaration: // actionDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3315 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_variableDeclaration: // variableDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3321 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3327 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_constantDeclaration: // constantDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3333 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_optInitializer: // optInitializer
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3339 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_initializer: // initializer
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3345 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_functionDeclaration: // functionDeclaration
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Declaration* > (); }
#line 3351 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_argumentList: // argumentList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Argument>* > (); }
#line 3357 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Argument>* > (); }
#line 3363 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_argument: // argument
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Argument* > (); }
#line 3369 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_expressionList: // expressionList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 3375 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Path* > (); }
#line 3381 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_dot_name: // dot_name
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::ID* > (); }
#line 3387 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_lvalue: // lvalue
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3393 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_expression: // expression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3399 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3405 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_intOrStr: // intOrStr
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Expression* > (); }
#line 3411 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_intList: // intList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 3417 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_intOrStrList: // intOrStrList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 3423 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      case symbol_kind::S_strList: // strList
#line 156 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yyoutput << yysym.value.template as < IR::Vector<IR::Expression>* > (); }
#line 3429 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
        break;

      default:
        break;
    }
        yyo << ')';
      }
  }
#endif

  void
  P4Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  P4Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  P4Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  P4Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  P4Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  P4Parser::debug_level_type
  P4Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  P4Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  P4Parser::state_type
  P4Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  P4Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  P4Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  P4Parser::operator() ()
  {
    return parse ();
  }

  int
  P4Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_typeRef: // typeRef
      case symbol_kind::S_namedType: // namedType
      case symbol_kind::S_p4listType: // p4listType
      case symbol_kind::S_tupleType: // tupleType
      case symbol_kind::S_headerStackType: // headerStackType
      case symbol_kind::S_specializedType: // specializedType
      case symbol_kind::S_baseType: // baseType
      case symbol_kind::S_typeOrVoid: // typeOrVoid
      case symbol_kind::S_typeArg: // typeArg
      case symbol_kind::S_realTypeArg: // realTypeArg
        yylhs.value.emplace< ConstType* > ();
        break;

      case symbol_kind::S_annotation: // annotation
        yylhs.value.emplace< IR::Annotation* > ();
        break;

      case symbol_kind::S_argument: // argument
        yylhs.value.emplace< IR::Argument* > ();
        break;

      case symbol_kind::S_objInitializer: // objInitializer
      case symbol_kind::S_parserBlockStatement: // parserBlockStatement
      case symbol_kind::S_controlBody: // controlBody
      case symbol_kind::S_blockStatement: // blockStatement
        yylhs.value.emplace< IR::BlockStatement* > ();
        break;

      case symbol_kind::S_instantiation: // instantiation
      case symbol_kind::S_objDeclaration: // objDeclaration
      case symbol_kind::S_parserLocalElement: // parserLocalElement
      case symbol_kind::S_valueSetDeclaration: // valueSetDeclaration
      case symbol_kind::S_controlLocalDeclaration: // controlLocalDeclaration
      case symbol_kind::S_tableDeclaration: // tableDeclaration
      case symbol_kind::S_actionDeclaration: // actionDeclaration
      case symbol_kind::S_variableDeclaration: // variableDeclaration
      case symbol_kind::S_variableDeclarationWithoutSemicolon: // variableDeclarationWithoutSemicolon
      case symbol_kind::S_constantDeclaration: // constantDeclaration
      case symbol_kind::S_functionDeclaration: // functionDeclaration
        yylhs.value.emplace< IR::Declaration* > ();
        break;

      case symbol_kind::S_direction: // direction
        yylhs.value.emplace< IR::Direction > ();
        break;

      case symbol_kind::S_entry: // entry
        yylhs.value.emplace< IR::Entry* > ();
        break;

      case symbol_kind::S_p4rtControllerType: // p4rtControllerType
      case symbol_kind::S_transitionStatement: // transitionStatement
      case symbol_kind::S_stateExpression: // stateExpression
      case symbol_kind::S_selectExpression: // selectExpression
      case symbol_kind::S_keysetExpression: // keysetExpression
      case symbol_kind::S_reducedSimpleKeysetExpression: // reducedSimpleKeysetExpression
      case symbol_kind::S_simpleKeysetExpression: // simpleKeysetExpression
      case symbol_kind::S_switchLabel: // switchLabel
      case symbol_kind::S_forCollectionExpr: // forCollectionExpr
      case symbol_kind::S_actionRef: // actionRef
      case symbol_kind::S_entryPriority: // entryPriority
      case symbol_kind::S_optInitializer: // optInitializer
      case symbol_kind::S_initializer: // initializer
      case symbol_kind::S_lvalue: // lvalue
      case symbol_kind::S_expression: // expression
      case symbol_kind::S_nonBraceExpression: // nonBraceExpression
      case symbol_kind::S_intOrStr: // intOrStr
        yylhs.value.emplace< IR::Expression* > ();
        break;

      case symbol_kind::S_nonTypeName: // nonTypeName
      case symbol_kind::S_name: // name
      case symbol_kind::S_nonTableKwName: // nonTableKwName
      case symbol_kind::S_annotationName: // annotationName
      case symbol_kind::S_dot_name: // dot_name
        yylhs.value.emplace< IR::ID* > ();
        break;

      case symbol_kind::S_actionList: // actionList
        yylhs.value.emplace< IR::IndexedVector<IR::ActionListElement>* > ();
        break;

      case symbol_kind::S_parserLocalElements: // parserLocalElements
      case symbol_kind::S_controlLocalDeclarations: // controlLocalDeclarations
        yylhs.value.emplace< IR::IndexedVector<IR::Declaration>* > ();
        break;

      case symbol_kind::S_identifierList: // identifierList
        yylhs.value.emplace< IR::IndexedVector<IR::Declaration_ID>* > ();
        break;

      case symbol_kind::S_kvList: // kvList
        yylhs.value.emplace< IR::IndexedVector<IR::NamedExpression>* > ();
        break;

      case symbol_kind::S_parameterList: // parameterList
      case symbol_kind::S_nonEmptyParameterList: // nonEmptyParameterList
      case symbol_kind::S_optConstructorParameters: // optConstructorParameters
        yylhs.value.emplace< IR::IndexedVector<IR::Parameter>* > ();
        break;

      case symbol_kind::S_parserStates: // parserStates
        yylhs.value.emplace< IR::IndexedVector<IR::ParserState>* > ();
        break;

      case symbol_kind::S_tablePropertyList: // tablePropertyList
        yylhs.value.emplace< IR::IndexedVector<IR::Property>* > ();
        break;

      case symbol_kind::S_specifiedIdentifierList: // specifiedIdentifierList
        yylhs.value.emplace< IR::IndexedVector<IR::SerEnumMember>* > ();
        break;

      case symbol_kind::S_objDeclarations: // objDeclarations
      case symbol_kind::S_parserStatements: // parserStatements
      case symbol_kind::S_statOrDeclList: // statOrDeclList
      case symbol_kind::S_forInitStatements: // forInitStatements
      case symbol_kind::S_forInitStatementsNonEmpty: // forInitStatementsNonEmpty
      case symbol_kind::S_forUpdateStatements: // forUpdateStatements
      case symbol_kind::S_forUpdateStatementsNonEmpty: // forUpdateStatementsNonEmpty
        yylhs.value.emplace< IR::IndexedVector<IR::StatOrDecl>* > ();
        break;

      case symbol_kind::S_structFieldList: // structFieldList
        yylhs.value.emplace< IR::IndexedVector<IR::StructField>* > ();
        break;

      case symbol_kind::S_typeParameterList: // typeParameterList
        yylhs.value.emplace< IR::IndexedVector<IR::Type_Var>* > ();
        break;

      case symbol_kind::S_keyElement: // keyElement
        yylhs.value.emplace< IR::KeyElement* > ();
        break;

      case symbol_kind::S_functionPrototype: // functionPrototype
      case symbol_kind::S_methodPrototype: // methodPrototype
        yylhs.value.emplace< IR::Method* > ();
        break;

      case symbol_kind::S_kvPair: // kvPair
        yylhs.value.emplace< IR::NamedExpression* > ();
        break;

      case symbol_kind::S_fragment: // fragment
      case symbol_kind::S_declaration: // declaration
      case symbol_kind::S_externDeclaration: // externDeclaration
      case symbol_kind::S_matchKindDeclaration: // matchKindDeclaration
        yylhs.value.emplace< IR::Node* > ();
        break;

      case symbol_kind::S_parameter: // parameter
        yylhs.value.emplace< IR::Parameter* > ();
        break;

      case symbol_kind::S_parserState: // parserState
        yylhs.value.emplace< IR::ParserState* > ();
        break;

      case symbol_kind::S_prefixedType: // prefixedType
      case symbol_kind::S_prefixedNonTypeName: // prefixedNonTypeName
        yylhs.value.emplace< IR::Path* > ();
        break;

      case symbol_kind::S_tableProperty: // tableProperty
        yylhs.value.emplace< IR::Property* > ();
        break;

      case symbol_kind::S_selectCase: // selectCase
        yylhs.value.emplace< IR::SelectCase* > ();
        break;

      case symbol_kind::S_specifiedIdentifier: // specifiedIdentifier
        yylhs.value.emplace< IR::SerEnumMember* > ();
        break;

      case symbol_kind::S_parserStatement: // parserStatement
      case symbol_kind::S_statementOrDeclaration: // statementOrDeclaration
      case symbol_kind::S_declOrAssignmentOrMethodCallStatement: // declOrAssignmentOrMethodCallStatement
        yylhs.value.emplace< IR::StatOrDecl* > ();
        break;

      case symbol_kind::S_assignmentOrMethodCallStatement: // assignmentOrMethodCallStatement
      case symbol_kind::S_assignmentOrMethodCallStatementWithoutSemicolon: // assignmentOrMethodCallStatementWithoutSemicolon
      case symbol_kind::S_emptyStatement: // emptyStatement
      case symbol_kind::S_exitStatement: // exitStatement
      case symbol_kind::S_returnStatement: // returnStatement
      case symbol_kind::S_conditionalStatement: // conditionalStatement
      case symbol_kind::S_breakStatement: // breakStatement
      case symbol_kind::S_continueStatement: // continueStatement
      case symbol_kind::S_directApplication: // directApplication
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_switchStatement: // switchStatement
      case symbol_kind::S_forStatement: // forStatement
        yylhs.value.emplace< IR::Statement* > ();
        break;

      case symbol_kind::S_structField: // structField
        yylhs.value.emplace< IR::StructField* > ();
        break;

      case symbol_kind::S_switchCase: // switchCase
        yylhs.value.emplace< IR::SwitchCase* > ();
        break;

      case symbol_kind::S_optTypeParameters: // optTypeParameters
      case symbol_kind::S_typeParameters: // typeParameters
        yylhs.value.emplace< IR::TypeParameters* > ();
        break;

      case symbol_kind::S_controlTypeDeclaration: // controlTypeDeclaration
        yylhs.value.emplace< IR::Type_Control* > ();
        break;

      case symbol_kind::S_packageTypeDeclaration: // packageTypeDeclaration
      case symbol_kind::S_parserDeclaration: // parserDeclaration
      case symbol_kind::S_controlDeclaration: // controlDeclaration
      case symbol_kind::S_typeDeclaration: // typeDeclaration
      case symbol_kind::S_derivedTypeDeclaration: // derivedTypeDeclaration
      case symbol_kind::S_headerTypeDeclaration: // headerTypeDeclaration
      case symbol_kind::S_structTypeDeclaration: // structTypeDeclaration
      case symbol_kind::S_headerUnionDeclaration: // headerUnionDeclaration
      case symbol_kind::S_enumDeclaration: // enumDeclaration
      case symbol_kind::S_typedefDeclaration: // typedefDeclaration
        yylhs.value.emplace< IR::Type_Declaration* > ();
        break;

      case symbol_kind::S_errorDeclaration: // errorDeclaration
        yylhs.value.emplace< IR::Type_Error* > ();
        break;

      case symbol_kind::S_typeName: // typeName
        yylhs.value.emplace< IR::Type_Name* > ();
        break;

      case symbol_kind::S_parserTypeDeclaration: // parserTypeDeclaration
        yylhs.value.emplace< IR::Type_Parser* > ();
        break;

      case symbol_kind::S_optAnnotations: // optAnnotations
      case symbol_kind::S_annotations: // annotations
        yylhs.value.emplace< IR::Vector<IR::Annotation>* > ();
        break;

      case symbol_kind::S_annotationBody: // annotationBody
        yylhs.value.emplace< IR::Vector<IR::AnnotationToken>* > ();
        break;

      case symbol_kind::S_argumentList: // argumentList
      case symbol_kind::S_nonEmptyArgList: // nonEmptyArgList
        yylhs.value.emplace< IR::Vector<IR::Argument>* > ();
        break;

      case symbol_kind::S_entriesList: // entriesList
        yylhs.value.emplace< IR::Vector<IR::Entry>* > ();
        break;

      case symbol_kind::S_tupleKeysetExpression: // tupleKeysetExpression
      case symbol_kind::S_simpleExpressionList: // simpleExpressionList
      case symbol_kind::S_expressionList: // expressionList
      case symbol_kind::S_intList: // intList
      case symbol_kind::S_intOrStrList: // intOrStrList
      case symbol_kind::S_strList: // strList
        yylhs.value.emplace< IR::Vector<IR::Expression>* > ();
        break;

      case symbol_kind::S_keyElementList: // keyElementList
        yylhs.value.emplace< IR::Vector<IR::KeyElement>* > ();
        break;

      case symbol_kind::S_methodPrototypes: // methodPrototypes
        yylhs.value.emplace< IR::Vector<IR::Method>* > ();
        break;

      case symbol_kind::S_selectCaseList: // selectCaseList
        yylhs.value.emplace< IR::Vector<IR::SelectCase>* > ();
        break;

      case symbol_kind::S_switchCases: // switchCases
        yylhs.value.emplace< IR::Vector<IR::SwitchCase>* > ();
        break;

      case symbol_kind::S_typeArgumentList: // typeArgumentList
      case symbol_kind::S_realTypeArgumentList: // realTypeArgumentList
        yylhs.value.emplace< IR::Vector<IR::Type>* > ();
        break;

      case symbol_kind::S_optCONST: // optCONST
        yylhs.value.emplace< OptionalConst > ();
        break;

      case symbol_kind::S_UNEXPECTED_TOKEN: // UNEXPECTED_TOKEN
      case symbol_kind::S_END_PRAGMA: // END_PRAGMA
      case symbol_kind::S_LE: // "<="
      case symbol_kind::S_GE: // ">="
      case symbol_kind::S_SHL: // "<<"
      case symbol_kind::S_AND: // "&&"
      case symbol_kind::S_OR: // "||"
      case symbol_kind::S_NE: // "!="
      case symbol_kind::S_EQ: // "=="
      case symbol_kind::S_PLUS: // "+"
      case symbol_kind::S_MINUS: // "-"
      case symbol_kind::S_PLUS_SAT: // "|+|"
      case symbol_kind::S_MINUS_SAT: // "|-|"
      case symbol_kind::S_MUL: // "*"
      case symbol_kind::S_INVALID: // "{#}"
      case symbol_kind::S_DIV: // "/"
      case symbol_kind::S_MOD: // "%"
      case symbol_kind::S_BIT_OR: // "|"
      case symbol_kind::S_BIT_AND: // "&"
      case symbol_kind::S_BIT_XOR: // "^"
      case symbol_kind::S_COMPLEMENT: // "~"
      case symbol_kind::S_L_BRACKET: // "["
      case symbol_kind::S_R_BRACKET: // "]"
      case symbol_kind::S_L_BRACE: // "{"
      case symbol_kind::S_R_BRACE: // "}"
      case symbol_kind::S_L_ANGLE: // "<"
      case symbol_kind::S_L_ANGLE_ARGS: // L_ANGLE_ARGS
      case symbol_kind::S_R_ANGLE: // ">"
      case symbol_kind::S_R_ANGLE_SHIFT: // R_ANGLE_SHIFT
      case symbol_kind::S_L_PAREN: // "("
      case symbol_kind::S_R_PAREN: // ")"
      case symbol_kind::S_NOT: // "!"
      case symbol_kind::S_COLON: // ":"
      case symbol_kind::S_COMMA: // ","
      case symbol_kind::S_QUESTION: // "?"
      case symbol_kind::S_DOT: // "."
      case symbol_kind::S_ASSIGN: // "="
      case symbol_kind::S_ASSIGN_PLUS: // "+="
      case symbol_kind::S_ASSIGN_MINUS: // "-="
      case symbol_kind::S_ASSIGN_MUL: // "*="
      case symbol_kind::S_ASSIGN_DIV: // "/="
      case symbol_kind::S_ASSIGN_MOD: // "%="
      case symbol_kind::S_ASSIGN_BIT_AND: // "&="
      case symbol_kind::S_ASSIGN_BIT_OR: // "|="
      case symbol_kind::S_ASSIGN_XOR: // "^="
      case symbol_kind::S_ASSIGN_SHL: // "<<="
      case symbol_kind::S_ASSIGN_SHR: // ">>="
      case symbol_kind::S_ASSIGN_PLUS_SAT: // "|+|="
      case symbol_kind::S_ASSIGN_MINUS_SAT: // "|-|="
      case symbol_kind::S_SEMICOLON: // ";"
      case symbol_kind::S_AT: // "@"
      case symbol_kind::S_PP: // "++"
      case symbol_kind::S_DONTCARE: // "_"
      case symbol_kind::S_MASK: // "&&&"
      case symbol_kind::S_DOTS: // "..."
      case symbol_kind::S_RANGE: // ".."
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_THIS: // THIS
      case symbol_kind::S_ABSTRACT: // ABSTRACT
      case symbol_kind::S_ACTION: // ACTION
      case symbol_kind::S_ACTIONS: // ACTIONS
      case symbol_kind::S_APPLY: // APPLY
      case symbol_kind::S_BOOL: // BOOL
      case symbol_kind::S_BIT: // BIT
      case symbol_kind::S_BREAK: // BREAK
      case symbol_kind::S_CONST: // CONST
      case symbol_kind::S_CONTINUE: // CONTINUE
      case symbol_kind::S_CONTROL: // CONTROL
      case symbol_kind::S_DEFAULT: // DEFAULT
      case symbol_kind::S_ELSE: // ELSE
      case symbol_kind::S_ENTRIES: // ENTRIES
      case symbol_kind::S_ENUM: // ENUM
      case symbol_kind::S_ERROR: // ERROR
      case symbol_kind::S_EXIT: // EXIT
      case symbol_kind::S_EXTERN: // EXTERN
      case symbol_kind::S_FOR: // FOR
      case symbol_kind::S_HEADER: // HEADER
      case symbol_kind::S_HEADER_UNION: // HEADER_UNION
      case symbol_kind::S_IF: // IF
      case symbol_kind::S_IN: // IN
      case symbol_kind::S_INOUT: // INOUT
      case symbol_kind::S_INT: // INT
      case symbol_kind::S_KEY: // KEY
      case symbol_kind::S_LIST: // LIST
      case symbol_kind::S_SELECT: // SELECT
      case symbol_kind::S_MATCH_KIND: // MATCH_KIND
      case symbol_kind::S_TYPE: // TYPE
      case symbol_kind::S_OUT: // OUT
      case symbol_kind::S_PACKAGE: // PACKAGE
      case symbol_kind::S_PARSER: // PARSER
      case symbol_kind::S_PRAGMA: // PRAGMA
      case symbol_kind::S_PRIORITY: // PRIORITY
      case symbol_kind::S_RETURN: // RETURN
      case symbol_kind::S_STATE: // STATE
      case symbol_kind::S_STRING: // STRING
      case symbol_kind::S_STRUCT: // STRUCT
      case symbol_kind::S_SWITCH: // SWITCH
      case symbol_kind::S_TABLE: // TABLE
      case symbol_kind::S_TRANSITION: // TRANSITION
      case symbol_kind::S_TUPLE: // TUPLE
      case symbol_kind::S_TYPEDEF: // TYPEDEF
      case symbol_kind::S_VARBIT: // VARBIT
      case symbol_kind::S_VALUESET: // VALUESET
      case symbol_kind::S_VOID: // VOID
      case symbol_kind::S_annotationToken: // annotationToken
        yylhs.value.emplace< Token > ();
        break;

      case symbol_kind::S_INTEGER: // INTEGER
        yylhs.value.emplace< UnparsedConstant > ();
        break;

      case symbol_kind::S_IDENTIFIER: // IDENTIFIER
      case symbol_kind::S_TYPE_IDENTIFIER: // TYPE_IDENTIFIER
      case symbol_kind::S_STRING_LITERAL: // STRING_LITERAL
        yylhs.value.emplace< cstring > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // start: fragment END_ANNOTATION
#line 389 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { driver.nodes->push_back(yystack_[1].value.as < IR::Node* > ()->getNode()); YYACCEPT; }
#line 4092 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 4: // fragment: START_EXPRESSION_LIST expressionList
#line 395 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Vector<IR::Expression>* > (); }
#line 4098 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 5: // fragment: START_KV_LIST kvList
#line 396 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::IndexedVector<IR::NamedExpression>* > (); }
#line 4104 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 6: // fragment: START_INTEGER_LIST intList
#line 397 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Vector<IR::Expression>* > (); }
#line 4110 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 7: // fragment: START_INTEGER_OR_STRING_LITERAL_LIST intOrStrList
#line 398 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Vector<IR::Expression>* > (); }
#line 4116 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 8: // fragment: START_STRING_LITERAL_LIST strList
#line 399 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Vector<IR::Expression>* > (); }
#line 4122 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 9: // fragment: START_EXPRESSION expression
#line 402 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 4128 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 10: // fragment: START_INTEGER INTEGER
#line 403 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0); }
#line 4134 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 11: // fragment: START_INTEGER_OR_STRING_LITERAL intOrStr
#line 404 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 4140 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 12: // fragment: START_STRING_LITERAL STRING_LITERAL
#line 405 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::Node* > () = new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4146 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 13: // fragment: START_EXPRESSION_PAIR expression "," expression
#line 409 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(yystack_[2].value.as < IR::Expression* > ());
          result->push_back(yystack_[0].value.as < IR::Expression* > ());
          result->srcInfo = yystack_[2].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4156 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 14: // fragment: START_INTEGER_PAIR INTEGER "," INTEGER
#line 415 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(parseConstant(yystack_[2].location, yystack_[2].value.as < UnparsedConstant > (), 0));
          result->push_back(parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0));
          result->srcInfo = yystack_[2].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4166 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 15: // fragment: START_STRING_LITERAL_PAIR STRING_LITERAL "," STRING_LITERAL
#line 421 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(new IR::StringLiteral(yystack_[2].location, yystack_[2].value.as < cstring > ()));
          result->push_back(new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()));
          result->srcInfo = yystack_[2].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4176 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 16: // fragment: START_EXPRESSION_TRIPLE expression "," expression "," expression
#line 429 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(yystack_[4].value.as < IR::Expression* > ());
          result->push_back(yystack_[2].value.as < IR::Expression* > ());
          result->push_back(yystack_[0].value.as < IR::Expression* > ());
          result->srcInfo = yystack_[4].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4187 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 17: // fragment: START_INTEGER_TRIPLE INTEGER "," INTEGER "," INTEGER
#line 436 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(parseConstant(yystack_[4].location, yystack_[4].value.as < UnparsedConstant > (), 0));
          result->push_back(parseConstant(yystack_[2].location, yystack_[2].value.as < UnparsedConstant > (), 0));
          result->push_back(parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0));
          result->srcInfo = yystack_[4].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4198 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 18: // fragment: START_STRING_LITERAL_TRIPLE STRING_LITERAL "," STRING_LITERAL "," STRING_LITERAL
#line 444 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(new IR::StringLiteral(yystack_[4].location, yystack_[4].value.as < cstring > ()));
          result->push_back(new IR::StringLiteral(yystack_[2].location, yystack_[2].value.as < cstring > ()));
          result->push_back(new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()));
          result->srcInfo = yystack_[4].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4209 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 19: // fragment: START_P4RT_TRANSLATION_ANNOTATION STRING_LITERAL "," p4rtControllerType
#line 453 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto* result = new IR::Vector<IR::Expression>();
          result->push_back(new IR::StringLiteral(yystack_[2].location, yystack_[2].value.as < cstring > ()));
          result->push_back(yystack_[0].value.as < IR::Expression* > ());
          result->srcInfo = yystack_[2].location + yystack_[0].location;
          yylhs.value.as < IR::Node* > () = result; }
#line 4219 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 20: // p4rtControllerType: STRING
#line 466 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::StringLiteral(yystack_[0].location, ""_cs); }
#line 4225 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 21: // p4rtControllerType: BIT l_angle INTEGER r_angle
#line 468 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Constant(parseConstantChecked(yystack_[1].location, yystack_[1].value.as < UnparsedConstant > ())); }
#line 4231 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 22: // p4rtControllerType: INTEGER
#line 471 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Constant(parseConstantChecked(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > ())); }
#line 4237 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 23: // program: input END
#line 474 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                    { YYACCEPT; }
#line 4243 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 25: // input: input declaration
#line 478 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                         { if (yystack_[0].value.as < IR::Node* > ()) driver.nodes->push_back(yystack_[0].value.as < IR::Node* > ()->getNode()); }
#line 4249 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 26: // input: input ";"
#line 479 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                         {}
#line 4255 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 27: // declaration: constantDeclaration
#line 483 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 4261 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 28: // declaration: externDeclaration
#line 484 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Node* > (); }
#line 4267 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 29: // declaration: actionDeclaration
#line 485 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 4273 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 30: // declaration: parserDeclaration
#line 486 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 4279 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 31: // declaration: typeDeclaration
#line 487 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 4285 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 32: // declaration: controlDeclaration
#line 488 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 4291 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 33: // declaration: instantiation
#line 489 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 4297 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 34: // declaration: errorDeclaration
#line 490 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { driver.onReadErrorDeclaration(yystack_[0].value.as < IR::Type_Error* > ()); yylhs.value.as < IR::Node* > () = nullptr; }
#line 4303 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 35: // declaration: matchKindDeclaration
#line 491 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Node* > (); }
#line 4309 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 36: // declaration: functionDeclaration
#line 492 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Node* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 4315 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 37: // nonTypeName: IDENTIFIER
#line 496 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4321 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 38: // nonTypeName: APPLY
#line 497 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "apply"_cs); }
#line 4327 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 39: // nonTypeName: KEY
#line 498 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "key"_cs); }
#line 4333 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 40: // nonTypeName: ACTIONS
#line 499 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "actions"_cs); }
#line 4339 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 41: // nonTypeName: STATE
#line 500 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "state"_cs); }
#line 4345 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 42: // nonTypeName: ENTRIES
#line 501 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "entries"_cs); }
#line 4351 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 43: // nonTypeName: TYPE
#line 502 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "type"_cs); }
#line 4357 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 44: // nonTypeName: PRIORITY
#line 503 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "priority"_cs); }
#line 4363 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 45: // name: nonTypeName
#line 507 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::ID* > () = yystack_[0].value.as < IR::ID* > (); }
#line 4369 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 46: // name: LIST
#line 508 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
           { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "list"_cs); }
#line 4375 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 47: // name: TYPE_IDENTIFIER
#line 509 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4381 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 48: // nonTableKwName: IDENTIFIER
#line 513 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4387 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 49: // nonTableKwName: TYPE_IDENTIFIER
#line 514 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4393 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 50: // nonTableKwName: APPLY
#line 515 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "apply"_cs); }
#line 4399 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 51: // nonTableKwName: STATE
#line 516 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "state"_cs); }
#line 4405 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 52: // nonTableKwName: TYPE
#line 517 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "type"_cs); }
#line 4411 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 53: // nonTableKwName: PRIORITY
#line 518 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "priority"_cs); }
#line 4417 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 54: // optCONST: %empty
#line 522 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < OptionalConst > () = OptionalConst{false}; }
#line 4423 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 55: // optCONST: CONST
#line 523 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < OptionalConst > () = OptionalConst{true}; }
#line 4429 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 56: // optAnnotations: %empty
#line 527 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::Vector<IR::Annotation>* > () = new IR::Vector<IR::Annotation>(); }
#line 4435 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 57: // optAnnotations: annotations
#line 528 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < IR::Vector<IR::Annotation>* > () = yystack_[0].value.as < IR::Vector<IR::Annotation>* > (); }
#line 4441 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 58: // annotations: annotation
#line 532 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  {
       yylhs.value.as < IR::Vector<IR::Annotation>* > () = new IR::Vector<IR::Annotation>();
       if (! P4CContext::get().options().isAnnotationDisabled(yystack_[0].value.as < IR::Annotation* > ())) {
         yylhs.value.as < IR::Vector<IR::Annotation>* > ()->push_back(yystack_[0].value.as < IR::Annotation* > ());
         yylhs.value.as < IR::Vector<IR::Annotation>* > ()->srcInfo = yystack_[0].location;
       }}
#line 4452 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 59: // annotations: annotations annotation
#line 538 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                             {
       yylhs.value.as < IR::Vector<IR::Annotation>* > () = yystack_[1].value.as < IR::Vector<IR::Annotation>* > ();
       if (! P4CContext::get().options().isAnnotationDisabled(yystack_[0].value.as < IR::Annotation* > ())) {
          yylhs.value.as < IR::Vector<IR::Annotation>* > ()->push_back(yystack_[0].value.as < IR::Annotation* > ());
          yylhs.value.as < IR::Vector<IR::Annotation>* > ()->srcInfo = yystack_[1].location + yystack_[0].location;
       }}
#line 4463 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 60: // annotation: "@" annotationName
#line 548 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { // Initialize with an empty sequence of annotation tokens so that the
          // annotation node is marked as unparsed.
          IR::Vector<IR::AnnotationToken> body;
          yylhs.value.as < IR::Annotation* > () = new IR::Annotation(yystack_[1].location, *yystack_[0].value.as < IR::ID* > (), body); }
#line 4472 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 61: // annotation: "@" annotationName "(" annotationBody ")"
#line 553 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Annotation* > () = new IR::Annotation(yystack_[4].location, *yystack_[3].value.as < IR::ID* > (), *yystack_[1].value.as < IR::Vector<IR::AnnotationToken>* > ()); }
#line 4478 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 62: // annotation: "@" annotationName "[" expressionList optTrailingComma "]"
#line 555 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Annotation* > () = new IR::Annotation(yystack_[5].location, *yystack_[4].value.as < IR::ID* > (), *yystack_[2].value.as < IR::Vector<IR::Expression>* > (), true); }
#line 4484 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 63: // annotation: "@" annotationName "[" kvList optTrailingComma "]"
#line 557 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Annotation* > () = new IR::Annotation(yystack_[5].location, *yystack_[4].value.as < IR::ID* > (), *yystack_[2].value.as < IR::IndexedVector<IR::NamedExpression>* > (), true); }
#line 4490 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 64: // annotation: PRAGMA annotationName annotationBody END_PRAGMA
#line 561 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Annotation* > () = new IR::Annotation(yystack_[3].location, *yystack_[2].value.as < IR::ID* > (), *yystack_[1].value.as < IR::Vector<IR::AnnotationToken>* > (), false); }
#line 4496 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 65: // annotationBody: %empty
#line 565 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
              { yylhs.value.as < IR::Vector<IR::AnnotationToken>* > () = new IR::Vector<IR::AnnotationToken>; }
#line 4502 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 66: // annotationBody: annotationBody "(" annotationBody ")"
#line 567 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Vector<IR::AnnotationToken>* > () = yystack_[3].value.as < IR::Vector<IR::AnnotationToken>* > ();
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->push_back(new IR::AnnotationToken(yystack_[2].location, yystack_[2].value.as < Token > ().type, yystack_[2].value.as < Token > ().text));
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->append(*yystack_[1].value.as < IR::Vector<IR::AnnotationToken>* > ());
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->push_back(new IR::AnnotationToken(yystack_[0].location, yystack_[0].value.as < Token > ().type, yystack_[0].value.as < Token > ().text));
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->srcInfo = yystack_[3].location + yystack_[0].location;
        }
#line 4513 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 67: // annotationBody: annotationBody annotationToken
#line 574 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Vector<IR::AnnotationToken>* > () = yystack_[1].value.as < IR::Vector<IR::AnnotationToken>* > ();
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->push_back(new IR::AnnotationToken(yystack_[0].location, yystack_[0].value.as < Token > ().type, yystack_[0].value.as < Token > ().text, yystack_[0].value.as < Token > ().unparsedConstant));
          yylhs.value.as < IR::Vector<IR::AnnotationToken>* > ()->srcInfo = yystack_[1].location + yystack_[0].location;
        }
#line 4522 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 68: // annotationName: ABSTRACT
#line 581 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "abstract"_cs); }
#line 4528 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 69: // annotationName: ACTION
#line 582 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "action"_cs); }
#line 4534 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 70: // annotationName: ACTIONS
#line 583 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "actions"_cs); }
#line 4540 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 71: // annotationName: APPLY
#line 584 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "apply"_cs); }
#line 4546 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 72: // annotationName: BOOL
#line 585 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "bool"_cs); }
#line 4552 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 73: // annotationName: BIT
#line 586 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "bit"_cs); }
#line 4558 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 74: // annotationName: BREAK
#line 587 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "break"_cs); }
#line 4564 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 75: // annotationName: CONST
#line 588 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "const"_cs); }
#line 4570 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 76: // annotationName: CONTINUE
#line 589 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "continue"_cs); }
#line 4576 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 77: // annotationName: CONTROL
#line 590 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "control"_cs); }
#line 4582 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 78: // annotationName: DEFAULT
#line 591 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "default"_cs); }
#line 4588 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 79: // annotationName: ELSE
#line 592 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "else"_cs); }
#line 4594 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 80: // annotationName: ENTRIES
#line 593 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "entries"_cs); }
#line 4600 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 81: // annotationName: ENUM
#line 594 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "enum"_cs); }
#line 4606 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 82: // annotationName: ERROR
#line 595 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "error"_cs); }
#line 4612 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 83: // annotationName: EXIT
#line 596 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "exit"_cs); }
#line 4618 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 84: // annotationName: EXTERN
#line 597 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "extern"_cs); }
#line 4624 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 85: // annotationName: FALSE
#line 598 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "false"_cs); }
#line 4630 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 86: // annotationName: FOR
#line 599 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "for"_cs); }
#line 4636 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 87: // annotationName: HEADER
#line 600 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "header"_cs); }
#line 4642 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 88: // annotationName: HEADER_UNION
#line 601 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "header_union"_cs); }
#line 4648 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 89: // annotationName: IF
#line 602 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "if"_cs); }
#line 4654 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 90: // annotationName: IN
#line 603 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "in"_cs); }
#line 4660 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 91: // annotationName: INOUT
#line 604 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "inout"_cs); }
#line 4666 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 92: // annotationName: INT
#line 605 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "int"_cs); }
#line 4672 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 93: // annotationName: KEY
#line 606 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "key"_cs); }
#line 4678 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 94: // annotationName: MATCH_KIND
#line 607 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "match_kind"_cs); }
#line 4684 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 95: // annotationName: TYPE
#line 608 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "type"_cs); }
#line 4690 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 96: // annotationName: OUT
#line 609 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "out"_cs); }
#line 4696 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 97: // annotationName: PARSER
#line 610 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "parser"_cs); }
#line 4702 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 98: // annotationName: PACKAGE
#line 611 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "package"_cs); }
#line 4708 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 99: // annotationName: PRIORITY
#line 612 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "priority"_cs); }
#line 4714 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 100: // annotationName: RETURN
#line 613 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "return"_cs); }
#line 4720 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 101: // annotationName: SELECT
#line 614 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "select"_cs); }
#line 4726 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 102: // annotationName: STATE
#line 615 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "state"_cs); }
#line 4732 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 103: // annotationName: STRING
#line 616 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "string"_cs); }
#line 4738 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 104: // annotationName: STRUCT
#line 617 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "struct"_cs); }
#line 4744 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 105: // annotationName: SWITCH
#line 618 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "switch"_cs); }
#line 4750 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 106: // annotationName: TABLE
#line 619 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "table"_cs); }
#line 4756 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 107: // annotationName: THIS
#line 620 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "this"_cs); }
#line 4762 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 108: // annotationName: TRANSITION
#line 621 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "transition"_cs); }
#line 4768 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 109: // annotationName: TRUE
#line 622 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "true"_cs); }
#line 4774 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 110: // annotationName: TUPLE
#line 623 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "tuple"_cs); }
#line 4780 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 111: // annotationName: TYPEDEF
#line 624 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "typedef"_cs); }
#line 4786 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 112: // annotationName: VARBIT
#line 625 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "varbit"_cs); }
#line 4792 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 113: // annotationName: VALUESET
#line 626 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "valueset"_cs); }
#line 4798 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 114: // annotationName: LIST
#line 627 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "list"_cs); }
#line 4804 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 115: // annotationName: VOID
#line 628 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "void"_cs); }
#line 4810 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 116: // annotationName: "_"
#line 629 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, "_"_cs); }
#line 4816 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 117: // annotationName: IDENTIFIER
#line 630 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4822 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 118: // annotationName: TYPE_IDENTIFIER
#line 631 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::ID* > () = new IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 4828 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 119: // annotationToken: UNEXPECTED_TOKEN
#line 635 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4834 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 120: // annotationToken: ABSTRACT
#line 636 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4840 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 121: // annotationToken: ACTION
#line 637 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4846 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 122: // annotationToken: ACTIONS
#line 638 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4852 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 123: // annotationToken: APPLY
#line 639 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4858 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 124: // annotationToken: BOOL
#line 640 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4864 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 125: // annotationToken: BIT
#line 641 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4870 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 126: // annotationToken: BREAK
#line 642 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4876 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 127: // annotationToken: CONST
#line 643 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4882 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 128: // annotationToken: CONTINUE
#line 644 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4888 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 129: // annotationToken: CONTROL
#line 645 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4894 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 130: // annotationToken: DEFAULT
#line 646 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4900 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 131: // annotationToken: ELSE
#line 647 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4906 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 132: // annotationToken: ENTRIES
#line 648 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4912 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 133: // annotationToken: ENUM
#line 649 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4918 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 134: // annotationToken: ERROR
#line 650 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4924 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 135: // annotationToken: EXIT
#line 651 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4930 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 136: // annotationToken: EXTERN
#line 652 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4936 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 137: // annotationToken: FALSE
#line 653 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4942 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 138: // annotationToken: FOR
#line 654 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4948 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 139: // annotationToken: HEADER
#line 655 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4954 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 140: // annotationToken: HEADER_UNION
#line 656 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4960 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 141: // annotationToken: IF
#line 657 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4966 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 142: // annotationToken: IN
#line 658 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4972 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 143: // annotationToken: INOUT
#line 659 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4978 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 144: // annotationToken: INT
#line 660 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4984 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 145: // annotationToken: KEY
#line 661 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4990 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 146: // annotationToken: MATCH_KIND
#line 662 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 4996 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 147: // annotationToken: TYPE
#line 663 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5002 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 148: // annotationToken: OUT
#line 664 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5008 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 149: // annotationToken: PARSER
#line 665 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5014 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 150: // annotationToken: PACKAGE
#line 666 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5020 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 151: // annotationToken: PRAGMA
#line 667 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5026 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 152: // annotationToken: RETURN
#line 668 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5032 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 153: // annotationToken: SELECT
#line 669 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5038 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 154: // annotationToken: STATE
#line 670 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5044 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 155: // annotationToken: STRING
#line 671 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5050 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 156: // annotationToken: STRUCT
#line 672 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5056 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 157: // annotationToken: SWITCH
#line 673 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5062 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 158: // annotationToken: TABLE
#line 674 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5068 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 159: // annotationToken: THIS
#line 675 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5074 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 160: // annotationToken: TRANSITION
#line 676 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5080 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 161: // annotationToken: TRUE
#line 677 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5086 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 162: // annotationToken: TUPLE
#line 678 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5092 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 163: // annotationToken: TYPEDEF
#line 679 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5098 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 164: // annotationToken: VARBIT
#line 680 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5104 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 165: // annotationToken: VALUESET
#line 681 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5110 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 166: // annotationToken: LIST
#line 682 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5116 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 167: // annotationToken: VOID
#line 683 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5122 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 168: // annotationToken: "_"
#line 684 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5128 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 169: // annotationToken: IDENTIFIER
#line 686 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = Token(token::TOK_IDENTIFIER, yystack_[0].value.as < cstring > ()); }
#line 5134 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 170: // annotationToken: TYPE_IDENTIFIER
#line 687 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = Token(token::TOK_TYPE_IDENTIFIER, yystack_[0].value.as < cstring > ()); }
#line 5140 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 171: // annotationToken: STRING_LITERAL
#line 688 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = Token(token::TOK_STRING_LITERAL, yystack_[0].value.as < cstring > ()); }
#line 5146 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 172: // annotationToken: INTEGER
#line 689 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = Token(token::TOK_INTEGER, yystack_[0].value.as < UnparsedConstant > ()); }
#line 5152 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 173: // annotationToken: "&&&"
#line 691 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5158 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 174: // annotationToken: ".."
#line 692 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5164 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 175: // annotationToken: "<<"
#line 693 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5170 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 176: // annotationToken: "&&"
#line 694 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5176 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 177: // annotationToken: "||"
#line 695 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5182 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 178: // annotationToken: "=="
#line 696 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5188 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 179: // annotationToken: "!="
#line 697 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5194 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 180: // annotationToken: ">="
#line 698 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5200 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 181: // annotationToken: "<="
#line 699 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5206 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 182: // annotationToken: "++"
#line 700 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5212 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 183: // annotationToken: "+"
#line 702 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5218 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 184: // annotationToken: "|+|"
#line 703 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5224 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 185: // annotationToken: "-"
#line 704 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5230 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 186: // annotationToken: "|-|"
#line 705 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5236 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 187: // annotationToken: "*"
#line 706 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5242 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 188: // annotationToken: "/"
#line 707 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5248 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 189: // annotationToken: "%"
#line 708 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5254 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 190: // annotationToken: "|"
#line 710 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5260 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 191: // annotationToken: "&"
#line 711 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5266 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 192: // annotationToken: "^"
#line 712 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5272 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 193: // annotationToken: "~"
#line 713 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5278 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 194: // annotationToken: "["
#line 720 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5284 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 195: // annotationToken: "]"
#line 721 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5290 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 196: // annotationToken: "{"
#line 722 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5296 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 197: // annotationToken: "}"
#line 723 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5302 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 198: // annotationToken: "<"
#line 724 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5308 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 199: // annotationToken: L_ANGLE_ARGS
#line 725 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5314 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 200: // annotationToken: ">"
#line 726 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5320 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 201: // annotationToken: R_ANGLE_SHIFT
#line 727 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5326 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 202: // annotationToken: "!"
#line 729 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5332 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 203: // annotationToken: ":"
#line 730 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5338 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 204: // annotationToken: ","
#line 731 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5344 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 205: // annotationToken: "?"
#line 732 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5350 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 206: // annotationToken: "."
#line 733 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5356 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 207: // annotationToken: "="
#line 734 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5362 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 208: // annotationToken: ";"
#line 735 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5368 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 209: // annotationToken: "@"
#line 736 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < Token > () = yystack_[0].value.as < Token > (); }
#line 5374 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 210: // kvList: kvPair
#line 740 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                        { yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > () = new IR::IndexedVector<IR::NamedExpression>; yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > ()->push_back(yystack_[0].value.as < IR::NamedExpression* > ()); yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > ()->srcInfo = yystack_[0].location; }
#line 5380 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 211: // kvList: kvList "," kvPair
#line 741 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                        { yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > () = yystack_[2].value.as < IR::IndexedVector<IR::NamedExpression>* > (); yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > ()->push_back(yystack_[0].value.as < IR::NamedExpression* > ()); yylhs.value.as < IR::IndexedVector<IR::NamedExpression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location;}
#line 5386 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 212: // kvPair: name "=" expression
#line 745 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::NamedExpression* > () = new IR::NamedExpression(yystack_[2].location, *yystack_[2].value.as < IR::ID* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5392 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 213: // parameterList: %empty
#line 749 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = new IR::IndexedVector<IR::Parameter>(); }
#line 5398 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 214: // parameterList: nonEmptyParameterList
#line 750 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = yystack_[0].value.as < IR::IndexedVector<IR::Parameter>* > (); }
#line 5404 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 215: // nonEmptyParameterList: parameter
#line 754 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = new IR::IndexedVector<IR::Parameter>();
                                            yylhs.value.as < IR::IndexedVector<IR::Parameter>* > ()->push_back(yystack_[0].value.as < IR::Parameter* > ()); yylhs.value.as < IR::IndexedVector<IR::Parameter>* > ()->srcInfo = yystack_[0].location; }
#line 5411 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 216: // nonEmptyParameterList: nonEmptyParameterList "," parameter
#line 756 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = yystack_[2].value.as < IR::IndexedVector<IR::Parameter>* > (); yylhs.value.as < IR::IndexedVector<IR::Parameter>* > ()->push_back(yystack_[0].value.as < IR::Parameter* > ()); yylhs.value.as < IR::IndexedVector<IR::Parameter>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 5417 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 217: // parameter: optAnnotations direction typeRef name
#line 760 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { yylhs.value.as < IR::Parameter* > () = new IR::Parameter(yystack_[0].location, *yystack_[0].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[2].value.as < IR::Direction > (), yystack_[1].value.as < ConstType* > (), nullptr); }
#line 5423 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 218: // parameter: optAnnotations direction typeRef name "=" expression
#line 761 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                           { yylhs.value.as < IR::Parameter* > () = new IR::Parameter(yystack_[2].location, *yystack_[2].value.as < IR::ID* > (), *yystack_[5].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::Direction > (), yystack_[3].value.as < ConstType* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5429 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 219: // direction: IN
#line 765 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                   { yylhs.value.as < IR::Direction > () = IR::Direction::In; }
#line 5435 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 220: // direction: OUT
#line 766 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                   { yylhs.value.as < IR::Direction > () = IR::Direction::Out; }
#line 5441 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 221: // direction: INOUT
#line 767 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                   { yylhs.value.as < IR::Direction > () = IR::Direction::InOut; }
#line 5447 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 222: // direction: %empty
#line 768 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                   { yylhs.value.as < IR::Direction > () = IR::Direction::None; }
#line 5453 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 223: // $@1: %empty
#line 772 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), false); }
#line 5459 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 224: // $@2: %empty
#line 773 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                        {
          if (!yystack_[0].value.as < IR::TypeParameters* > ()->empty()) driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
          driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 5467 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 225: // packageTypeDeclaration: optAnnotations PACKAGE name $@1 optTypeParameters $@2 "(" parameterList ")"
#line 776 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                   {
          driver.structure->declareParameters(yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
          auto pl = new IR::ParameterList(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
          yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Package(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), pl); }
#line 5476 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 226: // instantiation: annotations typeRef "(" argumentList ")" name ";"
#line 784 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Instance(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[6].value.as < IR::Vector<IR::Annotation>* > (),
                                                         yystack_[5].value.as < ConstType* > (), yystack_[3].value.as < IR::Vector<IR::Argument>* > ());
                       driver.structure->declareObject(*yystack_[1].value.as < IR::ID* > (), yystack_[5].value.as < ConstType* > ()->toString()); }
#line 5484 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 227: // instantiation: typeRef "(" argumentList ")" name ";"
#line 788 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Instance(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), yystack_[5].value.as < ConstType* > (), yystack_[3].value.as < IR::Vector<IR::Argument>* > ());
                       driver.structure->declareObject(*yystack_[1].value.as < IR::ID* > (), yystack_[5].value.as < ConstType* > ()->toString()); }
#line 5491 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 228: // instantiation: annotations typeRef "(" argumentList ")" name "=" objInitializer ";"
#line 791 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Instance(yystack_[3].location, *yystack_[3].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (),
                                                         yystack_[7].value.as < ConstType* > (), yystack_[5].value.as < IR::Vector<IR::Argument>* > (), yystack_[1].value.as < IR::BlockStatement* > ());
                       driver.structure->declareObject(*yystack_[3].value.as < IR::ID* > (), yystack_[7].value.as < ConstType* > ()->toString()); }
#line 5499 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 229: // instantiation: typeRef "(" argumentList ")" name "=" objInitializer ";"
#line 795 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Instance(yystack_[3].location, *yystack_[3].value.as < IR::ID* > (), yystack_[7].value.as < ConstType* > (), yystack_[5].value.as < IR::Vector<IR::Argument>* > (), yystack_[1].value.as < IR::BlockStatement* > ());
                       driver.structure->declareObject(*yystack_[3].value.as < IR::ID* > (), yystack_[7].value.as < ConstType* > ()->toString()); }
#line 5506 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 230: // $@3: %empty
#line 800 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
          { driver.structure->pushNamespace(yystack_[0].location, false); }
#line 5512 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 231: // objInitializer: "{" $@3 objDeclarations "}"
#line 801 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { driver.structure->pop();
                                 yylhs.value.as < IR::BlockStatement* > () = new IR::BlockStatement(yystack_[3].location+yystack_[0].location, *yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > ()); }
#line 5519 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 232: // objDeclarations: %empty
#line 806 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(); }
#line 5525 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 233: // objDeclarations: objDeclarations objDeclaration
#line 807 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > (); yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->push_back(yystack_[0].value.as < IR::Declaration* > ()); yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->srcInfo = yystack_[1].location + yystack_[0].location;}
#line 5531 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 234: // objDeclaration: functionDeclaration
#line 811 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5537 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 235: // objDeclaration: instantiation
#line 812 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5543 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 236: // optConstructorParameters: %empty
#line 816 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                             { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = new IR::IndexedVector<IR::Parameter>(); }
#line 5549 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 237: // optConstructorParameters: "(" parameterList ")"
#line 817 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                             { yylhs.value.as < IR::IndexedVector<IR::Parameter>* > () = yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > (); }
#line 5555 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 238: // dotPrefix: "."
#line 821 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { driver.structure->startAbsolutePath(); }
#line 5561 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 239: // parserDeclaration: parserTypeDeclaration optConstructorParameters "{" parserLocalElements parserStates "}"
#line 829 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                             { driver.structure->pop();
                               auto pl = new IR::ParameterList(yystack_[4].location, *yystack_[4].value.as < IR::IndexedVector<IR::Parameter>* > ());
                               yylhs.value.as < IR::Type_Declaration* > () = new IR::P4Parser(yystack_[5].value.as < IR::Type_Parser* > ()->name.srcInfo, yystack_[5].value.as < IR::Type_Parser* > ()->name,
                                                     yystack_[5].value.as < IR::Type_Parser* > (), pl, *yystack_[2].value.as < IR::IndexedVector<IR::Declaration>* > (), *yystack_[1].value.as < IR::IndexedVector<IR::ParserState>* > ());}
#line 5570 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 240: // parserLocalElements: %empty
#line 836 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                             { yylhs.value.as < IR::IndexedVector<IR::Declaration>* > () = new IR::IndexedVector<IR::Declaration>(); }
#line 5576 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 241: // parserLocalElements: parserLocalElements parserLocalElement
#line 837 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                             { yylhs.value.as < IR::IndexedVector<IR::Declaration>* > () = yystack_[1].value.as < IR::IndexedVector<IR::Declaration>* > (); yylhs.value.as < IR::IndexedVector<IR::Declaration>* > ()->push_back(yystack_[0].value.as < IR::Declaration* > ()); yylhs.value.as < IR::IndexedVector<IR::Declaration>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 5582 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 242: // parserLocalElement: constantDeclaration
#line 841 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5588 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 243: // parserLocalElement: instantiation
#line 842 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5594 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 244: // parserLocalElement: variableDeclaration
#line 843 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5600 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 245: // parserLocalElement: valueSetDeclaration
#line 844 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5606 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 246: // $@4: %empty
#line 849 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                          { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 5612 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 247: // $@5: %empty
#line 850 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                          { if (!yystack_[0].value.as < IR::TypeParameters* > ()->empty()) driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
                            driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 5619 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 248: // parserTypeDeclaration: optAnnotations PARSER name $@4 optTypeParameters $@5 "(" parameterList ")"
#line 852 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { driver.structure->declareParameters(yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                auto pl = new IR::ParameterList(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                yylhs.value.as < IR::Type_Parser* > () = new IR::Type_Parser(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), pl); }
#line 5627 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 249: // parserStates: parserState
#line 858 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::IndexedVector<IR::ParserState>* > () = new IR::IndexedVector<IR::ParserState>();
                                        yylhs.value.as < IR::IndexedVector<IR::ParserState>* > ()->push_back(yystack_[0].value.as < IR::ParserState* > ()); yylhs.value.as < IR::IndexedVector<IR::ParserState>* > ()->srcInfo = yystack_[0].location; }
#line 5634 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 250: // parserStates: parserStates parserState
#line 860 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::IndexedVector<IR::ParserState>* > () = yystack_[1].value.as < IR::IndexedVector<IR::ParserState>* > (); yylhs.value.as < IR::IndexedVector<IR::ParserState>* > ()->push_back(yystack_[0].value.as < IR::ParserState* > ()); yylhs.value.as < IR::IndexedVector<IR::ParserState>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 5640 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 251: // $@6: %empty
#line 864 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), false); }
#line 5646 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 252: // parserState: optAnnotations STATE name $@6 "{" parserStatements transitionStatement "}"
#line 866 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { driver.structure->pop();
                                        yylhs.value.as < IR::ParserState* > () = new IR::ParserState(yystack_[5].location, *yystack_[5].value.as < IR::ID* > (), *yystack_[7].value.as < IR::Vector<IR::Annotation>* > (), *yystack_[2].value.as < IR::IndexedVector<IR::StatOrDecl>* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 5653 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 253: // parserStatements: %empty
#line 871 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(); }
#line 5659 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 254: // parserStatements: parserStatements parserStatement
#line 872 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > (); yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->push_back(yystack_[0].value.as < IR::StatOrDecl* > ()); yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 5665 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 255: // parserStatement: assignmentOrMethodCallStatement
#line 876 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 5671 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 256: // parserStatement: directApplication
#line 877 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 5677 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 257: // parserStatement: emptyStatement
#line 878 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 5683 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 258: // parserStatement: variableDeclaration
#line 879 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5689 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 259: // parserStatement: constantDeclaration
#line 880 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5695 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 260: // parserStatement: parserBlockStatement
#line 881 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::BlockStatement* > (); }
#line 5701 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 261: // parserStatement: conditionalStatement
#line 882 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                      { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 5707 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 262: // $@7: %empty
#line 886 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                         { driver.structure->pushNamespace(yystack_[0].location, false); }
#line 5713 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 263: // parserBlockStatement: optAnnotations "{" $@7 parserStatements "}"
#line 887 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                           { driver.structure->pop(); yylhs.value.as < IR::BlockStatement* > () = new IR::BlockStatement(yystack_[4].location+yystack_[0].location, *yystack_[4].value.as < IR::Vector<IR::Annotation>* > (), *yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > ()); }
#line 5719 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 264: // transitionStatement: %empty
#line 891 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = nullptr; }
#line 5725 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 265: // transitionStatement: TRANSITION stateExpression
#line 892 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 5731 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 266: // stateExpression: name ";"
#line 896 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::Expression* > () = new IR::PathExpression(*yystack_[1].value.as < IR::ID* > ()); }
#line 5737 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 267: // stateExpression: selectExpression
#line 897 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                       { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 5743 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 268: // selectExpression: SELECT "(" expressionList ")" "{" selectCaseList "}"
#line 902 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Expression* > () = new IR::SelectExpression(yystack_[6].location + yystack_[0].location,
                                     new IR::ListExpression(yystack_[4].location, *yystack_[4].value.as < IR::Vector<IR::Expression>* > ()), std::move(*yystack_[1].value.as < IR::Vector<IR::SelectCase>* > ())); }
#line 5750 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 269: // selectCaseList: %empty
#line 907 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::SelectCase>* > () = new IR::Vector<IR::SelectCase>(); }
#line 5756 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 270: // selectCaseList: selectCaseList selectCase
#line 908 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::SelectCase>* > () = yystack_[1].value.as < IR::Vector<IR::SelectCase>* > (); yylhs.value.as < IR::Vector<IR::SelectCase>* > ()->push_back(yystack_[0].value.as < IR::SelectCase* > ()); yylhs.value.as < IR::Vector<IR::SelectCase>* > ()->srcInfo = yystack_[1].location + yystack_[0].location;}
#line 5762 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 271: // selectCase: keysetExpression ":" name ";"
#line 913 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { auto expr = new IR::PathExpression(*yystack_[1].value.as < IR::ID* > ());
        yylhs.value.as < IR::SelectCase* > () = new IR::SelectCase(yystack_[3].location + yystack_[1].location, yystack_[3].value.as < IR::Expression* > (), expr); }
#line 5769 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 272: // keysetExpression: tupleKeysetExpression
#line 918 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::Expression* > () = new IR::ListExpression(yystack_[0].location, *yystack_[0].value.as < IR::Vector<IR::Expression>* > ()); }
#line 5775 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 273: // keysetExpression: simpleKeysetExpression
#line 919 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 5781 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 274: // tupleKeysetExpression: "(" simpleKeysetExpression "," simpleExpressionList ")"
#line 924 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[1].value.as < IR::Vector<IR::Expression>* > (); yystack_[1].value.as < IR::Vector<IR::Expression>* > ()->insert(yystack_[1].value.as < IR::Vector<IR::Expression>* > ()->begin(), yystack_[3].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[3].location + yystack_[1].location; }
#line 5787 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 275: // tupleKeysetExpression: "(" reducedSimpleKeysetExpression ")"
#line 925 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>(); yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[1].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[1].location; }
#line 5793 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 278: // simpleExpressionList: simpleKeysetExpression
#line 934 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                             { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>(); yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[0].location; }
#line 5799 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 279: // simpleExpressionList: simpleExpressionList "," simpleKeysetExpression
#line 935 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                      { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[2].value.as < IR::Vector<IR::Expression>* > (); yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 5805 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 280: // reducedSimpleKeysetExpression: expression "&&&" expression
#line 940 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::Mask(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5811 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 281: // reducedSimpleKeysetExpression: expression ".." expression
#line 941 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::Range(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5817 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 282: // reducedSimpleKeysetExpression: DEFAULT
#line 942 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::DefaultExpression(yystack_[0].location); }
#line 5823 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 283: // reducedSimpleKeysetExpression: "_"
#line 943 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::DefaultExpression(yystack_[0].location); }
#line 5829 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 284: // simpleKeysetExpression: expression
#line 947 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 5835 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 285: // simpleKeysetExpression: expression "&&&" expression
#line 948 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::Mask(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5841 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 286: // simpleKeysetExpression: expression ".." expression
#line 949 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::Range(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 5847 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 287: // simpleKeysetExpression: DEFAULT
#line 950 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::DefaultExpression(yystack_[0].location); }
#line 5853 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 288: // simpleKeysetExpression: "_"
#line 951 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < IR::Expression* > () = new IR::DefaultExpression(yystack_[0].location); }
#line 5859 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 289: // valueSetDeclaration: optAnnotations VALUESET l_angle baseType r_angle "(" expression ")" name ";"
#line 957 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Declaration* > () = new IR::P4ValueSet(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[9].value.as < IR::Vector<IR::Annotation>* > (), yystack_[6].value.as < ConstType* > (), yystack_[3].value.as < IR::Expression* > ()); }
#line 5865 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 290: // valueSetDeclaration: optAnnotations VALUESET l_angle tupleType r_angle "(" expression ")" name ";"
#line 960 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Declaration* > () = new IR::P4ValueSet(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[9].value.as < IR::Vector<IR::Annotation>* > (), yystack_[6].value.as < ConstType* > (), yystack_[3].value.as < IR::Expression* > ()); }
#line 5871 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 291: // valueSetDeclaration: optAnnotations VALUESET l_angle typeName r_angle "(" expression ")" name ";"
#line 963 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Declaration* > () = new IR::P4ValueSet(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[9].value.as < IR::Vector<IR::Annotation>* > (), yystack_[6].value.as < IR::Type_Name* > (), yystack_[3].value.as < IR::Expression* > ()); }
#line 5877 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 292: // controlDeclaration: controlTypeDeclaration optConstructorParameters "{" controlLocalDeclarations APPLY controlBody "}"
#line 971 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { driver.structure->pop();
          auto pl = new IR::ParameterList(yystack_[5].location, *yystack_[5].value.as < IR::IndexedVector<IR::Parameter>* > ());
          yylhs.value.as < IR::Type_Declaration* > () = new IR::P4Control(yystack_[6].value.as < IR::Type_Control* > ()->name.srcInfo, yystack_[6].value.as < IR::Type_Control* > ()->name, yystack_[6].value.as < IR::Type_Control* > (), pl, *yystack_[3].value.as < IR::IndexedVector<IR::Declaration>* > (), yystack_[1].value.as < IR::BlockStatement* > ()); }
#line 5885 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 293: // $@8: %empty
#line 978 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 5891 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 294: // $@9: %empty
#line 979 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                          { if (!yystack_[0].value.as < IR::TypeParameters* > ()->empty()) driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
                            driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 5898 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 295: // controlTypeDeclaration: optAnnotations CONTROL name $@8 optTypeParameters $@9 "(" parameterList ")"
#line 981 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { driver.structure->declareParameters(yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                auto pl = new IR::ParameterList(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                yylhs.value.as < IR::Type_Control* > () = new IR::Type_Control(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), pl); }
#line 5906 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 296: // controlLocalDeclarations: %empty
#line 987 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < IR::IndexedVector<IR::Declaration>* > () = new IR::IndexedVector<IR::Declaration>(); }
#line 5912 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 297: // controlLocalDeclarations: controlLocalDeclarations controlLocalDeclaration
#line 988 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                       { yylhs.value.as < IR::IndexedVector<IR::Declaration>* > () = yystack_[1].value.as < IR::IndexedVector<IR::Declaration>* > (); yylhs.value.as < IR::IndexedVector<IR::Declaration>* > ()->push_back(yystack_[0].value.as < IR::Declaration* > ()); yylhs.value.as < IR::IndexedVector<IR::Declaration>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 5918 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 298: // controlLocalDeclaration: constantDeclaration
#line 992 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5924 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 299: // controlLocalDeclaration: actionDeclaration
#line 993 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5930 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 300: // controlLocalDeclaration: tableDeclaration
#line 994 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5936 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 301: // controlLocalDeclaration: instantiation
#line 995 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5942 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 302: // controlLocalDeclaration: variableDeclaration
#line 996 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Declaration* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 5948 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 303: // controlBody: blockStatement
#line 1000 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                     { yylhs.value.as < IR::BlockStatement* > () = yystack_[0].value.as < IR::BlockStatement* > (); }
#line 5954 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 304: // $@10: %empty
#line 1007 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                           { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 5960 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 305: // $@11: %empty
#line 1008 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                          { if (!yystack_[0].value.as < IR::TypeParameters* > ()->empty()) driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
                            driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 5967 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 306: // externDeclaration: optAnnotations EXTERN nonTypeName $@10 optTypeParameters $@11 "{" methodPrototypes "}"
#line 1010 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { driver.structure->pop();
                                   yylhs.value.as < IR::Node* > () = new IR::Type_Extern(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), yystack_[4].value.as < IR::TypeParameters* > (), *yystack_[1].value.as < IR::Vector<IR::Method>* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > ()); }
#line 5974 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 307: // externDeclaration: optAnnotations EXTERN functionPrototype ";"
#line 1012 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                  {
            driver.structure->pop();
            yylhs.value.as < IR::Node* > () = yystack_[1].value.as < IR::Method* > ();
            yystack_[1].value.as < IR::Method* > ()->annotations = *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (); }
#line 5983 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 308: // externDeclaration: optAnnotations EXTERN name ";"
#line 1016 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     {
            // forward declaration;
            driver.structure->pushContainerType(*yystack_[1].value.as < IR::ID* > (), true);
            driver.structure->pop();
            yylhs.value.as < IR::Node* > () = nullptr; }
#line 5993 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 309: // methodPrototypes: %empty
#line 1024 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Vector<IR::Method>* > () = new IR::Vector<IR::Method>(); }
#line 5999 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 310: // methodPrototypes: methodPrototypes methodPrototype
#line 1025 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Vector<IR::Method>* > () = yystack_[1].value.as < IR::Vector<IR::Method>* > (); yystack_[1].value.as < IR::Vector<IR::Method>* > ()->push_back(yystack_[0].value.as < IR::Method* > ()); yylhs.value.as < IR::Vector<IR::Method>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 6005 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 311: // $@12: %empty
#line 1030 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               {
            driver.structure->declareObject(*yystack_[1].value.as < IR::ID* > (), yystack_[2].value.as < ConstType* > ()->toString());
            if (!yystack_[0].value.as < IR::TypeParameters* > ()->empty()) driver.structure->markAsTemplate(*yystack_[1].value.as < IR::ID* > ());
            driver.structure->pushNamespace(yystack_[1].location, false);
            driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 6015 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 312: // functionPrototype: typeOrVoid name optTypeParameters $@12 "(" parameterList ")"
#line 1035 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { driver.structure->declareParameters(yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                auto params = new IR::ParameterList(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                auto mt = new IR::Type_Method(yystack_[5].location, yystack_[4].value.as < IR::TypeParameters* > (), yystack_[6].value.as < ConstType* > (), params, *yystack_[5].value.as < IR::ID* > ());
                                yylhs.value.as < IR::Method* > () = new IR::Method(yystack_[5].location, *yystack_[5].value.as < IR::ID* > (), mt); }
#line 6024 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 313: // methodPrototype: optAnnotations functionPrototype ";"
#line 1042 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                           {
            driver.structure->pop();
            yylhs.value.as < IR::Method* > () = yystack_[1].value.as < IR::Method* > (); yystack_[1].value.as < IR::Method* > ()->annotations = *yystack_[2].value.as < IR::Vector<IR::Annotation>* > (); }
#line 6032 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 314: // methodPrototype: optAnnotations ABSTRACT functionPrototype ";"
#line 1045 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                    {
            driver.structure->pop();
            yylhs.value.as < IR::Method* > () = yystack_[1].value.as < IR::Method* > (); yylhs.value.as < IR::Method* > ()->setAbstract();
            yystack_[1].value.as < IR::Method* > ()->annotations = *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (); }
#line 6041 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 315: // methodPrototype: optAnnotations TYPE_IDENTIFIER "(" parameterList ")" ";"
#line 1050 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { auto par = new IR::ParameterList(yystack_[2].location, *yystack_[2].value.as < IR::IndexedVector<IR::Parameter>* > ());
                                          auto mt = new IR::Type_Method(yystack_[4].location, par, yystack_[4].value.as < cstring > ());
                                          yylhs.value.as < IR::Method* > () = new IR::Method(yystack_[4].location, IR::ID(yystack_[4].location, yystack_[4].value.as < cstring > ()), mt, *yystack_[5].value.as < IR::Vector<IR::Annotation>* > ()); }
#line 6049 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 316: // typeRef: baseType
#line 1058 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6055 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 317: // typeRef: typeName
#line 1059 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < IR::Type_Name* > (); }
#line 6061 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 318: // typeRef: specializedType
#line 1060 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6067 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 319: // typeRef: headerStackType
#line 1061 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6073 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 320: // typeRef: p4listType
#line 1062 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6079 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 321: // typeRef: tupleType
#line 1063 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6085 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 322: // namedType: typeName
#line 1067 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < IR::Type_Name* > (); }
#line 6091 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 323: // namedType: specializedType
#line 1068 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6097 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 324: // prefixedType: TYPE_IDENTIFIER
#line 1072 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Path* > () = new IR::Path(IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ())); }
#line 6103 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 325: // prefixedType: dotPrefix TYPE_IDENTIFIER
#line 1073 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Path* > () = new IR::Path(IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()), true);
                                         driver.structure->clearPath(); }
#line 6110 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 326: // typeName: prefixedType
#line 1078 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Type_Name* > () = new IR::Type_Name(yystack_[0].location, yystack_[0].value.as < IR::Path* > ()); }
#line 6116 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 327: // p4listType: LIST l_angle typeArg r_angle
#line 1082 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < ConstType* > () = new IR::Type_P4List(yystack_[3].location+yystack_[0].location, yystack_[1].value.as < ConstType* > ()); }
#line 6122 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 328: // tupleType: TUPLE l_angle typeArgumentList r_angle
#line 1086 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                { yylhs.value.as < ConstType* > () = new IR::Type_Tuple(yystack_[3].location+yystack_[0].location, *yystack_[1].value.as < IR::Vector<IR::Type>* > ()); }
#line 6128 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 329: // headerStackType: typeName "[" expression "]"
#line 1090 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < ConstType* > () = new IR::Type_Stack(yystack_[3].location+yystack_[0].location, yystack_[3].value.as < IR::Type_Name* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 6134 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 330: // headerStackType: specializedType "[" expression "]"
#line 1091 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < ConstType* > () = new IR::Type_Stack(yystack_[3].location+yystack_[0].location, yystack_[3].value.as < ConstType* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 6140 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 331: // specializedType: typeName l_angle typeArgumentList r_angle
#line 1095 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                { yylhs.value.as < ConstType* > () = new IR::Type_Specialized(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Type_Name* > (), yystack_[1].value.as < IR::Vector<IR::Type>* > ()); }
#line 6146 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 332: // baseType: BOOL
#line 1099 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < ConstType* > () = IR::Type_Boolean::get(yystack_[0].location); }
#line 6152 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 333: // baseType: MATCH_KIND
#line 1100 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                 { yylhs.value.as < ConstType* > () = IR::Type_MatchKind::get(yystack_[0].location); }
#line 6158 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 334: // baseType: ERROR
#line 1101 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < ConstType* > () = new IR::Type_Name(yystack_[0].location, new IR::Path(IR::ID(yystack_[0].location, "error"_cs))); }
#line 6164 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 335: // baseType: BIT
#line 1102 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < ConstType* > () = IR::Type::Bits::get(yystack_[0].location, 1); }
#line 6170 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 336: // baseType: STRING
#line 1103 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < ConstType* > () = IR::Type::String::get(yystack_[0].location); }
#line 6176 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 337: // baseType: INT
#line 1104 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < ConstType* > () = IR::Type_InfInt::get(yystack_[0].location); }
#line 6182 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 338: // baseType: BIT l_angle INTEGER r_angle
#line 1106 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type::Bits::get(yystack_[3].location+yystack_[0].location, parseConstantChecked(yystack_[1].location, yystack_[1].value.as < UnparsedConstant > ()), false); }
#line 6188 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 339: // baseType: INT l_angle INTEGER r_angle
#line 1108 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type::Bits::get(yystack_[3].location+yystack_[0].location, parseConstantChecked(yystack_[1].location, yystack_[1].value.as < UnparsedConstant > ()), true); }
#line 6194 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 340: // baseType: VARBIT l_angle INTEGER r_angle
#line 1110 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type::Varbits::get(yystack_[3].location+yystack_[0].location, parseConstantChecked(yystack_[1].location, yystack_[1].value.as < UnparsedConstant > ())); }
#line 6200 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 341: // baseType: BIT l_angle "(" expression ")" r_angle
#line 1113 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type_Bits::get(yystack_[5].location+yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), false); }
#line 6206 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 342: // baseType: INT l_angle "(" expression ")" r_angle
#line 1115 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type_Bits::get(yystack_[5].location+yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), true); }
#line 6212 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 343: // baseType: VARBIT l_angle "(" expression ")" r_angle
#line 1117 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
      { yylhs.value.as < ConstType* > () = IR::Type_Varbits::get(yystack_[5].location+yystack_[0].location, yystack_[2].value.as < IR::Expression* > ()); }
#line 6218 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 344: // typeOrVoid: typeRef
#line 1121 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6224 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 345: // typeOrVoid: VOID
#line 1122 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < ConstType* > () = IR::Type_Void::get(yystack_[0].location); }
#line 6230 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 346: // typeOrVoid: IDENTIFIER
#line 1123 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { yylhs.value.as < ConstType* > () = new IR::Type_Name(yystack_[0].location, new IR::Path(IR::ID(yystack_[0].location, yystack_[0].value.as < cstring > ()))); }
#line 6236 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 347: // optTypeParameters: %empty
#line 1128 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::TypeParameters* > () = new IR::TypeParameters(); }
#line 6242 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 348: // optTypeParameters: typeParameters
#line 1129 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::TypeParameters* > () = yystack_[0].value.as < IR::TypeParameters* > (); }
#line 6248 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 349: // typeParameters: l_angle typeParameterList r_angle
#line 1133 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::TypeParameters* > () = new IR::TypeParameters(yystack_[2].location+yystack_[0].location, *yystack_[1].value.as < IR::IndexedVector<IR::Type_Var>* > ()); }
#line 6254 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 350: // typeParameterList: name
#line 1137 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::IndexedVector<IR::Type_Var>* > () = new IR::IndexedVector<IR::Type_Var>();
                                       yylhs.value.as < IR::IndexedVector<IR::Type_Var>* > ()->push_back(new IR::Type_Var(yystack_[0].location, *yystack_[0].value.as < IR::ID* > ())); yylhs.value.as < IR::IndexedVector<IR::Type_Var>* > ()->srcInfo = yystack_[0].location; }
#line 6261 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 351: // typeParameterList: typeParameterList "," name
#line 1139 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { (yylhs.value.as < IR::IndexedVector<IR::Type_Var>* > ()=yystack_[2].value.as < IR::IndexedVector<IR::Type_Var>* > ())->push_back(new IR::Type_Var(yystack_[0].location, *yystack_[0].value.as < IR::ID* > ())); yylhs.value.as < IR::IndexedVector<IR::Type_Var>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 6267 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 352: // typeArg: typeRef
#line 1143 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6273 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 353: // typeArg: nonTypeName
#line 1144 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = new IR::Type_Name(yystack_[0].location, new IR::Path(*yystack_[0].value.as < IR::ID* > ())); }
#line 6279 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 354: // typeArg: VOID
#line 1146 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = IR::Type_Void::get(yystack_[0].location); }
#line 6285 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 355: // typeArg: "_"
#line 1147 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = IR::Type_Dontcare::get(yystack_[0].location); }
#line 6291 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 356: // typeArgumentList: %empty
#line 1151 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Vector<IR::Type>* > () = new IR::Vector<IR::Type>(); }
#line 6297 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 357: // typeArgumentList: typeArg
#line 1152 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Vector<IR::Type>* > () = new IR::Vector<IR::Type>(); yylhs.value.as < IR::Vector<IR::Type>* > ()->push_back(yystack_[0].value.as < ConstType* > ()); yylhs.value.as < IR::Vector<IR::Type>* > ()->srcInfo = yystack_[0].location; }
#line 6303 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 358: // typeArgumentList: typeArgumentList "," typeArg
#line 1153 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Vector<IR::Type>* > () = yystack_[2].value.as < IR::Vector<IR::Type>* > (); yylhs.value.as < IR::Vector<IR::Type>* > ()->push_back(yystack_[0].value.as < ConstType* > ()); yylhs.value.as < IR::Vector<IR::Type>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 6309 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 359: // realTypeArg: typeRef
#line 1157 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = yystack_[0].value.as < ConstType* > (); }
#line 6315 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 360: // realTypeArg: VOID
#line 1158 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = IR::Type_Void::get(yystack_[0].location); }
#line 6321 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 361: // realTypeArg: "_"
#line 1159 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { yylhs.value.as < ConstType* > () = IR::Type_Dontcare::get(yystack_[0].location); }
#line 6327 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 362: // realTypeArgumentList: realTypeArg
#line 1165 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Type>* > () = new IR::Vector<IR::Type>(); yylhs.value.as < IR::Vector<IR::Type>* > ()->push_back(yystack_[0].value.as < ConstType* > ()); yylhs.value.as < IR::Vector<IR::Type>* > ()->srcInfo = yystack_[0].location; }
#line 6333 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 363: // realTypeArgumentList: realTypeArgumentList "," typeArg
#line 1166 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Type>* > () = yystack_[2].value.as < IR::Vector<IR::Type>* > (); yylhs.value.as < IR::Vector<IR::Type>* > ()->push_back(yystack_[0].value.as < ConstType* > ()); yylhs.value.as < IR::Vector<IR::Type>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 6339 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 364: // typeDeclaration: derivedTypeDeclaration
#line 1170 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Type_Declaration* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 6345 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 365: // typeDeclaration: typedefDeclaration ";"
#line 1171 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Type_Declaration* > () = yystack_[1].value.as < IR::Type_Declaration* > (); }
#line 6351 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 366: // typeDeclaration: parserTypeDeclaration ";"
#line 1172 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { driver.structure->pop(); yylhs.value.as < IR::Type_Declaration* > () = yystack_[1].value.as < IR::Type_Parser* > (); }
#line 6357 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 367: // typeDeclaration: controlTypeDeclaration ";"
#line 1173 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { driver.structure->pop(); yylhs.value.as < IR::Type_Declaration* > () = yystack_[1].value.as < IR::Type_Control* > (); }
#line 6363 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 368: // typeDeclaration: packageTypeDeclaration ";"
#line 1174 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { driver.structure->pop(); yylhs.value.as < IR::Type_Declaration* > () = yystack_[1].value.as < IR::Type_Declaration* > (); }
#line 6369 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 369: // derivedTypeDeclaration: headerTypeDeclaration
#line 1178 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Type_Declaration* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 6375 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 370: // derivedTypeDeclaration: headerUnionDeclaration
#line 1179 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Type_Declaration* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 6381 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 371: // derivedTypeDeclaration: structTypeDeclaration
#line 1180 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Type_Declaration* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 6387 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 372: // derivedTypeDeclaration: enumDeclaration
#line 1181 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Type_Declaration* > () = yystack_[0].value.as < IR::Type_Declaration* > (); }
#line 6393 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 373: // $@13: %empty
#line 1185 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 6399 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 374: // $@14: %empty
#line 1185 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                                                       {
        driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
        driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 6407 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 375: // headerTypeDeclaration: optAnnotations HEADER name $@13 optTypeParameters $@14 "{" structFieldList "}"
#line 1188 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Header(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), *yystack_[1].value.as < IR::IndexedVector<IR::StructField>* > ());
                                driver.structure->pop(); }
#line 6414 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 376: // $@15: %empty
#line 1193 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                  { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 6420 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 377: // $@16: %empty
#line 1193 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                                                        {
        driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
        driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 6428 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 378: // structTypeDeclaration: optAnnotations STRUCT name $@15 optTypeParameters $@16 "{" structFieldList "}"
#line 1196 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Struct(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), *yystack_[1].value.as < IR::IndexedVector<IR::StructField>* > ());
                                driver.structure->pop(); }
#line 6435 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 379: // $@17: %empty
#line 1201 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { driver.structure->pushContainerType(*yystack_[0].value.as < IR::ID* > (), true); }
#line 6441 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 380: // $@18: %empty
#line 1201 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                                                             {
        driver.structure->markAsTemplate(*yystack_[2].value.as < IR::ID* > ());
        driver.structure->declareTypes(&yystack_[0].value.as < IR::TypeParameters* > ()->parameters); }
#line 6449 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 381: // headerUnionDeclaration: optAnnotations HEADER_UNION name $@17 optTypeParameters $@18 "{" structFieldList "}"
#line 1204 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_HeaderUnion(yystack_[6].location, *yystack_[6].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < IR::TypeParameters* > (), *yystack_[1].value.as < IR::IndexedVector<IR::StructField>* > ());
                                driver.structure->pop(); }
#line 6456 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 382: // structFieldList: %empty
#line 1209 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::IndexedVector<IR::StructField>* > () = new IR::IndexedVector<IR::StructField>(); }
#line 6462 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 383: // structFieldList: structFieldList structField
#line 1210 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::IndexedVector<IR::StructField>* > () = yystack_[1].value.as < IR::IndexedVector<IR::StructField>* > (); yystack_[1].value.as < IR::IndexedVector<IR::StructField>* > ()->push_back(yystack_[0].value.as < IR::StructField* > ()); yylhs.value.as < IR::IndexedVector<IR::StructField>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 6468 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 384: // structField: optAnnotations typeRef name ";"
#line 1214 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::StructField* > () = new IR::StructField(yystack_[1].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[2].value.as < ConstType* > ()); }
#line 6474 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 385: // $@19: %empty
#line 1219 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                  { driver.structure->declareType(*yystack_[0].value.as < IR::ID* > ()); }
#line 6480 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 386: // enumDeclaration: optAnnotations ENUM name $@19 "{" identifierList optTrailingComma "}"
#line 1220 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                { yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Enum(yystack_[5].location, *yystack_[5].value.as < IR::ID* > (), *yystack_[7].value.as < IR::Vector<IR::Annotation>* > (), *yystack_[2].value.as < IR::IndexedVector<IR::Declaration_ID>* > ()); }
#line 6486 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 387: // $@20: %empty
#line 1221 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { driver.structure->declareType(*yystack_[0].value.as < IR::ID* > ()); }
#line 6492 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 388: // enumDeclaration: optAnnotations ENUM typeRef name $@20 "{" specifiedIdentifierList optTrailingComma "}"
#line 1222 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                          {
              auto type = yystack_[6].value.as < ConstType* > ();
              yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_SerEnum(yystack_[5].location, *yystack_[5].value.as < IR::ID* > (), *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), type, *yystack_[2].value.as < IR::IndexedVector<IR::SerEnumMember>* > ());
          }
#line 6501 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 389: // specifiedIdentifierList: specifiedIdentifier
#line 1229 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                           { yylhs.value.as < IR::IndexedVector<IR::SerEnumMember>* > () = new IR::IndexedVector<IR::SerEnumMember>();
                                             yylhs.value.as < IR::IndexedVector<IR::SerEnumMember>* > ()->push_back(yystack_[0].value.as < IR::SerEnumMember* > ()); yylhs.value.as < IR::IndexedVector<IR::SerEnumMember>* > ()->srcInfo = yystack_[0].location; }
#line 6508 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 390: // specifiedIdentifierList: specifiedIdentifierList "," specifiedIdentifier
#line 1231 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                      { yylhs.value.as < IR::IndexedVector<IR::SerEnumMember>* > () = yystack_[2].value.as < IR::IndexedVector<IR::SerEnumMember>* > (); yystack_[2].value.as < IR::IndexedVector<IR::SerEnumMember>* > ()->push_back(yystack_[0].value.as < IR::SerEnumMember* > ()); yylhs.value.as < IR::IndexedVector<IR::SerEnumMember>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 6514 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 391: // specifiedIdentifier: name "=" initializer
#line 1235 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::SerEnumMember* > () = new IR::SerEnumMember(yystack_[2].location+yystack_[0].location, *yystack_[2].value.as < IR::ID* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6520 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 392: // errorDeclaration: ERROR "{" identifierList "}"
#line 1240 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Type_Error* > () = new IR::Type_Error(yystack_[3].location + yystack_[0].location, IR::ID(yystack_[3].location, "error"_cs), *yystack_[1].value.as < IR::IndexedVector<IR::Declaration_ID>* > ()); }
#line 6526 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 393: // matchKindDeclaration: MATCH_KIND "{" identifierList optTrailingComma "}"
#line 1245 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Node* > () = new IR::Declaration_MatchKind(yystack_[4].location + yystack_[1].location, *yystack_[2].value.as < IR::IndexedVector<IR::Declaration_ID>* > ()); }
#line 6532 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 394: // identifierList: name
#line 1249 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > () = new IR::IndexedVector<IR::Declaration_ID>();
                                yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > ()->push_back(new IR::Declaration_ID(yystack_[0].location, *yystack_[0].value.as < IR::ID* > ())); yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > ()->srcInfo = yystack_[0].location; }
#line 6539 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 395: // identifierList: identifierList "," name
#line 1251 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                              { yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > () = yystack_[2].value.as < IR::IndexedVector<IR::Declaration_ID>* > (); yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > ()->push_back(new IR::Declaration_ID(yystack_[0].location, *yystack_[0].value.as < IR::ID* > ()));
                                yylhs.value.as < IR::IndexedVector<IR::Declaration_ID>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 6546 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 396: // typedefDeclaration: optAnnotations TYPEDEF typeRef name
#line 1256 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { driver.structure->declareType(*yystack_[0].value.as < IR::ID* > ());
          yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Typedef(yystack_[0].location, *yystack_[0].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[1].value.as < ConstType* > ()); }
#line 6553 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 397: // typedefDeclaration: optAnnotations TYPEDEF derivedTypeDeclaration name
#line 1258 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                           { driver.structure->declareType(*yystack_[0].value.as < IR::ID* > ());
                        yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Typedef(yystack_[0].location, *yystack_[0].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[1].value.as < IR::Type_Declaration* > ()); }
#line 6560 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 398: // typedefDeclaration: optAnnotations TYPE typeRef name
#line 1260 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { driver.structure->declareType(*yystack_[0].value.as < IR::ID* > ());
          yylhs.value.as < IR::Type_Declaration* > () = new IR::Type_Newtype(yystack_[0].location, *yystack_[0].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[1].value.as < ConstType* > ()); }
#line 6567 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 399: // assignmentOrMethodCallStatement: assignmentOrMethodCallStatementWithoutSemicolon ";"
#line 1267 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                           { yylhs.value.as < IR::Statement* > () = yystack_[1].value.as < IR::Statement* > (); }
#line 6573 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 400: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "(" argumentList ")"
#line 1273 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto mc = new IR::MethodCallExpression(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (),
                                                 new IR::Vector<IR::Type>(), yystack_[1].value.as < IR::Vector<IR::Argument>* > ());
          yylhs.value.as < IR::Statement* > () = new IR::MethodCallStatement(yystack_[3].location + yystack_[0].location, mc); }
#line 6581 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 401: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue l_angle typeArgumentList r_angle "(" argumentList ")"
#line 1278 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto mc = new IR::MethodCallExpression(yystack_[6].location + yystack_[0].location,
                                                 yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Vector<IR::Type>* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ());
          yylhs.value.as < IR::Statement* > () = new IR::MethodCallStatement(yystack_[6].location + yystack_[0].location, mc); }
#line 6589 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 402: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "=" expression
#line 1283 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::AssignmentStatement(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6595 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 403: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "*=" expression
#line 1286 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::MulAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6601 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 404: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "/=" expression
#line 1288 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::DivAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6607 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 405: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "%=" expression
#line 1290 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::ModAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6613 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 406: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "+=" expression
#line 1292 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::AddAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6619 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 407: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "-=" expression
#line 1294 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::SubAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6625 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 408: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "|+|=" expression
#line 1296 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::AddSatAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6631 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 409: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "|-|=" expression
#line 1298 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::SubSatAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6637 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 410: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "<<=" expression
#line 1300 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::ShlAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6643 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 411: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue ">>=" expression
#line 1302 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::ShrAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6649 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 412: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue R_ANGLE_SHIFT ">=" expression
#line 1304 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::ShrAssign(yystack_[2].location+yystack_[1].location, yystack_[3].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6655 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 413: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "&=" expression
#line 1306 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::BAndAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6661 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 414: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "|=" expression
#line 1308 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::BOrAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6667 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 415: // assignmentOrMethodCallStatementWithoutSemicolon: lvalue "^=" expression
#line 1310 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::BXorAssign(yystack_[1].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6673 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 416: // emptyStatement: ";"
#line 1314 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
               { yylhs.value.as < IR::Statement* > () = new IR::EmptyStatement(yystack_[0].location); }
#line 6679 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 417: // exitStatement: EXIT ";"
#line 1318 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
               { yylhs.value.as < IR::Statement* > () = new IR::ExitStatement(yystack_[1].location); }
#line 6685 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 418: // returnStatement: RETURN ";"
#line 1322 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                            { yylhs.value.as < IR::Statement* > () = new IR::ReturnStatement(yystack_[1].location, nullptr); }
#line 6691 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 419: // returnStatement: RETURN expression ";"
#line 1323 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                            { yylhs.value.as < IR::Statement* > () = new IR::ReturnStatement(yystack_[2].location, yystack_[1].value.as < IR::Expression* > ()); }
#line 6697 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 420: // conditionalStatement: IF "(" expression ")" statement
#line 1328 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::IfStatement(yystack_[4].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Statement* > (), nullptr); }
#line 6703 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 421: // conditionalStatement: IF "(" expression ")" statement ELSE statement
#line 1330 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Statement* > () = new IR::IfStatement(yystack_[6].location, yystack_[4].value.as < IR::Expression* > (), yystack_[2].value.as < IR::Statement* > (), yystack_[0].value.as < IR::Statement* > ()); }
#line 6709 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 422: // breakStatement: BREAK ";"
#line 1334 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                { yylhs.value.as < IR::Statement* > () = new IR::BreakStatement(yystack_[1].location); }
#line 6715 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 423: // continueStatement: CONTINUE ";"
#line 1338 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                   { yylhs.value.as < IR::Statement* > () = new IR::ContinueStatement(yystack_[1].location); }
#line 6721 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 424: // directApplication: typeName "." APPLY "(" argumentList ")" ";"
#line 1343 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                  {
                                  auto method = new IR::Member(
                                      yystack_[6].location + yystack_[4].location, new IR::TypeNameExpression(yystack_[6].value.as < IR::Type_Name* > ()), IR::ID(yystack_[4].location, "apply"_cs));
                                  auto mce = new IR::MethodCallExpression(yystack_[6].location + yystack_[1].location, method, yystack_[2].value.as < IR::Vector<IR::Argument>* > ());
                                  yylhs.value.as < IR::Statement* > () = new IR::MethodCallStatement(yystack_[6].location + yystack_[1].location, mce); }
#line 6731 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 425: // directApplication: specializedType "." APPLY "(" argumentList ")" ";"
#line 1348 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                         {
                                  auto method = new IR::Member(
                                      yystack_[6].location + yystack_[4].location, new IR::TypeNameExpression(yystack_[6].value.as < ConstType* > ()), IR::ID(yystack_[4].location, "apply"_cs));
                                  auto mce = new IR::MethodCallExpression(yystack_[6].location + yystack_[1].location, method, yystack_[2].value.as < IR::Vector<IR::Argument>* > ());
                                  yylhs.value.as < IR::Statement* > () = new IR::MethodCallStatement(yystack_[6].location + yystack_[1].location, mce); }
#line 6741 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 426: // statement: assignmentOrMethodCallStatement
#line 1356 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6747 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 427: // statement: directApplication
#line 1357 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6753 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 428: // statement: conditionalStatement
#line 1358 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6759 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 429: // statement: emptyStatement
#line 1359 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6765 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 430: // statement: blockStatement
#line 1360 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::BlockStatement* > (); }
#line 6771 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 431: // statement: returnStatement
#line 1361 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6777 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 432: // statement: breakStatement
#line 1362 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6783 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 433: // statement: continueStatement
#line 1363 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6789 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 434: // statement: exitStatement
#line 1364 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6795 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 435: // statement: switchStatement
#line 1365 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6801 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 436: // statement: forStatement
#line 1366 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Statement* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6807 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 437: // $@21: %empty
#line 1370 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                         { driver.structure->pushNamespace(yystack_[0].location, false); }
#line 6813 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 438: // blockStatement: optAnnotations "{" $@21 statOrDeclList "}"
#line 1371 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                         { driver.structure->pop();
                           yylhs.value.as < IR::BlockStatement* > () = new IR::BlockStatement(yystack_[4].location + yystack_[0].location, *yystack_[4].value.as < IR::Vector<IR::Annotation>* > (), *yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > ()); }
#line 6820 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 439: // statOrDeclList: %empty
#line 1376 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(); }
#line 6826 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 440: // statOrDeclList: statOrDeclList statementOrDeclaration
#line 1377 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                            { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[1].value.as < IR::IndexedVector<IR::StatOrDecl>* > (); yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->push_back(yystack_[0].value.as < IR::StatOrDecl* > ()); yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 6832 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 441: // switchStatement: SWITCH "(" expression ")" "{" switchCases "}"
#line 1381 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                    {
            yylhs.value.as < IR::Statement* > () = new IR::SwitchStatement(yystack_[6].location, yystack_[4].value.as < IR::Expression* > (), std::move(*yystack_[1].value.as < IR::Vector<IR::SwitchCase>* > ())); }
#line 6839 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 442: // switchCases: %empty
#line 1386 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Vector<IR::SwitchCase>* > () = new IR::Vector<IR::SwitchCase>(); }
#line 6845 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 443: // switchCases: switchCases switchCase
#line 1387 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Vector<IR::SwitchCase>* > () = yystack_[1].value.as < IR::Vector<IR::SwitchCase>* > (); yylhs.value.as < IR::Vector<IR::SwitchCase>* > ()->push_back(yystack_[0].value.as < IR::SwitchCase* > ()); yylhs.value.as < IR::Vector<IR::SwitchCase>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 6851 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 444: // switchCase: switchLabel ":" blockStatement
#line 1391 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::SwitchCase* > () = new IR::SwitchCase(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::BlockStatement* > ()); }
#line 6857 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 445: // switchCase: switchLabel ":"
#line 1392 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::SwitchCase* > () = new IR::SwitchCase(yystack_[1].location, yystack_[1].value.as < IR::Expression* > (), nullptr); }
#line 6863 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 446: // switchLabel: DEFAULT
#line 1396 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Expression* > () = new IR::DefaultExpression(yystack_[0].location); }
#line 6869 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 447: // switchLabel: nonBraceExpression
#line 1397 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 6875 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 448: // statementOrDeclaration: variableDeclaration
#line 1401 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 6881 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 449: // statementOrDeclaration: constantDeclaration
#line 1402 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 6887 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 450: // statementOrDeclaration: statement
#line 1403 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6893 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 451: // statementOrDeclaration: instantiation
#line 1408 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                               { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 6899 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 452: // forStatement: optAnnotations FOR "(" forInitStatements ";" expression ";" forUpdateStatements ")" statement
#line 1416 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
    { yylhs.value.as < IR::Statement* > () = new IR::ForStatement(yystack_[8].location+yystack_[1].location, *yystack_[9].value.as < IR::Vector<IR::Annotation>* > (), *yystack_[6].value.as < IR::IndexedVector<IR::StatOrDecl>* > (), yystack_[4].value.as < IR::Expression* > (), *yystack_[2].value.as < IR::IndexedVector<IR::StatOrDecl>* > (), yystack_[0].value.as < IR::Statement* > ()); }
#line 6905 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 453: // forStatement: optAnnotations FOR "(" typeRef name IN forCollectionExpr ")" statement
#line 1418 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
    { auto decl = new IR::Declaration_Variable(yystack_[5].location+yystack_[4].location, *yystack_[4].value.as < IR::ID* > (), yystack_[5].value.as < ConstType* > ());
      yylhs.value.as < IR::Statement* > () = new IR::ForInStatement(yystack_[7].location+yystack_[2].location, *yystack_[8].value.as < IR::Vector<IR::Annotation>* > (), decl, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Statement* > ()); }
#line 6912 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 454: // forStatement: optAnnotations FOR "(" annotations typeRef name IN forCollectionExpr ")" statement
#line 1421 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
    { auto decl = new IR::Declaration_Variable(yystack_[5].location+yystack_[4].location, *yystack_[4].value.as < IR::ID* > (), *yystack_[6].value.as < IR::Vector<IR::Annotation>* > (), yystack_[5].value.as < ConstType* > ());
      yylhs.value.as < IR::Statement* > () = new IR::ForInStatement(yystack_[8].location+yystack_[2].location, *yystack_[9].value.as < IR::Vector<IR::Annotation>* > (), decl, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Statement* > ()); }
#line 6919 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 455: // forInitStatements: %empty
#line 1426 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(); }
#line 6925 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 456: // forInitStatements: forInitStatementsNonEmpty
#line 1427 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[0].value.as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 6931 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 457: // forInitStatementsNonEmpty: declOrAssignmentOrMethodCallStatement
#line 1431 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(yystack_[0].value.as < IR::StatOrDecl* > ()); }
#line 6937 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 458: // forInitStatementsNonEmpty: forInitStatementsNonEmpty "," declOrAssignmentOrMethodCallStatement
#line 1432 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                          {
            (yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[2].value.as < IR::IndexedVector<IR::StatOrDecl>* > ())->push_back(yystack_[0].value.as < IR::StatOrDecl* > ()); }
#line 6944 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 459: // declOrAssignmentOrMethodCallStatement: variableDeclarationWithoutSemicolon
#line 1437 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Declaration* > (); }
#line 6950 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 460: // declOrAssignmentOrMethodCallStatement: assignmentOrMethodCallStatementWithoutSemicolon
#line 1438 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        { yylhs.value.as < IR::StatOrDecl* > () = yystack_[0].value.as < IR::Statement* > (); }
#line 6956 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 461: // forUpdateStatements: %empty
#line 1442 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(); }
#line 6962 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 462: // forUpdateStatements: forUpdateStatementsNonEmpty
#line 1443 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[0].value.as < IR::IndexedVector<IR::StatOrDecl>* > (); }
#line 6968 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 463: // forUpdateStatementsNonEmpty: assignmentOrMethodCallStatementWithoutSemicolon
#line 1447 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                        {
            yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = new IR::IndexedVector<IR::StatOrDecl>(yystack_[0].value.as < IR::Statement* > ()); }
#line 6975 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 464: // forUpdateStatementsNonEmpty: forUpdateStatementsNonEmpty "," assignmentOrMethodCallStatementWithoutSemicolon
#line 1449 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                                      {
            (yylhs.value.as < IR::IndexedVector<IR::StatOrDecl>* > () = yystack_[2].value.as < IR::IndexedVector<IR::StatOrDecl>* > ())->push_back(yystack_[0].value.as < IR::Statement* > ()); }
#line 6982 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 465: // forCollectionExpr: expression
#line 1454 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 6988 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 466: // forCollectionExpr: expression ".." expression
#line 1455 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::Expression* > () = new IR::Range(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 6994 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 467: // forCollectionExpr: typeRef
#line 1456 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                        { yylhs.value.as < IR::Expression* > () = new IR::ConstructorCallExpression(yystack_[0].location, yystack_[0].value.as < ConstType* > (), {}); }
#line 7000 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 468: // tableDeclaration: optAnnotations TABLE name "{" tablePropertyList "}"
#line 1464 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
          { yylhs.value.as < IR::Declaration* > () = new IR::P4Table(yystack_[3].location, *yystack_[3].value.as < IR::ID* > (), *yystack_[5].value.as < IR::Vector<IR::Annotation>* > (), new IR::TableProperties(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::Property>* > ())); }
#line 7006 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 469: // tablePropertyList: tableProperty
#line 1468 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::IndexedVector<IR::Property>* > () = new IR::IndexedVector<IR::Property>();
                                           yylhs.value.as < IR::IndexedVector<IR::Property>* > ()->push_back(yystack_[0].value.as < IR::Property* > ()); yylhs.value.as < IR::IndexedVector<IR::Property>* > ()->srcInfo = yystack_[0].location; }
#line 7013 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 470: // tablePropertyList: tablePropertyList tableProperty
#line 1470 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::IndexedVector<IR::Property>* > () = yystack_[1].value.as < IR::IndexedVector<IR::Property>* > (); yylhs.value.as < IR::IndexedVector<IR::Property>* > ()->push_back(yystack_[0].value.as < IR::Property* > ()); yylhs.value.as < IR::IndexedVector<IR::Property>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 7019 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 471: // tableProperty: KEY "=" "{" keyElementList "}"
#line 1475 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto v = new IR::Key(yystack_[1].location, *yystack_[1].value.as < IR::Vector<IR::KeyElement>* > ());
          auto id = IR::ID(yystack_[4].location, "key"_cs);
          yylhs.value.as < IR::Property* > () = new IR::Property( yystack_[4].location + yystack_[0].location, id, v, false); }
#line 7027 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 472: // tableProperty: ACTIONS "=" "{" actionList "}"
#line 1479 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto v = new IR::ActionList(yystack_[1].location, *yystack_[1].value.as < IR::IndexedVector<IR::ActionListElement>* > ());
          auto id = IR::ID(yystack_[4].location, "actions"_cs);
          yylhs.value.as < IR::Property* > () = new IR::Property(yystack_[4].location + yystack_[0].location, id, v, false); }
#line 7035 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 473: // tableProperty: optAnnotations optCONST ENTRIES "=" "{" entriesList "}"
#line 1483 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto l = new IR::EntriesList(yystack_[4].location, *yystack_[1].value.as < IR::Vector<IR::Entry>* > ());
          auto id = IR::ID(yystack_[4].location+yystack_[0].location, "entries"_cs);
          yylhs.value.as < IR::Property* > () = new IR::Property(yystack_[4].location, id, *yystack_[6].value.as < IR::Vector<IR::Annotation>* > (), l, yystack_[5].value.as < OptionalConst > ().isConst); }
#line 7043 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 474: // tableProperty: optAnnotations optCONST nonTableKwName "=" initializer ";"
#line 1487 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto v = new IR::ExpressionValue(yystack_[1].location, yystack_[1].value.as < IR::Expression* > ());
          auto id = *yystack_[3].value.as < IR::ID* > ();
          yylhs.value.as < IR::Property* > () = new IR::Property(yystack_[3].value.as < IR::ID* > ()->srcInfo, id, *yystack_[5].value.as < IR::Vector<IR::Annotation>* > (), v, yystack_[4].value.as < OptionalConst > ().isConst); }
#line 7051 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 475: // keyElementList: %empty
#line 1493 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::KeyElement>* > () = new IR::Vector<IR::KeyElement>(); }
#line 7057 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 476: // keyElementList: keyElementList keyElement
#line 1494 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::KeyElement>* > () = yystack_[1].value.as < IR::Vector<IR::KeyElement>* > (); yylhs.value.as < IR::Vector<IR::KeyElement>* > ()->push_back(yystack_[0].value.as < IR::KeyElement* > ()); yylhs.value.as < IR::Vector<IR::KeyElement>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 7063 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 477: // keyElement: expression ":" name optAnnotations ";"
#line 1499 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { auto expr = new IR::PathExpression(*yystack_[2].value.as < IR::ID* > ());
                                           yylhs.value.as < IR::KeyElement* > () = new IR::KeyElement(yystack_[4].location, yystack_[4].value.as < IR::Expression* > (), expr, *yystack_[1].value.as < IR::Vector<IR::Annotation>* > ()); }
#line 7070 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 478: // actionList: %empty
#line 1504 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < IR::IndexedVector<IR::ActionListElement>* > () = new IR::IndexedVector<IR::ActionListElement>(); }
#line 7076 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 479: // actionList: actionList optAnnotations actionRef ";"
#line 1506 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
             { yylhs.value.as < IR::IndexedVector<IR::ActionListElement>* > () = yystack_[3].value.as < IR::IndexedVector<IR::ActionListElement>* > (); yylhs.value.as < IR::IndexedVector<IR::ActionListElement>* > ()->push_back(new IR::ActionListElement(yystack_[1].location, *yystack_[2].value.as < IR::Vector<IR::Annotation>* > (), yystack_[1].value.as < IR::Expression* > ())); yylhs.value.as < IR::IndexedVector<IR::ActionListElement>* > ()->srcInfo = yystack_[3].location + yystack_[1].location; }
#line 7082 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 480: // actionRef: prefixedNonTypeName
#line 1511 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::PathExpression(yystack_[0].value.as < IR::Path* > ()); }
#line 7088 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 481: // actionRef: prefixedNonTypeName "(" argumentList ")"
#line 1513 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::MethodCallExpression(yystack_[3].location+yystack_[1].location, new IR::PathExpression(yystack_[3].value.as < IR::Path* > ()), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7094 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 482: // entry: optCONST entryPriority keysetExpression ":" actionRef optAnnotations ";"
#line 1520 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { if (auto l = yystack_[4].value.as < IR::Expression* > ()->to<IR::ListExpression>())
            yylhs.value.as < IR::Entry* > () = new IR::Entry(yystack_[4].location+yystack_[1].location, *yystack_[1].value.as < IR::Vector<IR::Annotation>* > (), yystack_[6].value.as < OptionalConst > ().isConst, yystack_[5].value.as < IR::Expression* > (), l, yystack_[2].value.as < IR::Expression* > (), false);
          else {  // if not a tuple, make it a list of 1
            IR::Vector<IR::Expression> le(yystack_[4].value.as < IR::Expression* > ());
            yylhs.value.as < IR::Entry* > () = new IR::Entry(yystack_[4].location+yystack_[1].location, *yystack_[1].value.as < IR::Vector<IR::Annotation>* > (), yystack_[6].value.as < OptionalConst > ().isConst, yystack_[5].value.as < IR::Expression* > (),
                   new IR::ListExpression(yystack_[4].location, le), yystack_[2].value.as < IR::Expression* > (), true);
          }
        }
#line 7107 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 483: // entry: optCONST keysetExpression ":" actionRef optAnnotations ";"
#line 1531 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { if (auto l = yystack_[4].value.as < IR::Expression* > ()->to<IR::ListExpression>())
            yylhs.value.as < IR::Entry* > () = new IR::Entry(yystack_[4].location+yystack_[1].location, *yystack_[1].value.as < IR::Vector<IR::Annotation>* > (), yystack_[5].value.as < OptionalConst > ().isConst, nullptr, l, yystack_[2].value.as < IR::Expression* > (), false);
          else {  // if not a tuple, make it a list of 1
            IR::Vector<IR::Expression> le(yystack_[4].value.as < IR::Expression* > ());
            yylhs.value.as < IR::Entry* > () = new IR::Entry(yystack_[4].location+yystack_[1].location, *yystack_[1].value.as < IR::Vector<IR::Annotation>* > (), yystack_[5].value.as < OptionalConst > ().isConst, nullptr,
                   new IR::ListExpression(yystack_[4].location, le), yystack_[2].value.as < IR::Expression* > (), true);
          }
        }
#line 7120 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 484: // entryPriority: PRIORITY "=" INTEGER ":"
#line 1542 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Expression* > () = new IR::Constant(parseConstantChecked(yystack_[1].location, yystack_[1].value.as < UnparsedConstant > ())); }
#line 7126 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 485: // entryPriority: PRIORITY "=" "(" expression ")" ":"
#line 1543 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < IR::Expression* > () = yystack_[2].value.as < IR::Expression* > (); }
#line 7132 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 486: // entriesList: %empty
#line 1547 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Vector<IR::Entry>* > () = new IR::Vector<IR::Entry>(); }
#line 7138 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 487: // entriesList: entriesList entry
#line 1548 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Vector<IR::Entry>* > () = yystack_[1].value.as < IR::Vector<IR::Entry>* > (); yylhs.value.as < IR::Vector<IR::Entry>* > ()->push_back(yystack_[0].value.as < IR::Entry* > ()); yylhs.value.as < IR::Vector<IR::Entry>* > ()->srcInfo = yystack_[1].location + yystack_[0].location; }
#line 7144 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 488: // actionDeclaration: optAnnotations ACTION name "(" parameterList ")" blockStatement
#line 1555 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto pl = new IR::ParameterList(yystack_[2].location, *yystack_[2].value.as < IR::IndexedVector<IR::Parameter>* > ());
          yylhs.value.as < IR::Declaration* > () = new IR::P4Action(yystack_[4].location, *yystack_[4].value.as < IR::ID* > (), *yystack_[6].value.as < IR::Vector<IR::Annotation>* > (), pl, yystack_[0].value.as < IR::BlockStatement* > ()); }
#line 7151 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 489: // variableDeclaration: variableDeclarationWithoutSemicolon ";"
#line 1562 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Declaration* > () = yystack_[1].value.as < IR::Declaration* > (); }
#line 7157 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 490: // variableDeclarationWithoutSemicolon: annotations typeRef name optInitializer
#line 1567 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Variable(yystack_[3].location+yystack_[0].location, *yystack_[1].value.as < IR::ID* > (), *yystack_[3].value.as < IR::Vector<IR::Annotation>* > (), yystack_[2].value.as < ConstType* > (), yystack_[0].value.as < IR::Expression* > ());
                                       driver.structure->declareObject(*yystack_[1].value.as < IR::ID* > (), yystack_[2].value.as < ConstType* > ()->toString()); }
#line 7164 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 491: // variableDeclarationWithoutSemicolon: typeRef name optInitializer
#line 1570 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Variable(yystack_[2].location+yystack_[0].location, *yystack_[1].value.as < IR::ID* > (), yystack_[2].value.as < ConstType* > (), yystack_[0].value.as < IR::Expression* > ());
                                       driver.structure->declareObject(*yystack_[1].value.as < IR::ID* > (), yystack_[2].value.as < ConstType* > ()->toString()); }
#line 7171 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 492: // constantDeclaration: optAnnotations CONST typeRef name "=" initializer ";"
#line 1576 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                     { yylhs.value.as < IR::Declaration* > () = new IR::Declaration_Constant(yystack_[3].location, *yystack_[3].value.as < IR::ID* > (), *yystack_[6].value.as < IR::Vector<IR::Annotation>* > (), yystack_[4].value.as < ConstType* > (), yystack_[1].value.as < IR::Expression* > ());
                                       driver.structure->declareObject(*yystack_[3].value.as < IR::ID* > (), yystack_[4].value.as < ConstType* > ()->toString()); }
#line 7178 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 493: // optInitializer: %empty
#line 1581 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Expression* > () = nullptr; }
#line 7184 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 494: // optInitializer: "=" initializer
#line 1582 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                       { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 7190 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 495: // initializer: expression
#line 1586 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                          { yylhs.value.as < IR::Expression* > () = yystack_[0].value.as < IR::Expression* > (); }
#line 7196 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 496: // functionDeclaration: annotations functionPrototype blockStatement
#line 1592 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                     {
            driver.structure->pop();
            yylhs.value.as < IR::Declaration* > () = new IR::Function(yystack_[1].value.as < IR::Method* > ()->srcInfo, yystack_[1].value.as < IR::Method* > ()->name, *yystack_[2].value.as < IR::Vector<IR::Annotation>* > (), yystack_[1].value.as < IR::Method* > ()->type, yystack_[0].value.as < IR::BlockStatement* > ()); }
#line 7204 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 497: // functionDeclaration: functionPrototype blockStatement
#line 1595 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         {
            driver.structure->pop();
            yylhs.value.as < IR::Declaration* > () = new IR::Function(yystack_[1].value.as < IR::Method* > ()->srcInfo, yystack_[1].value.as < IR::Method* > ()->name, yystack_[1].value.as < IR::Method* > ()->type, yystack_[0].value.as < IR::BlockStatement* > ()); }
#line 7212 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 498: // argumentList: %empty
#line 1601 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Argument>* > () = new IR::Vector<IR::Argument>(); }
#line 7218 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 499: // argumentList: nonEmptyArgList
#line 1602 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Argument>* > () = yystack_[0].value.as < IR::Vector<IR::Argument>* > (); }
#line 7224 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 500: // nonEmptyArgList: argument
#line 1606 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Argument>* > () = new IR::Vector<IR::Argument>();
                                           yylhs.value.as < IR::Vector<IR::Argument>* > ()->push_back(yystack_[0].value.as < IR::Argument* > ()); yylhs.value.as < IR::Vector<IR::Argument>* > ()->srcInfo = yystack_[0].location; }
#line 7231 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 501: // nonEmptyArgList: nonEmptyArgList "," argument
#line 1608 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Argument>* > () = yystack_[2].value.as < IR::Vector<IR::Argument>* > (); yylhs.value.as < IR::Vector<IR::Argument>* > ()->push_back(yystack_[0].value.as < IR::Argument* > ()); yylhs.value.as < IR::Vector<IR::Argument>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 7237 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 502: // argument: expression
#line 1612 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Argument* > () = new IR::Argument(yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7243 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 503: // argument: name "=" expression
#line 1613 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Argument* > () = new IR::Argument(yystack_[2].location, *yystack_[2].value.as < IR::ID* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7249 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 504: // argument: "_"
#line 1614 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Argument* > () = new IR::Argument(yystack_[0].location, new IR::DefaultExpression(yystack_[0].location)); }
#line 7255 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 505: // argument: name "=" "_"
#line 1615 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Argument* > () = new IR::Argument(yystack_[2].location, *yystack_[2].value.as < IR::ID* > (), new IR::DefaultExpression(yystack_[0].location)); }
#line 7261 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 506: // expressionList: %empty
#line 1619 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>(); }
#line 7267 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 507: // expressionList: expression
#line 1620 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>();
                                           yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[0].location; }
#line 7274 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 508: // expressionList: expressionList "," expression
#line 1622 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[2].value.as < IR::Vector<IR::Expression>* > (); yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ()); yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 7280 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 509: // prefixedNonTypeName: nonTypeName
#line 1626 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Path* > () = new IR::Path(*yystack_[0].value.as < IR::ID* > ()); }
#line 7286 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 510: // prefixedNonTypeName: dotPrefix nonTypeName
#line 1627 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Path* > () = new IR::Path(*yystack_[0].value.as < IR::ID* > (), true);
                                           driver.structure->clearPath(); }
#line 7293 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 511: // $@22: %empty
#line 1632 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { driver.structure->relativePathFromLastSymbol(); }
#line 7299 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 512: // dot_name: "." $@22 name
#line 1632 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                                 {
          driver.structure->clearPath(); yylhs.value.as < IR::ID* > () = yystack_[0].value.as < IR::ID* > (); }
#line 7306 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 513: // lvalue: prefixedNonTypeName
#line 1637 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::PathExpression(yystack_[0].value.as < IR::Path* > ()); }
#line 7312 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 514: // lvalue: THIS
#line 1638 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::This(yystack_[0].location); }
#line 7318 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 515: // lvalue: lvalue dot_name
#line 1639 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[1].location + yystack_[0].location, yystack_[1].value.as < IR::Expression* > (), *yystack_[0].value.as < IR::ID* > ()); }
#line 7324 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 516: // lvalue: lvalue "[" expression "]"
#line 1640 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::ArrayIndex(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7330 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 517: // lvalue: lvalue "[" expression ":" expression "]"
#line 1641 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                               { yylhs.value.as < IR::Expression* > () = new IR::Slice(yystack_[5].location + yystack_[0].location, yystack_[5].value.as < IR::Expression* > (), yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7336 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 518: // lvalue: lvalue "[" expression "+" ":" expression "]"
#line 1642 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                   { yylhs.value.as < IR::Expression* > () = new IR::PlusSlice(yystack_[6].location + yystack_[0].location, yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7342 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 519: // lvalue: "(" lvalue ")"
#line 1643 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = yystack_[1].value.as < IR::Expression* > (); }
#line 7348 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 520: // expression: INTEGER
#line 1647 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0); }
#line 7354 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 521: // expression: "..."
#line 1648 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Dots(yystack_[0].location); }
#line 7360 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 522: // expression: STRING_LITERAL
#line 1649 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 7366 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 523: // expression: TRUE
#line 1650 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BoolLiteral(yystack_[0].location, true); }
#line 7372 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 524: // expression: FALSE
#line 1651 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BoolLiteral(yystack_[0].location, false); }
#line 7378 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 525: // expression: THIS
#line 1652 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::This(yystack_[0].location); }
#line 7384 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 526: // expression: prefixedNonTypeName
#line 1653 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::PathExpression(yystack_[0].value.as < IR::Path* > ()); }
#line 7390 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 527: // expression: expression "[" expression "]"
#line 1654 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::ArrayIndex(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7396 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 528: // expression: expression "[" expression ":" expression "]"
#line 1656 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Slice(yystack_[5].location + yystack_[0].location, yystack_[5].value.as < IR::Expression* > (), yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7402 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 529: // expression: expression "[" expression "+" ":" expression "]"
#line 1658 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::PlusSlice(yystack_[6].location + yystack_[0].location, yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7408 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 530: // expression: "{" expressionList optTrailingComma "}"
#line 1659 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                              { yylhs.value.as < IR::Expression* > () = new IR::ListExpression(yystack_[3].location + yystack_[0].location, *yystack_[2].value.as < IR::Vector<IR::Expression>* > ()); }
#line 7414 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 531: // expression: "{#}"
#line 1660 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Invalid(yystack_[0].location, IR::Type::Unknown::get()); }
#line 7420 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 532: // expression: "{" kvList optTrailingComma "}"
#line 1661 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::StructExpression(
                                                  yystack_[3].location + yystack_[0].location, IR::Type::Unknown::get(), (IR::Type_Name*)nullptr, *yystack_[2].value.as < IR::IndexedVector<IR::NamedExpression>* > ()); }
#line 7427 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 533: // expression: "{" kvList "," "..." optTrailingComma "}"
#line 1663 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                               {
                                           auto list = yystack_[4].value.as < IR::IndexedVector<IR::NamedExpression>* > ();
                                           list->push_back(new IR::NamedDots(yystack_[2].location));
                                           list->srcInfo = list->srcInfo + yystack_[2].location;
                                           yylhs.value.as < IR::Expression* > () = new IR::StructExpression(
                                                  yystack_[5].location + yystack_[2].location, IR::Type::Unknown::get(),
                                                  (IR::Type_Name*)nullptr, *list); }
#line 7439 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 534: // expression: "(" expression ")"
#line 1670 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = yystack_[1].value.as < IR::Expression* > (); }
#line 7445 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 535: // expression: "!" expression
#line 1671 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::LNot(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7451 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 536: // expression: "~" expression
#line 1672 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Cmpl(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7457 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 537: // expression: "-" expression
#line 1673 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Neg(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7463 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 538: // expression: "+" expression
#line 1674 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::UPlus(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7469 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 539: // expression: typeName dot_name
#line 1676 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[1].location + yystack_[0].location, new IR::TypeNameExpression(yystack_[1].location, yystack_[1].value.as < IR::Type_Name* > ()), *yystack_[0].value.as < IR::ID* > ()); }
#line 7475 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 540: // expression: ERROR "." name
#line 1678 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto typeName = new IR::Type_Name(yystack_[2].location, new IR::Path(IR::ID(yystack_[2].location, "error"_cs)));
          yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[2].location+yystack_[0].location, new IR::TypeNameExpression(yystack_[2].location+yystack_[0].location, typeName), *yystack_[0].value.as < IR::ID* > ()); }
#line 7482 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 541: // expression: expression dot_name
#line 1680 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[1].location + yystack_[0].location, yystack_[1].value.as < IR::Expression* > (), *yystack_[0].value.as < IR::ID* > ()); }
#line 7488 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 542: // expression: expression "*" expression
#line 1681 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Mul(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7494 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 543: // expression: expression "/" expression
#line 1682 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Div(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7500 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 544: // expression: expression "%" expression
#line 1683 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Mod(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7506 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 545: // expression: expression "+" expression
#line 1684 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Add(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7512 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 546: // expression: expression "-" expression
#line 1685 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Sub(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7518 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 547: // expression: expression "|+|" expression
#line 1686 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::AddSat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7524 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 548: // expression: expression "|-|" expression
#line 1687 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::SubSat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7530 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 549: // expression: expression "<<" expression
#line 1688 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Shl(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7536 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 550: // expression: expression R_ANGLE_SHIFT ">" expression
#line 1690 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Shr(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7542 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 551: // expression: expression "<=" expression
#line 1691 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Leq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7548 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 552: // expression: expression ">=" expression
#line 1692 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Geq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7554 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 553: // expression: expression l_angle expression
#line 1694 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Lss(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7560 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 554: // expression: expression ">" expression
#line 1695 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Grt(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7566 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 555: // expression: expression "!=" expression
#line 1696 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Neq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7572 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 556: // expression: expression "==" expression
#line 1697 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Equ(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7578 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 557: // expression: expression "&" expression
#line 1698 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BAnd(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7584 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 558: // expression: expression "^" expression
#line 1699 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BXor(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7590 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 559: // expression: expression "|" expression
#line 1700 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BOr(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7596 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 560: // expression: expression "++" expression
#line 1701 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Concat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7602 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 561: // expression: expression "&&" expression
#line 1702 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::LAnd(yystack_[2].location + yystack_[1].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7608 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 562: // expression: expression "||" expression
#line 1703 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::LOr(yystack_[2].location + yystack_[1].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7614 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 563: // expression: expression "?" expression ":" expression
#line 1704 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                               { yylhs.value.as < IR::Expression* > () = new IR::Mux(yystack_[4].location + yystack_[0].location, yystack_[4].value.as < IR::Expression* > (), yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7620 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 564: // expression: expression l_angle realTypeArgumentList r_angle "(" argumentList ")"
#line 1706 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::MethodCallExpression(yystack_[6].location + yystack_[3].location, yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Vector<IR::Type>* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7626 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 565: // expression: expression "(" argumentList ")"
#line 1708 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::MethodCallExpression(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7632 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 566: // expression: namedType "(" argumentList ")"
#line 1710 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::ConstructorCallExpression(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < ConstType* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7638 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 567: // expression: "(" typeRef ")" expression
#line 1711 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                              { yylhs.value.as < IR::Expression* > () = new IR::Cast(yystack_[3].location + yystack_[0].location, yystack_[2].value.as < ConstType* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7644 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 568: // nonBraceExpression: INTEGER
#line 1715 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0); }
#line 7650 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 569: // nonBraceExpression: STRING_LITERAL
#line 1716 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 7656 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 570: // nonBraceExpression: TRUE
#line 1717 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BoolLiteral(yystack_[0].location, true); }
#line 7662 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 571: // nonBraceExpression: FALSE
#line 1718 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::BoolLiteral(yystack_[0].location, false); }
#line 7668 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 572: // nonBraceExpression: THIS
#line 1719 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::This(yystack_[0].location); }
#line 7674 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 573: // nonBraceExpression: prefixedNonTypeName
#line 1720 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::PathExpression(yystack_[0].value.as < IR::Path* > ()); }
#line 7680 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 574: // nonBraceExpression: nonBraceExpression "[" expression "]"
#line 1721 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::ArrayIndex(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7686 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 575: // nonBraceExpression: nonBraceExpression "[" expression ":" expression "]"
#line 1723 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Slice(yystack_[5].location + yystack_[0].location, yystack_[5].value.as < IR::Expression* > (), yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7692 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 576: // nonBraceExpression: nonBraceExpression "[" expression "+" ":" expression "]"
#line 1725 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::PlusSlice(yystack_[6].location + yystack_[0].location, yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Expression* > ()); }
#line 7698 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 577: // nonBraceExpression: "(" expression ")"
#line 1726 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = yystack_[1].value.as < IR::Expression* > (); }
#line 7704 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 578: // nonBraceExpression: "!" expression
#line 1727 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::LNot(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7710 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 579: // nonBraceExpression: "~" expression
#line 1728 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Cmpl(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7716 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 580: // nonBraceExpression: "-" expression
#line 1729 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Neg(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7722 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 581: // nonBraceExpression: "+" expression
#line 1730 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::UPlus(yystack_[1].location + yystack_[0].location, yystack_[0].value.as < IR::Expression* > ()); }
#line 7728 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 582: // nonBraceExpression: typeName dot_name
#line 1732 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[1].location + yystack_[0].location, new IR::TypeNameExpression(yystack_[1].location, yystack_[1].value.as < IR::Type_Name* > ()), *yystack_[0].value.as < IR::ID* > ()); }
#line 7734 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 583: // nonBraceExpression: ERROR "." name
#line 1734 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { auto typeName = new IR::Type_Name(yystack_[2].location, new IR::Path(IR::ID(yystack_[2].location, "error"_cs)));
          yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[2].location+yystack_[0].location, new IR::TypeNameExpression(yystack_[2].location+yystack_[0].location, typeName), *yystack_[0].value.as < IR::ID* > ()); }
#line 7741 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 584: // nonBraceExpression: nonBraceExpression dot_name
#line 1736 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Member(yystack_[1].location + yystack_[0].location, yystack_[1].value.as < IR::Expression* > (), *yystack_[0].value.as < IR::ID* > ()); }
#line 7747 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 585: // nonBraceExpression: nonBraceExpression "*" expression
#line 1737 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Mul(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7753 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 586: // nonBraceExpression: nonBraceExpression "/" expression
#line 1738 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Div(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7759 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 587: // nonBraceExpression: nonBraceExpression "%" expression
#line 1739 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Mod(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7765 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 588: // nonBraceExpression: nonBraceExpression "+" expression
#line 1740 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Add(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7771 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 589: // nonBraceExpression: nonBraceExpression "-" expression
#line 1741 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Sub(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7777 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 590: // nonBraceExpression: nonBraceExpression "|+|" expression
#line 1742 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::AddSat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7783 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 591: // nonBraceExpression: nonBraceExpression "|-|" expression
#line 1743 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::SubSat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7789 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 592: // nonBraceExpression: nonBraceExpression "<<" expression
#line 1744 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Shl(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7795 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 593: // nonBraceExpression: nonBraceExpression R_ANGLE_SHIFT ">" expression
#line 1746 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::Shr(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7801 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 594: // nonBraceExpression: nonBraceExpression "<=" expression
#line 1747 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Leq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7807 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 595: // nonBraceExpression: nonBraceExpression ">=" expression
#line 1748 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Geq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7813 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 596: // nonBraceExpression: nonBraceExpression l_angle expression
#line 1750 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                         { yylhs.value.as < IR::Expression* > () = new IR::Lss(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7819 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 597: // nonBraceExpression: nonBraceExpression ">" expression
#line 1751 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Grt(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7825 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 598: // nonBraceExpression: nonBraceExpression "!=" expression
#line 1752 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Neq(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7831 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 599: // nonBraceExpression: nonBraceExpression "==" expression
#line 1753 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Equ(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7837 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 600: // nonBraceExpression: nonBraceExpression "&" expression
#line 1754 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::BAnd(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7843 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 601: // nonBraceExpression: nonBraceExpression "^" expression
#line 1755 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::BXor(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7849 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 602: // nonBraceExpression: nonBraceExpression "|" expression
#line 1756 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::BOr(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7855 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 603: // nonBraceExpression: nonBraceExpression "++" expression
#line 1757 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::Concat(yystack_[2].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7861 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 604: // nonBraceExpression: nonBraceExpression "&&" expression
#line 1758 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::LAnd(yystack_[2].location + yystack_[1].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7867 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 605: // nonBraceExpression: nonBraceExpression "||" expression
#line 1759 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                 { yylhs.value.as < IR::Expression* > () = new IR::LOr(yystack_[2].location + yystack_[1].location + yystack_[0].location, yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7873 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 606: // nonBraceExpression: nonBraceExpression "?" expression ":" expression
#line 1760 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                                       { yylhs.value.as < IR::Expression* > () = new IR::Mux(yystack_[4].location + yystack_[0].location, yystack_[4].value.as < IR::Expression* > (), yystack_[2].value.as < IR::Expression* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7879 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 607: // nonBraceExpression: nonBraceExpression l_angle realTypeArgumentList r_angle "(" argumentList ")"
#line 1762 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::MethodCallExpression(yystack_[6].location + yystack_[3].location, yystack_[6].value.as < IR::Expression* > (), yystack_[4].value.as < IR::Vector<IR::Type>* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7885 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 608: // nonBraceExpression: nonBraceExpression "(" argumentList ")"
#line 1764 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::MethodCallExpression(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < IR::Expression* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7891 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 609: // nonBraceExpression: namedType "(" argumentList ")"
#line 1766 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
        { yylhs.value.as < IR::Expression* > () = new IR::ConstructorCallExpression(yystack_[3].location + yystack_[0].location, yystack_[3].value.as < ConstType* > (), yystack_[1].value.as < IR::Vector<IR::Argument>* > ()); }
#line 7897 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 610: // nonBraceExpression: "(" typeRef ")" expression
#line 1767 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                              { yylhs.value.as < IR::Expression* > () = new IR::Cast(yystack_[3].location + yystack_[0].location, yystack_[2].value.as < ConstType* > (), yystack_[0].value.as < IR::Expression* > ()); }
#line 7903 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 611: // intOrStr: INTEGER
#line 1771 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Expression* > () = parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0); }
#line 7909 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 612: // intOrStr: STRING_LITERAL
#line 1772 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Expression* > () = new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()); }
#line 7915 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 613: // intList: INTEGER
#line 1776 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0));
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[0].location; }
#line 7923 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 614: // intList: intList "," INTEGER
#line 1779 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[2].value.as < IR::Vector<IR::Expression>* > ();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(parseConstant(yystack_[0].location, yystack_[0].value.as < UnparsedConstant > (), 0));
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 7931 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 615: // intOrStrList: intOrStr
#line 1785 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ());
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[0].location; }
#line 7939 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 616: // intOrStrList: intOrStrList "," intOrStr
#line 1788 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[2].value.as < IR::Vector<IR::Expression>* > ();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(yystack_[0].value.as < IR::Expression* > ());
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 7947 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 617: // strList: STRING_LITERAL
#line 1794 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::Expression>* > () = new IR::Vector<IR::Expression>();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()));
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[0].location; }
#line 7955 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;

  case 618: // strList: strList "," STRING_LITERAL
#line 1797 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
                                 { yylhs.value.as < IR::Vector<IR::Expression>* > () = yystack_[2].value.as < IR::Vector<IR::Expression>* > ();
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->push_back(new IR::StringLiteral(yystack_[0].location, yystack_[0].value.as < cstring > ()));
                                   yylhs.value.as < IR::Vector<IR::Expression>* > ()->srcInfo = yystack_[2].location + yystack_[0].location; }
#line 7963 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"
    break;


#line 7967 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  P4Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  P4Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  P4Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // P4Parser::context.
  P4Parser::context::context (const P4Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  P4Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  P4Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  P4Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short P4Parser::yypact_ninf_ = -1045;

  const short P4Parser::yytable_ninf_ = -324;

  const short
  P4Parser::yypact_[] =
  {
    1870, -1045,  2983,   385,   -77,   134,   -52,  2983,   -45,   134,
      18,  2983,    71,   111,  2983,   120,   128,   148,   284,   271,
   -1045,   563,  2983,  2983, -1045,  2983,  2554,  1815,  2983, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045,   237, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045,   462,   245, -1045,
     213, -1045,   246, -1045,  4900, -1045, -1045, -1045,   268,   277,
   -1045, -1045,   280, -1045, -1045, -1045,   287, -1045,   292,  4900,
   -1045, -1045, -1045,  3801,   299,   322,  3838,   327,   330,   333,
   -1045, -1045, -1045, -1045,  3423, -1045,   320,   294,   320,   320,
     317,  3423, -1045,   320,   320, -1045, -1045, -1045,  5115,   555,
   -1045,   340, -1045,   273, -1045,    13, -1045,   162, -1045,    78,
     314,   219, -1045, -1045, -1045,   377, -1045,   385, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045,   356, -1045, -1045, -1045,
     194,   194,   194,   141,   372,   381,   384,   237, -1045,   388,
     312,   129,  3875,   194,   385, -1045, -1045,  2290, -1045, -1045,
   -1045, -1045,  3280,  2983,  2983,  2983,  2983,  2983,  2983,  2983,
    2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,
    2983,  2983,  2983,   392,  2290,  2983,  2983, -1045,  1713,  2983,
     385,   313,   134,   324,  2983,   316,   334,  2983,   319,   335,
     -41, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045,   181,   -14,   385,   -13,  3280,   385, -1045,  3280,
     -12,   385,   130,   385,  3372,  3326,   385,   385,   130,   385,
     385,   385,   464, -1045, -1045,    78,   400, -1045,     2, -1045,
     414, -1045,   420,   421,    78, -1045,  2290,  2983,  2983,   320,
   -1045,  1097,   425,  2983,   426,  2983, -1045, -1045, -1045,   409,
     427,   432, -1045,  4900,   385, -1045, -1045, -1045, -1045, -1045,
     288,  4900,  5087,  5087,  1917,  5032,  5003,  5060,  5060,   341,
     341,   341,   341,   194,   194,   194,  5108,  5156,  5135,  3690,
    5087,  2983,   441,  3912,   341, -1045, -1045, -1045, -1045,   302,
    5087,  4900, -1045, -1045, -1045, -1045,  4900, -1045, -1045,  3949,
     443,   445,   320, -1045, -1045, -1045,  2554, -1045,  2983,   321,
   -1045,   180,  2983,   321,   321,   447,  1972,   288,  2983,   321,
     454,   385, -1045,   320, -1045,   385,   150,   435,   437,   438,
   -1045, -1045, -1045,   385, -1045, -1045, -1045,   123,   385,   385,
   -1045,  2290,   221,   458,   456, -1045, -1045, -1045, -1045,   463,
    3986,  4023, -1045, -1045,   385,   459, -1045, -1045,   194,  2620,
   -1045,  2290, -1045, -1045, -1045,  3280, -1045,  2686, -1045,  2983,
    1917, -1045,  2983,  3280,   466,  2983,   389,   391,   394,   467,
     384,  2081,  4060, -1045, -1045,   385,  4097, -1045, -1045,   385,
     472, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045,  4134, -1045,     2,   468,
     320,   480, -1045,   320, -1045, -1045,   320,   320, -1045,   320,
     320,   320, -1045, -1045,   475, -1045, -1045, -1045,   130, -1045,
      78,   464,   187, -1045,   385, -1045, -1045,   477, -1045,   359,
   -1045,   483, -1045,  4900, -1045, -1045,  2983,  4171,  4974, -1045,
    2290,  4900, -1045, -1045,   321,   385,   486,   489, -1045,   321,
   -1045,   321, -1045,  2190,   321,   485,  2983, -1045,   385,   493,
   -1045, -1045, -1045, -1045, -1045, -1045,   385,   385, -1045,    95,
     464, -1045, -1045,     1, -1045, -1045,    -3, -1045,   473, -1045,
      78,   108, -1045, -1045, -1045, -1045, -1045, -1045,  3089,    75,
       2,   385, -1045, -1045,  4208, -1045,   487, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045,    78,   482,  4900,   492,   447,   385,
     506,   509,   511,   507,   510,   512,   172,   502,   385,   320,
     290, -1045,   449, -1045,   505, -1045,   523, -1045,   385, -1045,
     307, -1045, -1045,   514,   516,   522,   547,  2741,   554,    41,
   -1045,   231,    15, -1045,   538, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
    5189,   528, -1045,   558, -1045, -1045, -1045, -1045, -1045,     2,
     565,   557,   561, -1045, -1045, -1045, -1045,     2,     2, -1045,
     528, -1045,  2983, -1045,   212,   505,  2983, -1045, -1045,   568,
     755,     9, -1045, -1045, -1045,  2983, -1045,  4245,  2983,   566,
     534,   535, -1045,  2983,   596,  2290,  2983,  2983,  2983,  2983,
    2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983, -1045,
    3280, -1045,   551, -1045,   571, -1045,  2983,   385,   578,    23,
      24,    29,   573,   576,    66,   560,  4900,   584,   321,   321,
     321, -1045, -1045,   -26, -1045,  4295, -1045,  4332,  3182,   581,
     582,  3727,  2983,   585,  4900,  4900,  4900,  4900,  4900,  4900,
    4900,  4900,  4900,  4900,  4900,  4900,  4900,   288, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045,  1613, -1045, -1045,   130, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045,   587,   592,   593,   588,
     594,   548,    21, -1045,  3243,   600,   464,   385, -1045,   580,
     598, -1045, -1045,  2290,  2290,  2807, -1045,  2983,  4900, -1045,
     603,  3124,  1338,   604,   586,   385,  1203,  2983,  2983,  2983,
     611,   615, -1045,   310, -1045, -1045,    33,   255,   605,   572,
   -1045,   385,    30,  2983,  3182,   618,   626,  2983,  4369,  2290,
   -1045,   555, -1045, -1045, -1045,   617,     2, -1045,   621,   591,
      90,   464, -1045, -1045,   640,   385, -1045, -1045, -1045, -1045,
   -1045, -1045,  4406,  4443,  4480, -1045, -1045, -1045,   636, -1045,
   -1045, -1045, -1045, -1045,   637,  3243,  3038,    86,  1815,  4517,
     464, -1045,   628,   630,  4567, -1045,   650, -1045,   651, -1045,
     653,   635, -1045, -1045, -1045,   385, -1045,   385,   385,   385,
      76,  2862,   663,  2983, -1045,  2983,  2983,  2983, -1045,  1815,
    2983, -1045, -1045, -1045, -1045,   652, -1045, -1045,   660,   213,
   -1045,   658, -1045,  4937,  1815, -1045,   661,  3636,   307, -1045,
   -1045, -1045, -1045,   644,  2983, -1045, -1045,   646,   649,   656,
   -1045,    14, -1045, -1045,  4604, -1045,   657,   194,   194,   194,
     669,  4641,   194,   385,  2290, -1045,    -4,  2983,  2983,  2983,
    2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,  2983,
    2983,  2983,  2983,  2983,  2983,  2983,   675,  2290,  2983,  2983,
   -1045,  1713,   678,  3243,  2983, -1045,   680,   692, -1045,    88,
    1313, -1045, -1045, -1045,   677,   698,   385,     3, -1045,  2983,
   -1045, -1045,   699, -1045,  5087,  5087,  1917,  5032,  5003,  5060,
    5060,   341,   341,   341,   341,   194,   194,   194,  5108,  5156,
    5135,  3764,  5087,  2983,   700,  4678,   341,   302,  5087,  3243,
   -1045,  4900,  3243,   307,   708, -1045, -1045,  2290,    78, -1045,
    2356, -1045,   194, -1045,  2928, -1045,  2983,  1917, -1045,  2983,
     705, -1045, -1045, -1045, -1045,   709,   686,  1557, -1045, -1045,
     706,   711, -1045, -1045,  2422,  3582,  2983,  4715,  4974,  2290,
    1451, -1045, -1045,   712,   715,   714,   717,  3528,    -9,    14,
     719,  2983,  2983,  4752, -1045,   722, -1045, -1045,   721, -1045,
    2488,  2983,  2983,  2983,   723,    78,    14,  4900,  4900, -1045,
   -1045,   385,   253, -1045,  4789,  4826,  4863, -1045,   710,    78,
     713, -1045,  2488,   725, -1045,   716, -1045, -1045, -1045, -1045
  };

  const short
  P4Parser::yydefact_[] =
  {
       0,    24,   506,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       3,    56,     0,     0,   531,     0,   506,     0,     0,   238,
     521,   523,   524,   525,    40,    38,    42,     0,    39,    43,
      44,    41,    37,   324,   522,   520,   509,     0,     0,   326,
     322,   323,     4,   526,   507,    46,    47,    45,     0,     5,
     210,   613,     6,   612,   611,   615,     7,   617,     8,     9,
      10,    11,    12,     0,     0,     0,     0,     0,     0,     0,
       1,     2,    23,    26,     0,   332,   335,   334,   337,     0,
     333,     0,   336,     0,     0,   345,   346,    25,     0,    57,
      58,     0,    33,     0,    30,   236,    32,   236,    28,    56,
     344,   317,   320,   321,   319,   318,   316,     0,    31,   364,
     369,   371,   370,   372,    34,    35,     0,    29,    27,    36,
     538,   537,   536,   324,   509,   276,   276,   334,   333,     0,
     317,   318,     0,   535,     0,   325,   510,   498,   619,   620,
     511,   539,   356,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   498,     0,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   116,   109,    85,   107,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    86,    87,    88,    89,    90,    91,    92,    93,
     114,   101,    94,    95,    96,    98,    97,    99,   100,   102,
     103,   104,   105,   106,   108,   110,   111,   112,   113,   115,
     117,   118,    60,     0,     0,     0,     0,     0,    65,   356,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,   334,    59,    56,   344,   368,    56,   366,
       0,   367,     0,     0,    57,   497,   498,     0,     0,   347,
     365,   277,     0,   277,     0,     0,   534,   540,   504,     0,
       0,   499,   500,   502,     0,   355,   354,   353,   352,   357,
       0,   508,   551,   552,   549,   561,   562,   555,   556,   545,
     546,   547,   548,   542,   543,   544,   559,   557,   558,     0,
     554,     0,     0,     0,   560,   361,   360,   359,   362,     0,
     553,   212,   211,   614,   616,   618,    13,    14,    15,     0,
       0,     0,     0,    20,    22,    19,   506,    65,     0,     0,
     394,     0,     0,     0,     0,   276,     0,     0,     0,     0,
       0,     0,   293,    46,   385,     0,   346,   304,     0,     0,
     344,   373,   379,     0,   223,   246,   376,     0,     0,     0,
     496,   498,   222,     0,   214,   215,   240,   296,   437,     0,
       0,     0,   311,   348,     0,   276,   532,   530,   567,     0,
     566,     0,   512,   621,   622,     0,   331,     0,   527,     0,
     550,   565,     0,     0,     0,     0,     0,     0,     0,   276,
     276,     0,     0,   338,   392,     0,     0,   339,   327,   277,
       0,   119,    64,   181,   180,   175,   176,   177,   179,   178,
     183,   185,   184,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    65,
     202,   203,   204,   205,   206,   207,   208,   209,   182,   168,
     173,   174,   161,   137,   159,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   138,   139,   140,   141,   142,   143,   144,   145,
     166,   153,   146,   147,   148,   150,   149,   151,   152,   154,
     155,   156,   157,   158,   160,   162,   163,   164,   165,   167,
     169,   170,   171,   172,    67,   328,     0,   340,    56,     0,
     347,     0,   387,   347,   308,   307,   347,   347,   398,   347,
     347,   347,   396,   397,     0,   219,   221,   220,     0,   237,
      56,    56,    56,   439,     0,   329,   330,     0,   350,     0,
     277,     0,   505,   503,   501,   358,     0,     0,   563,   363,
     498,    16,    17,    18,     0,   277,     0,     0,    61,     0,
     395,     0,   393,     0,     0,     0,     0,   294,     0,     0,
     305,   374,   380,   224,   247,   377,     0,     0,   216,     0,
      57,   243,   241,    56,   249,   245,     0,   244,     0,   242,
      56,     0,   301,   297,   300,   299,   302,   298,    56,     0,
      56,     0,   349,   533,     0,   528,     0,    21,    63,    62,
     341,   342,    66,   343,    56,     0,   495,     0,   276,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
       0,   239,     0,   250,   493,   489,     0,   303,     0,   438,
       0,   416,   514,     0,     0,     0,     0,     0,     0,     0,
     451,   317,   318,   426,     0,   429,   434,   431,   428,   432,
     433,   427,   450,   430,   435,   440,   436,   448,   449,   513,
       0,     0,   227,     0,   351,   529,   564,   488,   492,    56,
       0,     0,   276,   389,   309,   382,   382,    56,    56,   382,
       0,   226,     0,   251,     0,   493,     0,   491,   292,     0,
       0,     0,   422,   423,   417,     0,   418,     0,     0,     0,
       0,     0,   399,     0,     0,   498,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   515,
     356,   230,     0,   312,     0,   386,     0,   277,     0,    56,
      56,    56,     0,     0,    56,     0,   218,     0,     0,     0,
       0,   490,   494,    56,   519,     0,   419,     0,   455,     0,
       0,     0,     0,     0,   402,   406,   407,   403,   404,   405,
     413,   414,   415,   410,   411,   408,   409,     0,   232,   229,
     295,   391,   390,   388,   306,     0,   310,   375,     0,   383,
     381,   225,   248,   378,   228,   253,     0,     0,     0,     0,
       0,    54,    56,   469,    56,     0,     0,     0,   460,     0,
     456,   457,   459,   498,   498,     0,   516,     0,   412,   400,
       0,     0,     0,   324,     0,     0,    56,     0,     0,     0,
       0,     0,    55,     0,   468,   470,     0,     0,     0,   420,
     442,     0,   493,     0,     0,     0,     0,     0,     0,   498,
     231,     0,   235,   233,   234,     0,    56,   313,     0,     0,
       0,    57,   254,   260,     0,     0,   255,   257,   261,   256,
     258,   259,     0,     0,     0,   478,   475,    50,     0,    52,
      53,    51,    48,    49,     0,    56,     0,   493,     0,     0,
       0,   458,     0,     0,     0,   517,     0,   314,     0,   384,
       0,     0,   265,   267,   262,     0,   252,     0,     0,     0,
      56,     0,     0,     0,   421,     0,     0,     0,   441,     0,
       0,   570,   571,   572,   446,     0,   569,   568,     0,   322,
     443,     0,   573,   447,     0,   467,     0,   465,   461,   424,
     425,   518,   401,     0,   506,   266,   253,     0,     0,     0,
     472,     0,   471,   476,     0,   486,     0,   581,   580,   579,
       0,     0,   578,     0,   498,   582,   445,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   498,     0,     0,
     584,     0,     0,    56,     0,   463,     0,   462,   315,     0,
      56,   291,   290,   289,     0,   480,     0,    54,   474,     0,
     577,   583,     0,   444,   594,   595,   592,   604,   605,   598,
     599,   588,   589,   590,   591,   585,   586,   587,   602,   600,
     601,     0,   597,     0,     0,     0,   603,     0,   596,    56,
     453,   466,    56,     0,     0,   263,   479,   498,    56,   473,
       0,   487,   610,   609,     0,   574,     0,   593,   608,     0,
       0,   454,   452,   464,   269,     0,     0,     0,   288,   287,
      44,     0,   272,   273,     0,   284,     0,     0,   606,   498,
       0,   481,   477,   283,   282,     0,     0,   284,     0,     0,
       0,     0,     0,     0,   575,     0,   268,   270,     0,   275,
       0,     0,     0,     0,     0,    56,     0,   285,   286,   576,
     607,     0,     0,   278,   280,   281,     0,   484,     0,    56,
       0,   274,     0,     0,   483,     0,   271,   279,   485,   482
  };

  const short
  P4Parser::yypgoto_[] =
  {
   -1045, -1045, -1045, -1045, -1045, -1045, -1045,   201,   549, -1045,
    -244,   208,   -10,   -93,  -314,   701, -1045,   -16,  -173,  -515,
   -1045,   240, -1045, -1045, -1045, -1045,  -535,    85, -1045, -1045,
   -1045,   694,   234, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
     196, -1045,  -154, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1044, -1045,  -106, -1045, -1045,  -993, -1045, -1045, -1045,
   -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,   -80,
   -1045, -1045,   695,   -92, -1045,   345, -1045,    99, -1045,   905,
     101, -1045,  -108, -1045, -1045,  -195,  -246, -1045,  -192, -1045,
     559, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
    -384, -1045, -1045, -1045, -1045, -1045,    59, -1045, -1045,  -239,
   -1045,  -818,  -764,  -817, -1045, -1045,  -815, -1045, -1045,  -814,
    -806,   -94, -1045, -1045, -1045, -1045, -1045, -1045, -1045, -1045,
   -1045, -1045,   -44, -1045, -1045,  -131, -1045, -1045,     5, -1045,
   -1045, -1045,  -895, -1045, -1045, -1045,   272,  -508,  -744,   -17,
    -688,  -694,     0,    34, -1045,   424,   -25,  -578,   -48, -1045,
     168,    -2, -1045,    27, -1045, -1045, -1045,  1089,  -294
  };

  const short
  P4Parser::yydefgoto_[] =
  {
       0,    18,    19,   345,    20,    21,    97,    46,   289,   904,
     853,   382,   274,   100,   356,   242,   524,    59,    60,   383,
     384,   385,   548,   101,   539,   643,   102,   752,   798,   841,
     873,   270,    47,   104,   551,   602,   105,   540,   644,   603,
     604,   767,   846,   882,   883,   966,   884,   922,   923,  1100,
    1117,  1091,  1092,   282,  1132,  1105,  1093,   605,   106,   107,
     530,   637,   552,   613,   656,   108,   533,   640,   759,   109,
     557,   806,   298,    48,    49,    50,   112,   113,   114,    51,
     116,   117,   392,   393,   559,   299,   300,   328,   329,   118,
     119,   120,   536,   641,   121,   541,   645,   122,   537,   642,
     760,   809,   123,   531,   589,   702,   703,   124,   125,   351,
     126,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   553,   618,   684,   906,   950,   951,   685,   686,
     829,   830,   831,  1016,  1017,   956,   614,   822,   823,   931,
     973,   930,  1024,  1071,  1094,  1027,   127,   890,   608,   891,
     717,   635,   129,   290,   291,   292,    52,    53,   177,   294,
     690,   293,   953,    65,    62,    66,    68,   178,   406
  };

  const short
  P4Parser::yytable_[] =
  {
      54,   136,   151,   357,   128,    69,   264,   332,   355,    73,
     135,    99,    76,   585,   828,   275,   601,   612,   859,   265,
     130,   131,   772,   132,    54,   142,   143,   771,   886,   887,
     284,   888,   889,   421,   832,   414,    71,   348,   352,   358,
     689,   -56,  1123,   607,   616,   342,    84,   651,   276,  1069,
    1110,   354,   733,    61,  -213,   423,  1118,   819,   278,   427,
     428,   774,   801,   525,   268,   527,   150,   854,    84,   804,
     807,    29,   731,    84,    84,   810,   343,    67,   388,   820,
      34,    35,   689,   670,   269,    70,   388,    91,   716,   344,
      36,   852,   151,    84,  1106,    84,    84,    34,    35,   934,
     828,    84,    38,    55,   819,   693,    39,    36,   332,    91,
     687,    40,   813,    41,    91,    91,   349,   353,   359,    38,
     832,  1124,   970,    39,    42,    56,   820,  1133,    40,   252,
      41,   729,   908,   691,    91,   924,    91,    91,    84,   729,
    1064,    42,    91,   153,   716,   583,   692,    72,    84,  1147,
      84,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   380,   278,   323,   324,   369,   330,   331,   252,    91,
    -323,   264,   336,   252,   754,   339,   -47,    29,   954,    91,
     251,    91,   762,   763,  1015,   -37,   252,   -37,   -37,   -47,
     689,    74,   886,   887,    57,   888,   889,  1060,   322,   334,
     565,   648,   -47,   268,  1125,    85,    86,   254,   569,   771,
     649,   -37,   256,   257,   346,   263,   424,   134,   658,    98,
     710,  1139,   347,   271,    88,   425,    89,   171,   138,   976,
      75,   261,   149,   711,    29,   174,   689,    92,   146,   430,
      77,   150,    93,  1081,    94,   103,  1082,    78,    43,    84,
     148,   149,   277,    63,    64,   622,   148,   149,   689,    29,
     150,   610,    85,    86,   277,   390,   391,    79,   148,   149,
     627,   301,   263,   398,    80,   630,   689,   631,   730,   561,
     633,    88,    81,    89,   144,   138,   147,    85,    86,  1083,
      91,   153,   148,   149,    92,  1141,   872,   263,  1142,    93,
     389,    94,   730,   576,   577,    43,    88,   273,    57,   410,
     138,   420,   761,   545,   546,   764,   179,   689,   952,    92,
     419,   547,   180,   103,    93,   181,    94,   403,   404,   244,
      43,   381,   182,   405,    54,    57,   422,   183,   134,   638,
     426,   403,   404,   297,   185,   277,   526,   413,   660,   148,
     149,   918,   247,  -322,    29,   276,   111,   148,   149,   150,
     403,   404,   140,    34,    35,   134,   165,   186,   166,   167,
     689,    57,   188,    36,   171,   189,   103,   662,   190,   149,
      34,    35,   174,  1025,   897,    38,    55,   563,   150,    39,
      36,   145,   332,   898,    40,   309,    41,   567,   403,   404,
     568,   267,    38,   571,   621,   544,    39,    42,    56,   899,
     278,    40,   587,    41,   900,   590,   901,   280,   591,   592,
     -45,   593,   594,   595,    42,   689,   281,   902,   903,   283,
     285,   321,   689,   333,   111,    57,   337,   297,    57,   340,
     297,   381,    57,   335,    57,    57,   367,    57,    57,   386,
      57,    57,    57,   338,   341,   387,   388,   399,    34,    35,
     377,   396,   397,   273,   816,   817,   818,   134,    36,   400,
     103,   689,    57,   103,   689,   689,   103,   401,   103,   103,
      38,    55,   103,   411,    39,    57,   103,   111,   416,    40,
     417,    41,   429,   840,   797,   528,   -45,   264,   534,   535,
     549,   550,    42,    56,   560,   554,   657,   570,   582,   572,
     573,    29,   575,   140,   574,   588,   586,   596,   620,   623,
     628,  1025,   700,   629,   609,   617,    84,   634,   639,   696,
     697,   600,   600,   699,   655,    34,    35,   134,  1025,    85,
      86,   704,    58,   698,   705,    36,   706,   709,   707,   263,
     712,   708,    57,   716,   624,   648,    57,    38,    88,   718,
      89,    39,   138,   751,    57,    58,    40,    91,    41,    57,
      57,    92,   134,    82,   636,   722,    93,   723,    94,    42,
     145,   111,    43,   724,   111,    57,   758,   111,   725,   111,
     111,   688,   134,   111,   626,   728,   297,   111,   600,   732,
     753,   755,    29,   773,   297,   756,   757,   778,   779,   780,
      29,   782,   799,   800,   803,   811,    57,    84,   812,   815,
      57,   814,   833,   834,    83,    84,   852,   839,   847,   103,
      85,    86,   749,   848,   849,   860,   850,   103,    85,    86,
     263,   863,   851,   864,   869,   876,   895,   877,    87,    88,
     896,    89,   731,   138,   905,   727,   279,    88,    91,    89,
     912,    90,    92,   749,    34,    35,    91,    93,   913,    94,
      92,    95,    96,    43,    36,    93,   926,    94,   917,    95,
      96,    43,   919,   287,   932,   933,    38,    55,   920,   959,
      39,   960,   962,   963,   964,    40,   965,    41,   975,   983,
     766,   984,   986,  1013,   636,  1018,   110,  1021,    42,    56,
    1022,  1029,   139,   775,  1053,   844,   777,  1023,  1028,    58,
    1059,   781,  1062,   264,   784,   785,   786,   787,   788,   789,
     790,   791,   792,   793,   794,   795,   796,  1063,  1066,  1067,
     111,  1073,  1078,  1084,   636,    57,  1099,  1102,   111,   599,
     611,  1101,   875,  1080,  1108,  1109,  1119,  -288,   826,   783,
    -287,   134,  1120,  1126,  1130,  1131,    57,  1137,   264,  1148,
     838,  1144,   103,  1070,  1146,   103,   103,  1149,   264,    57,
     598,   265,   248,   350,   266,   765,   350,    57,    57,   653,
     360,   272,   362,   364,   368,   371,   372,    57,   374,   375,
     376,   652,  1020,   769,   948,   770,   802,   264,   273,  1057,
     911,   379,    57,  1012,   615,   564,   669,   855,   721,     0,
      58,   871,     0,   309,   103,   868,   881,     0,    34,    35,
      57,   874,   273,   402,     0,   892,   893,   894,    36,    57,
       0,    57,     0,     0,   910,     0,     0,     0,     0,    57,
      38,   909,     0,     0,    39,   914,     0,   865,   866,    40,
       0,    41,     0,   327,     0,     0,     0,     0,     0,     0,
       0,     0,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1033,   111,   720,    58,   111,   111,     0,     0,
       0,   985,     0,   916,     0,  1010,   957,     0,     0,     0,
     529,     0,     0,     0,   532,     0,     0,     0,     0,     0,
       0,   146,   538,     0,     0,     0,   115,   542,   543,   974,
       0,   636,   141,   977,   978,   979,   134,   981,   982,  1019,
       0,     0,     0,   558,     0,   111,     0,   361,   103,   365,
     370,   297,   957,   373,     0,     0,     0,   378,    57,     0,
       0,     0,    54,   671,     0,     0,     0,   805,   808,   808,
       0,     0,   808,     0,   580,     0,     0,     0,   580,     0,
       0,   821,     0,     0,   103,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,   115,     0,  1055,  1056,     0,  1058,
     881,     0,  1061,     0,     0,     0,     0,     0,  1032,     0,
       0,     0,     0,     0,     0,     0,     0,  1072,    57,     0,
     821,     0,   856,     0,   134,   134,     0,     0,     0,   103,
       0,  1054,   103,     0,     0,     0,    57,     0,     0,     0,
       0,  1077,     0,     0,   880,     0,     0,   115,     0,   768,
     103,     0,    57,     0,     0,     0,     0,     0,  1095,     0,
     134,     0,   309,     0,  1097,   103,   103,  1098,     0,     0,
      57,     0,     0,   141,     0,  1107,    57,     0,     0,     0,
       0,     0,  1095,     0,  1113,   111,     0,     0,  1095,     0,
       0,  1085,     0,   619,     0,   103,     0,     0,     0,  1127,
    1128,     0,     0,   856,     0,   103,     0,     0,  1095,  1134,
    1135,  1136,     0,   111,    58,     0,    57,     0,    57,    57,
      57,     0,     0,  1115,     0,     0,     0,   350,   971,   152,
    1095,     0,     0,     0,   103,   646,   647,     0,     0,     0,
     111,   115,     0,   111,   115,   654,     0,   115,     0,   115,
     115,     0,     0,   115,     0,     0,     0,   115,     0,   857,
     694,   111,     0,   395,     0,   243,     0,   245,   246,     0,
      34,    35,   249,   250,    57,   134,   111,   111,   701,     0,
      36,   671,   720,     0,   273,     0,     0,   713,     0,   715,
     152,     0,    38,    55,     0,   720,    39,   719,   134,   111,
       0,    40,     0,    41,     0,     0,   111,     0,     0,     0,
       0,   856,     0,     0,    42,    56,   111,    57,   880,   152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   597,     0,     0,   606,   606,     0,  -264,
     857,   949,     0,   140,   660,   111,     0,     0,     0,     0,
      29,     0,     0,     0,     0,     0,     0,   856,   134,     0,
     856,     0,     0,     0,   661,    84,  1086,     0,     0,     0,
       0,     0,     0,   662,   140,     0,    34,    35,    85,    86,
       0,     0,     0,     0,     0,   650,    36,   720,   263,   140,
     134,     0,     0,     0,   666,     0,   701,    88,    38,    89,
     115,   138,    39,   606,     0,     0,    91,    40,   115,    41,
      92,     0,     0,     0,   879,    93,     0,    94,     0,     0,
      42,    43,    57,  1138,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,     0,     0,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,   140,     0,   857,  1065,
     720,     0,     0,     0,   660,   671,     0,     0,   394,     0,
      29,     0,     0,     0,     0,     0,   862,     0,     0,     0,
       0,     0,     0,     0,   661,    84,     0,     0,     0,     0,
       0,     0,     0,   662,   878,    29,    34,    35,    85,    86,
       0,     0,     0,     0,   857,     0,    36,   857,   263,     0,
     907,     0,     0,     0,   666,     0,     0,    88,    38,    89,
       0,   138,    39,    85,    86,     0,    91,    40,   921,    41,
      92,   418,   140,   263,   654,    93,     0,    94,     0,     0,
      42,    43,    88,     0,    89,     0,   138,     0,     0,     0,
       0,     0,   246,   115,     0,    92,   115,   115,     0,     0,
      93,     0,    94,     0,    95,    96,    43,     0,     0,     0,
       0,     0,     0,   827,   715,     0,   967,   968,   969,     0,
       0,     0,    22,    23,     0,     0,     0,    24,     0,     0,
       0,     0,     0,    25,     0,     0,    26,  1116,     0,     0,
     370,     0,  1087,   845,    28,   115,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   861,     0,   672,     0,  1088,     0,    30,     0,    31,
      32,    33,  1031,     0,    34,    35,   110,   370,     0,     0,
       0,   885,  1089,     0,    36,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    38,     0,     0,   885,
      39,     0,     0,     0,     0,    40,   266,    41,     0,     0,
       0,     0,     0,     0,     0,  1068,   925,     0,    42,    43,
      44,    45,     0,     0,     0,     0,     0,     0,    22,    23,
       0,     0,     0,    24,     0,     0,     0,     0,     0,    25,
       0,     0,    26,   955,     0,   925,     0,     0,    27,     0,
      28,     0,     0,     0,    29,     0,     0,     0,     0,   394,
       0,     0,   394,     0,     0,   394,   394,     0,   394,   394,
     394,  1103,     0,    30,   980,    31,    32,    33,     0,     0,
      34,    35,    85,    86,     0,     0,     0,     0,  1104,   955,
      36,     0,   137,     0,     0,   115,     0,     0,     0,     0,
       0,    88,    38,    89,     0,   138,    39,     0,     0,     0,
      29,    40,     0,    41,    92,     0,     0,     0,     0,    93,
    1140,    94,     0,   115,    42,    43,    44,    45,     0,     0,
       0,     0,     0,     0,   842,     0,     0,     0,    85,    86,
       0,     0,     0,     0,     0,     0,   327,     0,   263,     0,
     115,     0,     0,   115,     0,   885,     0,    88,     0,    89,
       0,   138,     0,     0,     0,     0,     0,     0,     0,   858,
      92,   115,     0,     0,     0,    93,     0,    94,   714,    95,
      96,   843,     0,     0,    22,    23,   115,   115,     0,    24,
       0,   672,     0,     0,     0,    25,     0,     0,    26,     0,
     152,     0,     0,     0,    27,     0,    28,     0,     0,   115,
      29,     0,     0,     0,     0,     0,   115,     0,     0,   750,
       0,     0,   139,     0,     0,     0,   115,   325,     0,    30,
       0,    31,    32,    33,     0,     0,    34,    35,    85,    86,
       0,     0,     0,     0,     0,     0,    36,     0,   137,     0,
     858,     0,     0,   141,     0,   115,     0,    88,    38,    89,
       0,   138,    39,     0,     0,     0,     0,    40,     0,    41,
      92,     0,     0,     0,     0,    93,     0,    94,     0,   326,
      42,    43,    44,    45,   141,     0,    22,    23,     0,     0,
       0,    24,     0,     0,     0,     0,     0,    25,     0,   141,
      26,     0,     0,     0,     0,     0,    27,     0,    28,     0,
       0,     0,    29,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
       0,    30,     0,    31,    32,    33,     0,     0,    34,    35,
      85,    86,     0,     0,     0,     0,     0,     0,    36,     0,
     137,     0,     0,     0,     0,     0,   141,     0,   858,    88,
      38,    89,     0,   138,    39,   672,     0,     0,     0,    40,
       0,    41,    92,     0,     0,     0,     0,    93,     0,    94,
       0,     0,    42,    43,    44,    45,   152,     0,   161,   162,
     163,   164,   165,     0,   166,   167,     0,     0,     0,     0,
     171,     0,     0,     0,   858,   149,     0,   858,   174,     0,
       0,     0,     0,     0,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     176,     0,   141,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,     0,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,   464,
     465,     0,     0,     0,     0,     0,     0,     0,   152,     0,
       0,     0,  1011,   466,   467,   468,   469,   470,     0,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,     0,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   431,     0,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,     0,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   578,   460,   461,   462,   463,   464,   465,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,   467,   468,   469,   470,     0,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,     0,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   431,     0,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,     0,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   632,   460,   461,   462,   463,   464,   465,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,     0,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,     0,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,    22,    23,     0,     0,     0,    24,     0,     0,     0,
       0,     0,    25,     0,     0,    26,     0,     0,     0,     0,
       0,    27,     0,    28,     0,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   288,     0,    30,     0,    31,    32,
      33,     0,     0,    34,    35,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    22,    23,     0,
       0,     0,    24,     0,     0,    38,    55,     0,    25,    39,
       0,    26,     0,     0,    40,     0,    41,  1087,     0,    28,
       0,     0,     0,    29,     0,     0,     0,    42,   133,    44,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1088,     0,    30,     0,    31,    32,    33,     0,     0,    34,
      35,     0,     0,     0,     0,     0,     0,  1089,     0,    36,
       0,    37,     0,    22,    23,     0,     0,     0,    24,     0,
       0,    38,     0,     0,    25,    39,     0,    26,     0,     0,
    1090,     0,    41,  1087,     0,    28,     0,     0,     0,    29,
       0,     0,     0,    42,    43,    44,    45,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1088,     0,    30,     0,
      31,    32,    33,     0,     0,    34,    35,     0,     0,     0,
       0,     0,     0,  1089,     0,    36,     0,    37,     0,    22,
      23,     0,     0,     0,    24,     0,     0,    38,     0,     0,
      25,    39,     0,    26,     0,     0,    40,     0,    41,    27,
       0,    28,     0,     0,     0,    29,     0,     0,     0,    42,
      43,    44,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,    30,     0,    31,    32,    33,     0,
       0,    34,    35,     0,     0,     0,     0,     0,     0,  1089,
       0,    36,     0,    37,     0,    22,    23,     0,     0,     0,
      24,     0,     0,    38,     0,     0,    25,    39,     0,    26,
       0,     0,    40,     0,    41,    27,     0,    28,     0,     0,
       0,    29,     0,     0,     0,    42,    43,    44,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      30,     0,    31,    32,    33,     0,     0,    34,    35,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,    37,
       0,    22,    23,     0,     0,     0,    24,     0,     0,    38,
      55,     0,    25,    39,     0,    26,     0,     0,    40,     0,
      41,    27,     0,    28,     0,     0,     0,    29,     0,     0,
       0,    42,   133,    44,    45,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   562,     0,    30,     0,    31,    32,
      33,     0,     0,    34,    35,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    37,     0,    22,    23,     0,
       0,     0,    24,     0,     0,    38,     0,     0,    25,    39,
       0,    26,     0,     0,    40,     0,    41,    27,     0,    28,
     566,     0,     0,    29,     0,     0,     0,    42,    43,    44,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,     0,    31,    32,    33,     0,     0,    34,
      35,     0,    22,    23,     0,     0,     0,    24,     0,    36,
       0,    37,     0,    25,     0,     0,    26,     0,     0,     0,
       0,    38,    27,     0,    28,    39,     0,     0,    29,     0,
      40,     0,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   726,    42,    43,    44,    45,    30,     0,    31,
      32,    33,     0,     0,    34,    35,     0,     0,     0,     0,
       0,     0,     0,     0,    36,     0,    37,     0,    22,    23,
       0,     0,     0,    24,     0,     0,    38,     0,     0,    25,
      39,     0,    26,     0,     0,    40,     0,    41,    27,     0,
      28,   867,     0,     0,    29,     0,     0,     0,    42,    43,
      44,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    30,     0,    31,    32,    33,     0,     0,
      34,    35,     0,    22,    23,     0,     0,     0,    24,     0,
      36,     0,    37,     0,    25,     0,     0,    26,   972,     0,
       0,     0,    38,    27,     0,    28,    39,     0,     0,    29,
       0,    40,     0,    41,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    42,    43,    44,    45,    30,     0,
      31,    32,    33,     0,     0,    34,    35,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,    37,     0,    22,
      23,     0,     0,     0,    24,     0,     0,    38,     0,     0,
      25,    39,     0,    26,     0,     0,    40,     0,    41,    27,
       0,    28,  1096,     0,     0,    29,     0,     0,     0,    42,
      43,    44,    45,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,     0,    31,    32,    33,     0,
       0,    34,    35,     0,    22,    23,     0,     0,     0,    24,
       0,    36,     0,    37,     0,    25,     0,     0,    26,     0,
       0,     0,     0,    38,    27,     0,    28,    39,     0,     0,
      29,     0,    40,     0,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,    43,    44,    45,    30,
       0,    31,    32,    33,     0,     0,    34,    35,     0,   935,
     936,     0,     0,     0,     0,     0,    36,     0,    37,     0,
     937,     0,     0,     0,   938,     0,     0,     0,    38,   939,
       0,   940,    39,     0,     0,    29,     0,    40,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,    43,    44,    45,     0,     0,   941,   942,   943,     0,
       0,    34,    35,     0,     0,     0,     0,     0,     0,   944,
       0,    36,     0,   945,     0,   659,     0,     0,     0,     0,
     660,     0,     0,    38,     0,     0,    29,    39,     0,     0,
       0,     0,    40,     0,    41,     0,     0,     0,     0,     0,
     661,    84,     0,     0,     0,    42,    43,   946,   947,   662,
     870,     0,    34,    35,    85,    86,   663,     0,   664,     0,
       0,    29,    36,     0,   263,   665,     0,     0,     0,     0,
     666,     0,     0,    88,    38,    89,    84,   138,    39,     0,
       0,     0,    91,    40,   667,    41,    92,     0,   668,    85,
      86,    93,     0,    94,     0,     0,    42,    43,     0,   263,
       0,     0,     0,     0,     0,     0,     0,     0,    88,     0,
      89,     0,   138,   660,     0,     0,     0,    91,     0,    29,
       0,    92,     0,     0,     0,     0,    93,     0,    94,     0,
      95,    96,    43,     0,    84,     0,     0,     0,     0,     0,
       0,     0,   662,     0,     0,    34,    35,    85,    86,     0,
       0,     0,     0,     0,     0,    36,     0,   263,     0,     0,
       0,     0,     0,     0,     0,     0,    88,    38,    89,     0,
     138,    39,     0,     0,   660,    91,    40,     0,    41,    92,
      29,     0,     0,     0,    93,     0,    94,     0,     0,    42,
      43,     0,     0,     0,   661,    84,     0,     0,     0,     0,
       0,     0,     0,   662,     0,     0,    34,    35,     0,     0,
     663,     0,   664,     0,     0,     0,    36,    29,     0,   665,
       0,     0,     0,     0,   666,     0,     0,     0,    38,     0,
       0,     0,    39,     0,   295,     0,    91,    40,   667,    41,
       0,     0,   668,    34,    35,    85,    86,     0,     0,     0,
      42,    43,     0,    36,     0,   263,     0,     0,     0,     0,
       0,     0,     0,    29,    88,    38,    89,     0,   138,    39,
       0,     0,     0,     0,    40,     0,    41,    92,     0,     0,
       0,     0,    93,     0,    94,     0,   296,    42,    43,    34,
      35,    85,    86,     0,     0,     0,     0,     0,     0,    36,
       0,   263,     0,     0,     0,     0,     0,     0,     0,    29,
      88,    38,   363,     0,   138,    39,     0,     0,     0,     0,
      40,     0,    41,    92,     0,     0,     0,     0,    93,     0,
      94,     0,    95,   366,   133,    34,    35,    85,    86,     0,
       0,     0,     0,     0,     0,    36,     0,   263,     0,     0,
       0,     0,     0,     0,     0,     0,    88,    38,   363,     0,
     138,    39,     0,     0,     0,     0,    40,     0,    41,    92,
       0,     0,     0,     0,    93,     0,    94,   191,     0,    42,
     133,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,     0,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,     0,   166,   167,   168,   169,   170,
       0,   171,     0,     0,     0,   148,   149,   172,   173,   174,
     286,     0,     0,     0,   175,   150,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   176,     0,  1121,     0,  1122,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,     0,   166,
     167,   168,   169,   170,     0,   171,     0,     0,     0,   148,
     149,   172,   173,   174,     0,     0,     0,     0,   175,   150,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   176,     0,  1111,     0,  1112,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,     0,   166,   167,   168,   169,   170,     0,   171,
       0,     0,     0,   148,   149,   172,   173,   174,     0,     0,
       0,     0,   175,   150,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   176,
       0,     0,     0,  1014,   154,   155,   156,   157,   158,   159,
     160,   407,   162,   163,   164,   165,     0,   166,   167,   168,
     169,   170,     0,   171,   408,     0,     0,   148,   149,   172,
     173,   174,     0,     0,   409,     0,   175,   150,     0,     0,
       0,   154,   155,   156,   157,   158,   159,   160,   835,   162,
     163,   164,   165,   176,   166,   167,   168,   169,   170,     0,
     171,   836,     0,     0,   148,   149,   172,   173,   174,     0,
       0,   837,     0,   175,   150,     0,     0,     0,   154,   155,
     156,   157,   158,   159,   160,  1074,   162,   163,   164,   165,
     176,   166,   167,   168,   169,   170,     0,   171,  1075,     0,
       0,   148,   149,   172,   173,   174,     0,     0,  1076,     0,
     175,   150,     0,     0,     0,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   176,   166,   167,
     168,   169,   170,     0,   171,     0,     0,     0,   148,   149,
     172,   173,   174,     0,     0,     0,   184,   175,   150,     0,
       0,     0,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   176,   166,   167,   168,   169,   170,
       0,   171,     0,     0,     0,   148,   149,   172,   173,   174,
       0,     0,     0,   187,   175,   150,     0,     0,     0,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   176,   166,   167,   168,   169,   170,     0,   171,     0,
       0,     0,   148,   149,   172,   173,   174,   286,     0,     0,
       0,   175,   150,     0,     0,     0,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   176,   166,
     167,   168,   169,   170,     0,   171,     0,     0,     0,   148,
     149,   172,   173,   174,     0,     0,   412,     0,   175,   150,
       0,     0,     0,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   176,   166,   167,   168,   169,
     170,     0,   171,     0,     0,     0,   148,   149,   172,   173,
     174,     0,     0,     0,   415,   175,   150,     0,     0,     0,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   176,   166,   167,   168,   169,   170,     0,   171,
     555,     0,     0,   148,   149,   172,   173,   174,     0,     0,
       0,     0,   175,   150,     0,     0,     0,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   176,
     166,   167,   168,   169,   170,     0,   171,   556,     0,     0,
     148,   149,   172,   173,   174,     0,     0,     0,     0,   175,
     150,     0,     0,     0,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   176,   166,   167,   168,
     169,   170,     0,   171,     0,     0,     0,   148,   149,   172,
     173,   174,   579,     0,     0,     0,   175,   150,     0,     0,
       0,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   176,   166,   167,   168,   169,   170,     0,
     171,     0,     0,     0,   148,   149,   172,   173,   174,   581,
       0,     0,     0,   175,   150,     0,     0,     0,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     176,   166,   167,   168,   169,   170,     0,   171,     0,     0,
       0,   148,   149,   172,   173,   174,   584,     0,     0,     0,
     175,   150,     0,     0,     0,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   176,   166,   167,
     168,   169,   170,     0,   171,   625,     0,     0,   148,   149,
     172,   173,   174,     0,     0,     0,     0,   175,   150,     0,
       0,     0,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   176,   166,   167,   168,   169,   170,
       0,   171,   695,     0,     0,   148,   149,   172,   173,   174,
       0,     0,     0,     0,   175,   150,     0,     0,     0,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   176,   166,   167,   168,   169,   170,     0,   171,     0,
       0,     0,   148,   149,   172,   173,   174,     0,     0,     0,
       0,   175,   150,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   776,     0,   176,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,   166,   167,   168,   169,   170,     0,   171,     0,
       0,     0,   148,   149,   172,   173,   174,   824,     0,     0,
       0,   175,   150,     0,     0,     0,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   176,   166,
     167,   168,   169,   170,     0,   171,     0,     0,     0,   148,
     149,   172,   173,   174,   825,     0,     0,     0,   175,   150,
       0,     0,     0,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   176,   166,   167,   168,   169,
     170,     0,   171,   915,     0,     0,   148,   149,   172,   173,
     174,     0,     0,     0,     0,   175,   150,     0,     0,     0,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   176,   166,   167,   168,   169,   170,     0,   171,
       0,     0,     0,   148,   149,   172,   173,   174,   927,     0,
       0,     0,   175,   150,     0,     0,     0,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   176,
     166,   167,   168,   169,   170,     0,   171,     0,     0,     0,
     148,   149,   172,   173,   174,   928,     0,     0,     0,   175,
     150,     0,     0,     0,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   176,   166,   167,   168,
     169,   170,     0,   171,     0,     0,     0,   148,   149,   172,
     173,   174,   929,     0,     0,     0,   175,   150,     0,     0,
       0,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   176,   166,   167,   168,   169,   170,     0,
     171,     0,     0,     0,   148,   149,   172,   173,   174,     0,
       0,     0,     0,   175,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   958,     0,
     176,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,     0,   166,   167,   168,   169,   170,     0,
     171,   961,     0,     0,   148,   149,   172,   173,   174,     0,
       0,     0,     0,   175,   150,     0,     0,     0,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     176,   166,   167,   168,   169,   170,     0,   171,     0,     0,
       0,   148,   149,   172,   173,   174,     0,     0,  1026,     0,
     175,   150,     0,     0,     0,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   176,   166,   167,
     168,   169,   170,     0,   171,     0,     0,     0,   148,   149,
     172,   173,   174,  1030,     0,     0,     0,   175,   150,     0,
       0,     0,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   176,   166,   167,   168,   169,   170,
       0,   171,     0,     0,     0,   148,   149,   172,   173,   174,
       0,     0,  1079,     0,   175,   150,     0,     0,     0,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   176,   166,   167,   168,   169,   170,     0,   171,  1114,
       0,     0,   148,   149,   172,   173,   174,     0,     0,     0,
       0,   175,   150,     0,     0,     0,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   176,   166,
     167,   168,   169,   170,     0,   171,  1129,     0,     0,   148,
     149,   172,   173,   174,     0,     0,     0,     0,   175,   150,
       0,     0,     0,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   176,   166,   167,   168,   169,
     170,     0,   171,     0,     0,     0,   148,   149,   172,   173,
     174,     0,     0,     0,  -285,   175,   150,     0,     0,     0,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   176,   166,   167,   168,   169,   170,     0,   171,
       0,     0,     0,   148,   149,   172,   173,   174,     0,     0,
       0,  -286,   175,   150,     0,     0,     0,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   176,
     166,   167,   168,   169,   170,     0,   171,     0,     0,     0,
     148,   149,   172,   173,   174,  1143,     0,     0,     0,   175,
     150,     0,     0,     0,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   176,   166,   167,   168,
     169,   170,     0,   171,     0,     0,     0,   148,   149,   172,
     173,   174,     0,     0,     0,     0,   175,   150,     0,     0,
       0,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   176,   999,  1000,  1001,  1002,  1003,     0,
    1004,     0,     0,     0,   148,   149,  1005,  1006,  1007,     0,
       0,     0,     0,  1008,   150,     0,     0,     0,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
    1009,   166,   167,   168,   169,   170,     0,   171,     0,     0,
       0,   148,   149,   172,   173,   174,     0,   154,   155,   156,
     157,   150,   159,   160,   161,   162,   163,   164,   165,     0,
     166,   167,   168,   169,   170,     0,   171,   176,     0,     0,
     148,   149,   172,   173,   174,     0,   154,   155,   156,     0,
     150,   159,   160,   161,   162,   163,   164,   165,     0,   166,
     167,   168,   169,   170,     0,   171,   176,     0,     0,   148,
     149,   172,   173,   174,   154,   155,   156,     0,     0,   150,
       0,   161,   162,   163,   164,   165,     0,   166,   167,   168,
     169,   170,     0,   171,     0,   176,     0,   148,   149,   172,
     173,   174,     0,   156,     0,     0,     0,   150,   161,   162,
     163,   164,   165,     0,   166,   167,   168,   169,   170,     0,
     171,     0,     0,   176,   156,   149,     0,   173,   174,   161,
     162,   163,   164,   165,   150,   166,   167,     0,   169,   170,
       0,   171,     0,     0,     0,     0,   149,     0,   173,   174,
     176,   156,     0,     0,     0,   150,   161,   162,   163,   164,
     165,     0,   166,   167,     0,   169,     0,     0,   171,     0,
       0,   176,   156,   149,     0,   173,   174,   161,   162,   163,
     164,   165,   150,   166,   167,     0,     0,   251,     0,   171,
       0,     0,     0,   252,   149,   253,   173,   174,   176,   254,
       0,     0,   255,   150,   256,   257,     0,     0,     0,     0,
       0,     0,     0,     0,   258,     0,   259,   260,     0,   176,
       0,     0,   733,   261,     0,     0,   148,   149,   262,   734,
     735,     0,     0,     0,     0,     0,   150,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748
  };

  const short
  P4Parser::yycheck_[] =
  {
       2,    26,    50,   249,    21,     7,    99,   180,   247,    11,
      26,    21,    14,   528,   778,   109,   551,   552,   824,    99,
      22,    23,   716,    25,    26,    27,    28,   715,   846,   846,
     136,   846,   846,   347,   778,   329,     9,    51,    51,    51,
     618,    45,    51,   551,   552,    86,    72,    46,    51,    46,
    1094,   246,    43,   130,    52,   349,  1100,    83,    43,   353,
     354,    52,   756,   357,    51,   359,    57,    46,    72,    46,
      46,    57,    57,    72,    72,    46,   117,   129,    45,   105,
      83,    84,   660,   618,    71,   130,    45,   113,    58,   130,
      93,    88,   140,    72,  1087,    72,    72,    83,    84,   905,
     864,    72,   105,   106,    83,   620,   109,    93,   281,   113,
     618,   114,    46,   116,   113,   113,   130,   130,   130,   105,
     864,   130,    46,   109,   127,   128,   105,  1120,   114,    88,
     116,    98,   102,    58,   113,    45,   113,   113,    72,    98,
      52,   127,   113,    55,    58,   459,    71,   129,    72,  1142,
      72,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   265,    43,   175,   176,   255,   178,   179,    88,   113,
      51,   274,   184,    88,   699,   187,    45,    57,   102,   113,
      82,   113,   707,   708,   958,    45,    88,    47,    48,    58,
     778,   130,  1020,  1020,     3,  1020,  1020,  1013,   174,   182,
     405,   116,    71,    51,  1109,    85,    86,    94,   413,   907,
     125,    71,    99,   100,    43,    95,    46,    26,   120,    21,
      58,  1126,    51,    71,   104,    55,   106,    43,   108,   933,
     129,   118,    48,    71,    57,    51,   824,   117,    47,   355,
     130,    57,   122,  1059,   124,    21,  1062,   129,   128,    72,
      47,    48,    43,   129,   130,   559,    47,    48,   846,    57,
      57,    84,    85,    86,    43,   277,   278,   129,    47,    48,
     574,   283,    95,   285,     0,   579,   864,   581,    57,   395,
     584,   104,    21,   106,    57,   108,    51,    85,    86,  1063,
     113,    55,    47,    48,   117,    52,   841,    95,    55,   122,
     276,   124,    57,   419,   420,   128,   104,   109,   117,   321,
     108,   346,   706,   102,   103,   709,    58,   905,   906,   117,
     346,   110,    55,    99,   122,    55,   124,    49,    50,    45,
     128,    51,    55,    55,   346,   144,   348,    55,   147,   588,
     352,    49,    50,   152,    55,    43,   358,    55,    51,    47,
      48,   876,    45,    51,    57,    51,    21,    47,    48,    57,
      49,    50,    27,    83,    84,   174,    35,    55,    37,    38,
     958,   180,    55,    93,    43,    55,   152,    80,    55,    48,
      83,    84,    51,   971,    84,   105,   106,   399,    57,   109,
      93,   128,   575,    93,   114,   407,   116,   409,    49,    50,
     412,    71,   105,   415,    55,   381,   109,   127,   128,   109,
      43,   114,   530,   116,   114,   533,   116,    71,   536,   537,
      58,   539,   540,   541,   127,  1013,    55,   127,   128,    55,
      52,    49,  1020,   130,    99,   244,   130,   246,   247,   130,
     249,    51,   251,   129,   253,   254,   255,   256,   257,    45,
     259,   260,   261,   129,   129,    45,    45,    58,    83,    84,
     262,    46,    46,   265,   768,   769,   770,   276,    93,    52,
     246,  1059,   281,   249,  1062,  1063,   252,    55,   254,   255,
     105,   106,   258,    52,   109,   294,   262,   152,    55,   114,
      55,   116,    55,   797,   750,    51,    71,   600,    71,    71,
      52,    55,   127,   128,    55,    52,   610,    51,    46,   130,
     129,    57,    55,   178,   130,    45,    58,    52,    51,    46,
      44,  1109,   638,    44,   551,   552,    72,    52,    45,    52,
     634,   551,   552,    51,    71,    83,    84,   346,  1126,    85,
      86,    45,     3,    71,    45,    93,    45,    45,    51,    95,
      58,    51,   361,    58,   566,   116,   365,   105,   104,    46,
     106,   109,   108,    45,   373,    26,   114,   113,   116,   378,
     379,   117,   381,    20,   586,    71,   122,    71,   124,   127,
     128,   246,   128,    71,   249,   394,   702,   252,    51,   254,
     255,   618,   401,   258,   570,    51,   405,   262,   618,    71,
      52,    46,    57,    45,   413,    58,    55,    51,    84,    84,
      57,    25,    71,    52,    46,    52,   425,    72,    52,    45,
     429,    71,    51,    51,    71,    72,    88,    52,    51,   405,
      85,    86,   690,    51,    51,    45,    58,   413,    85,    86,
      95,    71,    58,    55,    51,    51,    45,    71,    95,   104,
      45,   106,    57,   108,    92,   667,   117,   104,   113,   106,
      52,   108,   117,   721,    83,    84,   113,   122,    52,   124,
     117,   126,   127,   128,    93,   122,    46,   124,    71,   126,
     127,   128,    71,   144,    58,    58,   105,   106,   107,    71,
     109,    71,    52,    52,    51,   114,    71,   116,    45,    57,
     712,    51,    54,    52,   716,    71,    21,    71,   127,   128,
      71,    52,    27,   725,    49,   805,   728,    71,    71,   180,
      52,   733,    52,   826,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,    55,    71,    51,
     405,    52,    52,    45,   756,   554,    51,    71,   413,   551,
     552,    52,   842,  1057,    58,    54,    52,    55,   778,   735,
      55,   570,    55,    54,    52,    54,   575,    54,   871,    54,
     782,    71,   548,  1027,    71,   551,   552,    71,   881,   588,
     550,   871,    91,   244,    99,   710,   247,   596,   597,   603,
     251,   107,   253,   254,   255,   256,   257,   606,   259,   260,
     261,   603,   966,   714,   906,   714,   757,   910,   610,  1011,
     864,   262,   621,   954,   552,   401,   618,   822,   660,    -1,
     281,   841,    -1,   835,   600,   837,   846,    -1,    83,    84,
     639,   841,   634,   294,    -1,   847,   848,   849,    93,   648,
      -1,   650,    -1,    -1,   864,    -1,    -1,    -1,    -1,   658,
     105,   863,    -1,    -1,   109,   867,    -1,   833,   834,   114,
      -1,   116,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   986,   548,   660,   346,   551,   552,    -1,    -1,
      -1,   949,    -1,   869,    -1,   953,   908,    -1,    -1,    -1,
     361,    -1,    -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,
      -1,   720,   373,    -1,    -1,    -1,    21,   378,   379,   931,
      -1,   933,    27,   935,   936,   937,   735,   939,   940,   964,
      -1,    -1,    -1,   394,    -1,   600,    -1,   252,   714,   254,
     255,   750,   954,   258,    -1,    -1,    -1,   262,   757,    -1,
      -1,    -1,   964,   618,    -1,    -1,    -1,   759,   760,   761,
      -1,    -1,   764,    -1,   425,    -1,    -1,    -1,   429,    -1,
      -1,   773,    -1,    -1,   750,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,    99,    -1,  1008,  1009,    -1,  1011,
    1020,    -1,  1014,    -1,    -1,    -1,    -1,    -1,   984,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1029,   827,    -1,
     822,    -1,   824,    -1,   833,   834,    -1,    -1,    -1,   805,
      -1,  1007,   808,    -1,    -1,    -1,   845,    -1,    -1,    -1,
      -1,  1053,    -1,    -1,   846,    -1,    -1,   152,    -1,   714,
     826,    -1,   861,    -1,    -1,    -1,    -1,    -1,  1070,    -1,
     869,    -1,  1074,    -1,  1076,   841,   842,  1079,    -1,    -1,
     879,    -1,    -1,   178,    -1,  1087,   885,    -1,    -1,    -1,
      -1,    -1,  1094,    -1,  1096,   750,    -1,    -1,  1100,    -1,
      -1,  1067,    -1,   554,    -1,   871,    -1,    -1,    -1,  1111,
    1112,    -1,    -1,   905,    -1,   881,    -1,    -1,  1120,  1121,
    1122,  1123,    -1,   778,   575,    -1,   925,    -1,   927,   928,
     929,    -1,    -1,  1099,    -1,    -1,    -1,   588,   930,    50,
    1142,    -1,    -1,    -1,   910,   596,   597,    -1,    -1,    -1,
     805,   246,    -1,   808,   249,   606,    -1,   252,    -1,   254,
     255,    -1,    -1,   258,    -1,    -1,    -1,   262,    -1,   824,
     621,   826,    -1,    76,    -1,    86,    -1,    88,    89,    -1,
      83,    84,    93,    94,   983,   984,   841,   842,   639,    -1,
      93,   846,   958,    -1,   986,    -1,    -1,   648,    -1,   650,
     111,    -1,   105,   106,    -1,   971,   109,   658,  1007,   864,
      -1,   114,    -1,   116,    -1,    -1,   871,    -1,    -1,    -1,
      -1,  1013,    -1,    -1,   127,   128,   881,  1026,  1020,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   548,    -1,    -1,   551,   552,    -1,    46,
     905,   906,    -1,   908,    51,   910,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    -1,    -1,    -1,  1059,  1067,    -1,
    1062,    -1,    -1,    -1,    71,    72,  1068,    -1,    -1,    -1,
      -1,    -1,    -1,    80,   939,    -1,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,   600,    93,  1063,    95,   954,
    1099,    -1,    -1,    -1,   101,    -1,   757,   104,   105,   106,
     405,   108,   109,   618,    -1,    -1,   113,   114,   413,   116,
     117,    -1,    -1,    -1,   121,   122,    -1,   124,    -1,    -1,
     127,   128,  1131,  1125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1109,    -1,    -1,    -1,  1139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1011,    -1,  1013,    46,
    1126,    -1,    -1,    -1,    51,  1020,    -1,    -1,   279,    -1,
      57,    -1,    -1,    -1,    -1,    -1,   827,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,   845,    57,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,  1059,    -1,    93,  1062,    95,    -1,
     861,    -1,    -1,    -1,   101,    -1,    -1,   104,   105,   106,
      -1,   108,   109,    85,    86,    -1,   113,   114,   879,   116,
     117,   342,  1087,    95,   885,   122,    -1,   124,    -1,    -1,
     127,   128,   104,    -1,   106,    -1,   108,    -1,    -1,    -1,
      -1,    -1,   363,   548,    -1,   117,   551,   552,    -1,    -1,
     122,    -1,   124,    -1,   126,   127,   128,    -1,    -1,    -1,
      -1,    -1,    -1,   778,   925,    -1,   927,   928,   929,    -1,
      -1,    -1,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
     805,    -1,    51,   808,    53,   600,    -1,    -1,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   826,    -1,   618,    -1,    74,    -1,    76,    -1,    78,
      79,    80,   983,    -1,    83,    84,   841,   842,    -1,    -1,
      -1,   846,    91,    -1,    93,    -1,    95,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,   864,
     109,    -1,    -1,    -1,    -1,   114,   871,   116,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1026,   881,    -1,   127,   128,
     129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    45,   908,    -1,   910,    -1,    -1,    51,    -1,
      53,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,   530,
      -1,    -1,   533,    -1,    -1,   536,   537,    -1,   539,   540,
     541,    74,    -1,    76,   939,    78,    79,    80,    -1,    -1,
      83,    84,    85,    86,    -1,    -1,    -1,    -1,    91,   954,
      93,    -1,    95,    -1,    -1,   750,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,    -1,   108,   109,    -1,    -1,    -1,
      57,   114,    -1,   116,   117,    -1,    -1,    -1,    -1,   122,
    1131,   124,    -1,   778,   127,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,  1011,    -1,    95,    -1,
     805,    -1,    -1,   808,    -1,  1020,    -1,   104,    -1,   106,
      -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   824,
     117,   826,    -1,    -1,    -1,   122,    -1,   124,   649,   126,
     127,   128,    -1,    -1,    31,    32,   841,   842,    -1,    36,
      -1,   846,    -1,    -1,    -1,    42,    -1,    -1,    45,    -1,
     671,    -1,    -1,    -1,    51,    -1,    53,    -1,    -1,   864,
      57,    -1,    -1,    -1,    -1,    -1,   871,    -1,    -1,   690,
      -1,    -1,  1087,    -1,    -1,    -1,   881,    74,    -1,    76,
      -1,    78,    79,    80,    -1,    -1,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    -1,
     905,    -1,    -1,   908,    -1,   910,    -1,   104,   105,   106,
      -1,   108,   109,    -1,    -1,    -1,    -1,   114,    -1,   116,
     117,    -1,    -1,    -1,    -1,   122,    -1,   124,    -1,   126,
     127,   128,   129,   130,   939,    -1,    31,    32,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,   954,
      45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    53,    -1,
      -1,    -1,    57,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    76,    -1,    78,    79,    80,    -1,    -1,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      95,    -1,    -1,    -1,    -1,    -1,  1011,    -1,  1013,   104,
     105,   106,    -1,   108,   109,  1020,    -1,    -1,    -1,   114,
      -1,   116,   117,    -1,    -1,    -1,    -1,   122,    -1,   124,
      -1,    -1,   127,   128,   129,   130,   857,    -1,    31,    32,
      33,    34,    35,    -1,    37,    38,    -1,    -1,    -1,    -1,
      43,    -1,    -1,    -1,  1059,    48,    -1,  1062,    51,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,  1087,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   949,    -1,
      -1,    -1,   953,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,    -1,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,    22,    -1,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,    22,    -1,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,    -1,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    -1,    76,    -1,    78,    79,
      80,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    95,    -1,    31,    32,    -1,
      -1,    -1,    36,    -1,    -1,   105,   106,    -1,    42,   109,
      -1,    45,    -1,    -1,   114,    -1,   116,    51,    -1,    53,
      -1,    -1,    -1,    57,    -1,    -1,    -1,   127,   128,   129,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    76,    -1,    78,    79,    80,    -1,    -1,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    91,    -1,    93,
      -1,    95,    -1,    31,    32,    -1,    -1,    -1,    36,    -1,
      -1,   105,    -1,    -1,    42,   109,    -1,    45,    -1,    -1,
     114,    -1,   116,    51,    -1,    53,    -1,    -1,    -1,    57,
      -1,    -1,    -1,   127,   128,   129,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,    76,    -1,
      78,    79,    80,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    -1,    93,    -1,    95,    -1,    31,
      32,    -1,    -1,    -1,    36,    -1,    -1,   105,    -1,    -1,
      42,   109,    -1,    45,    -1,    -1,   114,    -1,   116,    51,
      -1,    53,    -1,    -1,    -1,    57,    -1,    -1,    -1,   127,
     128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    74,    -1,    76,    -1,    78,    79,    80,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    93,    -1,    95,    -1,    31,    32,    -1,    -1,    -1,
      36,    -1,    -1,   105,    -1,    -1,    42,   109,    -1,    45,
      -1,    -1,   114,    -1,   116,    51,    -1,    53,    -1,    -1,
      -1,    57,    -1,    -1,    -1,   127,   128,   129,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    -1,    78,    79,    80,    -1,    -1,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    95,
      -1,    31,    32,    -1,    -1,    -1,    36,    -1,    -1,   105,
     106,    -1,    42,   109,    -1,    45,    -1,    -1,   114,    -1,
     116,    51,    -1,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,   127,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    74,    -1,    76,    -1,    78,    79,
      80,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    95,    -1,    31,    32,    -1,
      -1,    -1,    36,    -1,    -1,   105,    -1,    -1,    42,   109,
      -1,    45,    -1,    -1,   114,    -1,   116,    51,    -1,    53,
      54,    -1,    -1,    57,    -1,    -1,    -1,   127,   128,   129,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    78,    79,    80,    -1,    -1,    83,
      84,    -1,    31,    32,    -1,    -1,    -1,    36,    -1,    93,
      -1,    95,    -1,    42,    -1,    -1,    45,    -1,    -1,    -1,
      -1,   105,    51,    -1,    53,   109,    -1,    -1,    57,    -1,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,   127,   128,   129,   130,    76,    -1,    78,
      79,    80,    -1,    -1,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    95,    -1,    31,    32,
      -1,    -1,    -1,    36,    -1,    -1,   105,    -1,    -1,    42,
     109,    -1,    45,    -1,    -1,   114,    -1,   116,    51,    -1,
      53,    54,    -1,    -1,    57,    -1,    -1,    -1,   127,   128,
     129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    -1,    78,    79,    80,    -1,    -1,
      83,    84,    -1,    31,    32,    -1,    -1,    -1,    36,    -1,
      93,    -1,    95,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,   105,    51,    -1,    53,   109,    -1,    -1,    57,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   127,   128,   129,   130,    76,    -1,
      78,    79,    80,    -1,    -1,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    -1,    31,
      32,    -1,    -1,    -1,    36,    -1,    -1,   105,    -1,    -1,
      42,   109,    -1,    45,    -1,    -1,   114,    -1,   116,    51,
      -1,    53,    54,    -1,    -1,    57,    -1,    -1,    -1,   127,
     128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    78,    79,    80,    -1,
      -1,    83,    84,    -1,    31,    32,    -1,    -1,    -1,    36,
      -1,    93,    -1,    95,    -1,    42,    -1,    -1,    45,    -1,
      -1,    -1,    -1,   105,    51,    -1,    53,   109,    -1,    -1,
      57,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,   128,   129,   130,    76,
      -1,    78,    79,    80,    -1,    -1,    83,    84,    -1,    31,
      32,    -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    -1,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,   105,    51,
      -1,    53,   109,    -1,    -1,    57,    -1,   114,    -1,   116,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     127,   128,   129,   130,    -1,    -1,    78,    79,    80,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    93,    -1,    95,    -1,    46,    -1,    -1,    -1,    -1,
      51,    -1,    -1,   105,    -1,    -1,    57,   109,    -1,    -1,
      -1,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      71,    72,    -1,    -1,    -1,   127,   128,   129,   130,    80,
      46,    -1,    83,    84,    85,    86,    87,    -1,    89,    -1,
      -1,    57,    93,    -1,    95,    96,    -1,    -1,    -1,    -1,
     101,    -1,    -1,   104,   105,   106,    72,   108,   109,    -1,
      -1,    -1,   113,   114,   115,   116,   117,    -1,   119,    85,
      86,   122,    -1,   124,    -1,    -1,   127,   128,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
     106,    -1,   108,    51,    -1,    -1,    -1,   113,    -1,    57,
      -1,   117,    -1,    -1,    -1,    -1,   122,    -1,   124,    -1,
     126,   127,   128,    -1,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    -1,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
     108,   109,    -1,    -1,    51,   113,   114,    -1,   116,   117,
      57,    -1,    -1,    -1,   122,    -1,   124,    -1,    -1,   127,
     128,    -1,    -1,    -1,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,    -1,    83,    84,    -1,    -1,
      87,    -1,    89,    -1,    -1,    -1,    93,    57,    -1,    96,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,   105,    -1,
      -1,    -1,   109,    -1,    74,    -1,   113,   114,   115,   116,
      -1,    -1,   119,    83,    84,    85,    86,    -1,    -1,    -1,
     127,   128,    -1,    93,    -1,    95,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,   104,   105,   106,    -1,   108,   109,
      -1,    -1,    -1,    -1,   114,    -1,   116,   117,    -1,    -1,
      -1,    -1,   122,    -1,   124,    -1,   126,   127,   128,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
     104,   105,   106,    -1,   108,   109,    -1,    -1,    -1,    -1,
     114,    -1,   116,   117,    -1,    -1,    -1,    -1,   122,    -1,
     124,    -1,   126,   127,   128,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
     108,   109,    -1,    -1,    -1,    -1,   114,    -1,   116,   117,
      -1,    -1,    -1,    -1,   122,    -1,   124,    74,    -1,   127,
     128,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    37,    38,    39,    40,    41,
      -1,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      52,    -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    75,    -1,    77,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      38,    39,    40,    41,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    -1,    -1,    56,    57,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    77,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    37,    38,    39,    40,    41,    -1,    43,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    77,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    38,    39,
      40,    41,    -1,    43,    44,    -1,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    -1,    56,    57,    -1,    -1,
      -1,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    73,    37,    38,    39,    40,    41,    -1,
      43,    44,    -1,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    -1,    56,    57,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      73,    37,    38,    39,    40,    41,    -1,    43,    44,    -1,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    -1,
      56,    57,    -1,    -1,    -1,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    73,    37,    38,
      39,    40,    41,    -1,    43,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    -1,    55,    56,    57,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    73,    37,    38,    39,    40,    41,
      -1,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    -1,    55,    56,    57,    -1,    -1,    -1,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    73,    37,    38,    39,    40,    41,    -1,    43,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    57,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    73,    37,
      38,    39,    40,    41,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    -1,    56,    57,
      -1,    -1,    -1,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    73,    37,    38,    39,    40,
      41,    -1,    43,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    73,    37,    38,    39,    40,    41,    -1,    43,
      44,    -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      -1,    -1,    56,    57,    -1,    -1,    -1,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    73,
      37,    38,    39,    40,    41,    -1,    43,    44,    -1,    -1,
      47,    48,    49,    50,    51,    -1,    -1,    -1,    -1,    56,
      57,    -1,    -1,    -1,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    73,    37,    38,    39,
      40,    41,    -1,    43,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    -1,    -1,
      -1,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    73,    37,    38,    39,    40,    41,    -1,
      43,    -1,    -1,    -1,    47,    48,    49,    50,    51,    52,
      -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      73,    37,    38,    39,    40,    41,    -1,    43,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    52,    -1,    -1,    -1,
      56,    57,    -1,    -1,    -1,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    73,    37,    38,
      39,    40,    41,    -1,    43,    44,    -1,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    -1,    -1,    56,    57,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    73,    37,    38,    39,    40,    41,
      -1,    43,    44,    -1,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    73,    37,    38,    39,    40,    41,    -1,    43,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    56,    57,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    38,    39,    40,    41,    -1,    43,    -1,
      -1,    -1,    47,    48,    49,    50,    51,    52,    -1,    -1,
      -1,    56,    57,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    73,    37,
      38,    39,    40,    41,    -1,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    -1,    -1,    -1,    56,    57,
      -1,    -1,    -1,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    73,    37,    38,    39,    40,
      41,    -1,    43,    44,    -1,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    -1,    -1,    56,    57,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    73,    37,    38,    39,    40,    41,    -1,    43,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    52,    -1,
      -1,    -1,    56,    57,    -1,    -1,    -1,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    73,
      37,    38,    39,    40,    41,    -1,    43,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    -1,    -1,    -1,    56,
      57,    -1,    -1,    -1,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    73,    37,    38,    39,
      40,    41,    -1,    43,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    52,    -1,    -1,    -1,    56,    57,    -1,    -1,
      -1,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    73,    37,    38,    39,    40,    41,    -1,
      43,    -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      73,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    37,    38,    39,    40,    41,    -1,
      43,    44,    -1,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      73,    37,    38,    39,    40,    41,    -1,    43,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    -1,
      56,    57,    -1,    -1,    -1,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    73,    37,    38,
      39,    40,    41,    -1,    43,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    -1,    -1,    -1,    56,    57,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    73,    37,    38,    39,    40,    41,
      -1,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    -1,    56,    57,    -1,    -1,    -1,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    73,    37,    38,    39,    40,    41,    -1,    43,    44,
      -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    56,    57,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    73,    37,
      38,    39,    40,    41,    -1,    43,    44,    -1,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    -1,    -1,    56,    57,
      -1,    -1,    -1,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    73,    37,    38,    39,    40,
      41,    -1,    43,    -1,    -1,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    -1,    55,    56,    57,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    73,    37,    38,    39,    40,    41,    -1,    43,
      -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      -1,    55,    56,    57,    -1,    -1,    -1,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    73,
      37,    38,    39,    40,    41,    -1,    43,    -1,    -1,    -1,
      47,    48,    49,    50,    51,    52,    -1,    -1,    -1,    56,
      57,    -1,    -1,    -1,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    73,    37,    38,    39,
      40,    41,    -1,    43,    -1,    -1,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    -1,    -1,    56,    57,    -1,    -1,
      -1,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    73,    37,    38,    39,    40,    41,    -1,
      43,    -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    -1,    -1,    56,    57,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      73,    37,    38,    39,    40,    41,    -1,    43,    -1,    -1,
      -1,    47,    48,    49,    50,    51,    -1,    24,    25,    26,
      27,    57,    29,    30,    31,    32,    33,    34,    35,    -1,
      37,    38,    39,    40,    41,    -1,    43,    73,    -1,    -1,
      47,    48,    49,    50,    51,    -1,    24,    25,    26,    -1,
      57,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      38,    39,    40,    41,    -1,    43,    73,    -1,    -1,    47,
      48,    49,    50,    51,    24,    25,    26,    -1,    -1,    57,
      -1,    31,    32,    33,    34,    35,    -1,    37,    38,    39,
      40,    41,    -1,    43,    -1,    73,    -1,    47,    48,    49,
      50,    51,    -1,    26,    -1,    -1,    -1,    57,    31,    32,
      33,    34,    35,    -1,    37,    38,    39,    40,    41,    -1,
      43,    -1,    -1,    73,    26,    48,    -1,    50,    51,    31,
      32,    33,    34,    35,    57,    37,    38,    -1,    40,    41,
      -1,    43,    -1,    -1,    -1,    -1,    48,    -1,    50,    51,
      73,    26,    -1,    -1,    -1,    57,    31,    32,    33,    34,
      35,    -1,    37,    38,    -1,    40,    -1,    -1,    43,    -1,
      -1,    73,    26,    48,    -1,    50,    51,    31,    32,    33,
      34,    35,    57,    37,    38,    -1,    -1,    82,    -1,    43,
      -1,    -1,    -1,    88,    48,    90,    50,    51,    73,    94,
      -1,    -1,    97,    57,    99,   100,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,    -1,   111,   112,    -1,    73,
      -1,    -1,    43,   118,    -1,    -1,    47,    48,   123,    50,
      51,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70
  };

  const short
  P4Parser::yystos_[] =
  {
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,   134,   135,
     137,   138,    31,    32,    36,    42,    45,    51,    53,    57,
      76,    78,    79,    80,    83,    84,    93,    95,   105,   109,
     114,   116,   127,   128,   129,   130,   140,   165,   206,   207,
     208,   212,   289,   290,   294,   106,   128,   140,   141,   150,
     151,   130,   297,   129,   130,   296,   298,   129,   299,   294,
     130,   296,   129,   294,   130,   129,   294,   130,   129,   129,
       0,    21,    20,    71,    72,    85,    86,    95,   104,   106,
     108,   113,   117,   122,   124,   126,   127,   139,   144,   145,
     146,   156,   159,   165,   166,   169,   191,   192,   198,   202,
     205,   208,   209,   210,   211,   212,   213,   214,   222,   223,
     224,   227,   230,   235,   240,   241,   243,   279,   282,   285,
     294,   294,   294,   128,   140,   150,   289,    95,   108,   205,
     208,   212,   294,   294,    57,   128,   140,    51,    47,    48,
      57,   291,   300,    55,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    37,    38,    39,    40,
      41,    43,    49,    50,    51,    56,    73,   291,   300,    58,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    74,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   148,   300,    45,   300,   300,    45,   148,   300,
     300,    82,    88,    90,    94,    97,    99,   100,   109,   111,
     112,   118,   123,    95,   146,   202,   205,    71,    51,    71,
     164,    71,   164,   144,   145,   254,    51,    43,    43,   141,
      71,    55,   186,    55,   186,    52,    52,   141,    74,   141,
     286,   287,   288,   294,   292,    74,   126,   140,   205,   218,
     219,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,    49,   286,   294,   294,    74,   126,   205,   220,   221,
     294,   294,   151,   130,   296,   129,   294,   130,   129,   294,
     130,   129,    86,   117,   130,   136,    43,    51,    51,   130,
     141,   242,    51,   130,   218,   242,   147,   219,    51,   130,
     141,   205,   141,   106,   141,   205,   127,   140,   141,   202,
     205,   141,   141,   205,   141,   141,   141,   144,   205,   223,
     254,    51,   144,   152,   153,   154,    45,    45,    45,   286,
     294,   294,   215,   216,   300,    76,    46,    46,   294,    58,
      52,    55,   141,    49,    50,    55,   301,    31,    44,    54,
     294,    52,    54,    55,   301,    55,    55,    55,   300,   150,
     289,   147,   294,   301,    46,    55,   294,   301,   301,    55,
     186,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      53,    54,    55,    56,    57,    58,    71,    72,    73,    74,
      75,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   149,   301,   294,   301,    51,   141,
     193,   236,   141,   199,    71,    71,   225,   231,   141,   157,
     170,   228,   141,   141,   286,   102,   103,   110,   155,    52,
      55,   167,   195,   255,    52,    44,    44,   203,   141,   217,
      55,   186,    74,   294,   288,   218,    54,   294,   294,   218,
      51,   294,   130,   129,   130,    55,   186,   186,    52,    52,
     141,    52,    46,   147,    52,   152,    58,   215,    45,   237,
     215,   215,   215,   215,   215,   215,    52,   205,   154,   144,
     145,   159,   168,   172,   173,   190,   205,   280,   281,   282,
      84,   144,   159,   196,   269,   279,   280,   282,   256,   141,
      51,    55,   301,    46,   294,    44,   286,   301,    44,    44,
     301,   301,    52,   301,    52,   284,   294,   194,   242,    45,
     200,   226,   232,   158,   171,   229,   141,   141,   116,   125,
     205,    46,   144,   173,   141,    71,   197,   254,   120,    46,
      51,    71,    80,    87,    89,    96,   101,   115,   119,   144,
     159,   208,   212,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   257,   261,   262,   280,   282,   290,
     293,    58,    71,   152,   141,    44,    52,   254,    71,    51,
     186,   141,   238,   239,    45,    45,    45,    51,    51,    45,
      58,    71,    58,   141,   300,   141,    58,   283,    46,   141,
     165,   293,    71,    71,    71,    51,    71,   294,    51,    98,
      57,    57,    71,    43,    50,    51,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,   291,
     300,    45,   160,    52,   152,    46,    58,    55,   186,   201,
     233,   233,   152,   152,   233,   160,   294,   174,   208,   210,
     213,   283,   284,    45,    52,   294,    71,   294,    51,    84,
      84,   294,    25,   286,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   219,   161,    71,
      52,   284,   239,    46,    46,   144,   204,    46,   144,   234,
      46,    52,    52,    46,    71,    45,   301,   301,   301,    83,
     105,   144,   270,   271,    52,    52,   145,   205,   245,   263,
     264,   265,   281,    51,    51,    31,    44,    54,   294,    52,
     301,   162,    81,   128,   202,   205,   175,    51,    51,    51,
      58,    58,    88,   143,    46,   271,   144,   208,   212,   253,
      45,   205,   141,    71,    55,   286,   286,    54,   294,    51,
      46,   145,   159,   163,   285,   202,    51,    71,   141,   121,
     144,   145,   176,   177,   179,   205,   244,   246,   249,   252,
     280,   282,   294,   294,   294,    45,    45,    84,    93,   109,
     114,   116,   127,   128,   142,    92,   258,   141,   102,   294,
     145,   265,    52,    52,   294,    44,   286,    71,   152,    71,
     107,   141,   180,   181,    45,   205,    46,    52,    52,    52,
     274,   272,    58,    58,   253,    31,    32,    42,    46,    51,
      53,    78,    79,    80,    91,    95,   129,   130,   206,   208,
     259,   260,   290,   295,   102,   205,   268,   294,    71,    71,
      71,    44,    52,    52,    51,    71,   178,   141,   141,   141,
      46,   144,    46,   273,   294,    45,   284,   294,   294,   294,
     205,   294,   294,    57,    51,   291,    54,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    37,
      38,    39,    40,    41,    43,    49,    50,    51,    56,    73,
     291,   300,   268,    52,    77,   245,   266,   267,    71,   289,
     175,    71,    71,    71,   275,   290,    54,   278,    71,    52,
      52,   141,   286,   254,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,    49,   286,   294,   294,   221,   294,    52,
     253,   294,    52,    55,    52,    46,    71,    51,   141,    46,
     143,   276,   294,    52,    31,    44,    54,   294,    52,    54,
     301,   253,   253,   245,    45,   286,   144,    51,    74,    91,
     114,   184,   185,   189,   277,   294,    54,   294,   294,    51,
     182,    52,    71,    74,    91,   188,   189,   294,    58,    54,
     184,    75,    77,   294,    44,   286,    46,   183,   184,    52,
      55,    75,    77,    51,   130,   275,    54,   294,   294,    44,
      52,    54,   187,   189,   294,   294,   294,    54,   144,   275,
     141,    52,    55,    52,    71,   144,    71,   189,    54,    71
  };

  const short
  P4Parser::yyr1_[] =
  {
       0,   133,   134,   134,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     136,   136,   136,   137,   138,   138,   138,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   140,   140,   140,
     140,   140,   140,   140,   140,   141,   141,   141,   142,   142,
     142,   142,   142,   142,   143,   143,   144,   144,   145,   145,
     146,   146,   146,   146,   146,   147,   147,   147,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     150,   150,   151,   152,   152,   153,   153,   154,   154,   155,
     155,   155,   155,   157,   158,   156,   159,   159,   159,   159,
     161,   160,   162,   162,   163,   163,   164,   164,   165,   166,
     167,   167,   168,   168,   168,   168,   170,   171,   169,   172,
     172,   174,   173,   175,   175,   176,   176,   176,   176,   176,
     176,   176,   178,   177,   179,   179,   180,   180,   181,   182,
     182,   183,   184,   184,   185,   185,   186,   186,   187,   187,
     188,   188,   188,   188,   189,   189,   189,   189,   189,   190,
     190,   190,   191,   193,   194,   192,   195,   195,   196,   196,
     196,   196,   196,   197,   199,   200,   198,   198,   198,   201,
     201,   203,   202,   204,   204,   204,   205,   205,   205,   205,
     205,   205,   206,   206,   207,   207,   208,   209,   210,   211,
     211,   212,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   214,   214,   214,   215,   215,   216,
     217,   217,   218,   218,   218,   218,   219,   219,   219,   220,
     220,   220,   221,   221,   222,   222,   222,   222,   222,   223,
     223,   223,   223,   225,   226,   224,   228,   229,   227,   231,
     232,   230,   233,   233,   234,   236,   235,   237,   235,   238,
     238,   239,   240,   241,   242,   242,   243,   243,   243,   244,
     245,   245,   245,   245,   245,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   245,   245,   246,   247,   248,   248,
     249,   249,   250,   251,   252,   252,   253,   253,   253,   253,
     253,   253,   253,   253,   253,   253,   253,   255,   254,   256,
     256,   257,   258,   258,   259,   259,   260,   260,   261,   261,
     261,   261,   262,   262,   262,   263,   263,   264,   264,   265,
     265,   266,   266,   267,   267,   268,   268,   268,   269,   270,
     270,   271,   271,   271,   271,   272,   272,   273,   274,   274,
     275,   275,   276,   276,   277,   277,   278,   278,   279,   280,
     281,   281,   282,   283,   283,   284,   285,   285,   286,   286,
     287,   287,   288,   288,   288,   288,   289,   289,   289,   290,
     290,   292,   291,   293,   293,   293,   293,   293,   293,   293,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   296,   296,   297,   297,   298,   298,   299,   299,   300,
     300,   301,   301
  };

  const signed char
  P4Parser::yyr2_[] =
  {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     4,     4,     6,     6,     6,     4,
       1,     4,     1,     2,     0,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     0,     1,     1,     2,
       2,     5,     6,     6,     4,     0,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     0,     1,     1,     3,     4,     6,     1,
       1,     1,     0,     0,     0,     9,     7,     6,     9,     8,
       0,     4,     0,     2,     1,     1,     0,     3,     1,     6,
       0,     2,     1,     1,     1,     1,     0,     0,     9,     1,
       2,     0,     8,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     0,     2,     2,     1,     7,     0,
       2,     4,     1,     1,     5,     3,     0,     1,     1,     3,
       3,     3,     1,     1,     1,     3,     3,     1,     1,    10,
      10,    10,     7,     0,     0,     9,     0,     2,     1,     1,
       1,     1,     1,     1,     0,     0,     9,     4,     4,     0,
       2,     0,     7,     3,     4,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     4,     4,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     6,     6,     6,     1,     1,     1,     0,     1,     3,
       1,     3,     1,     1,     1,     1,     0,     1,     3,     1,
       1,     1,     1,     3,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     0,     0,     9,     0,     0,     9,     0,
       0,     9,     0,     2,     4,     0,     8,     0,     9,     1,
       3,     3,     4,     5,     1,     3,     4,     4,     4,     2,
       4,     7,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     3,     3,     3,     1,     2,     2,     3,
       5,     7,     2,     2,     7,     7,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     0,
       2,     7,     0,     2,     3,     2,     1,     1,     1,     1,
       1,     1,    10,     9,    10,     0,     1,     1,     3,     1,
       1,     0,     1,     1,     3,     1,     3,     1,     6,     1,
       2,     5,     5,     7,     6,     0,     2,     5,     0,     4,
       1,     4,     7,     6,     4,     6,     0,     2,     7,     2,
       4,     3,     7,     0,     2,     1,     3,     2,     0,     1,
       1,     3,     1,     3,     1,     3,     0,     1,     3,     1,
       2,     0,     3,     1,     1,     2,     4,     6,     7,     3,
       1,     1,     1,     1,     1,     1,     1,     4,     6,     7,
       4,     1,     4,     6,     3,     2,     2,     2,     2,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     7,     4,     4,     4,     1,     1,
       1,     1,     1,     1,     4,     6,     7,     3,     2,     2,
       2,     2,     2,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     7,     4,     4,
       4,     1,     1,     1,     3,     1,     3,     1,     3,     1,
       1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const P4Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "START_PROGRAM",
  "START_EXPRESSION_LIST", "START_KV_LIST", "START_INTEGER_LIST",
  "START_INTEGER_OR_STRING_LITERAL_LIST", "START_STRING_LITERAL_LIST",
  "START_EXPRESSION", "START_INTEGER", "START_INTEGER_OR_STRING_LITERAL",
  "START_STRING_LITERAL", "START_EXPRESSION_PAIR", "START_INTEGER_PAIR",
  "START_STRING_LITERAL_PAIR", "START_EXPRESSION_TRIPLE",
  "START_INTEGER_TRIPLE", "START_STRING_LITERAL_TRIPLE",
  "START_P4RT_TRANSLATION_ANNOTATION", "END", "END_ANNOTATION",
  "UNEXPECTED_TOKEN", "END_PRAGMA", "\"<=\"", "\">=\"", "\"<<\"", "\"&&\"",
  "\"||\"", "\"!=\"", "\"==\"", "\"+\"", "\"-\"", "\"|+|\"", "\"|-|\"",
  "\"*\"", "\"{#}\"", "\"/\"", "\"%\"", "\"|\"", "\"&\"", "\"^\"", "\"~\"",
  "\"[\"", "\"]\"", "\"{\"", "\"}\"", "\"<\"", "L_ANGLE_ARGS", "\">\"",
  "R_ANGLE_SHIFT", "\"(\"", "\")\"", "\"!\"", "\":\"", "\",\"", "\"?\"",
  "\".\"", "\"=\"", "\"+=\"", "\"-=\"", "\"*=\"", "\"/=\"", "\"%=\"",
  "\"&=\"", "\"|=\"", "\"^=\"", "\"<<=\"", "\">>=\"", "\"|+|=\"",
  "\"|-|=\"", "\";\"", "\"@\"", "\"++\"", "\"_\"", "\"&&&\"", "\"...\"",
  "\"..\"", "TRUE", "FALSE", "THIS", "ABSTRACT", "ACTION", "ACTIONS",
  "APPLY", "BOOL", "BIT", "BREAK", "CONST", "CONTINUE", "CONTROL",
  "DEFAULT", "ELSE", "ENTRIES", "ENUM", "ERROR", "EXIT", "EXTERN", "FOR",
  "HEADER", "HEADER_UNION", "IF", "IN", "INOUT", "INT", "KEY", "LIST",
  "SELECT", "MATCH_KIND", "TYPE", "OUT", "PACKAGE", "PARSER", "PRAGMA",
  "PRIORITY", "RETURN", "STATE", "STRING", "STRUCT", "SWITCH", "TABLE",
  "TRANSITION", "TUPLE", "TYPEDEF", "VARBIT", "VALUESET", "VOID",
  "IDENTIFIER", "TYPE_IDENTIFIER", "STRING_LITERAL", "INTEGER", "PREFIX",
  "THEN", "$accept", "start", "fragment", "p4rtControllerType", "program",
  "input", "declaration", "nonTypeName", "name", "nonTableKwName",
  "optCONST", "optAnnotations", "annotations", "annotation",
  "annotationBody", "annotationName", "annotationToken", "kvList",
  "kvPair", "parameterList", "nonEmptyParameterList", "parameter",
  "direction", "packageTypeDeclaration", "$@1", "$@2", "instantiation",
  "objInitializer", "$@3", "objDeclarations", "objDeclaration",
  "optConstructorParameters", "dotPrefix", "parserDeclaration",
  "parserLocalElements", "parserLocalElement", "parserTypeDeclaration",
  "$@4", "$@5", "parserStates", "parserState", "$@6", "parserStatements",
  "parserStatement", "parserBlockStatement", "$@7", "transitionStatement",
  "stateExpression", "selectExpression", "selectCaseList", "selectCase",
  "keysetExpression", "tupleKeysetExpression", "optTrailingComma",
  "simpleExpressionList", "reducedSimpleKeysetExpression",
  "simpleKeysetExpression", "valueSetDeclaration", "controlDeclaration",
  "controlTypeDeclaration", "$@8", "$@9", "controlLocalDeclarations",
  "controlLocalDeclaration", "controlBody", "externDeclaration", "$@10",
  "$@11", "methodPrototypes", "functionPrototype", "$@12",
  "methodPrototype", "typeRef", "namedType", "prefixedType", "typeName",
  "p4listType", "tupleType", "headerStackType", "specializedType",
  "baseType", "typeOrVoid", "optTypeParameters", "typeParameters",
  "typeParameterList", "typeArg", "typeArgumentList", "realTypeArg",
  "realTypeArgumentList", "typeDeclaration", "derivedTypeDeclaration",
  "headerTypeDeclaration", "$@13", "$@14", "structTypeDeclaration", "$@15",
  "$@16", "headerUnionDeclaration", "$@17", "$@18", "structFieldList",
  "structField", "enumDeclaration", "$@19", "$@20",
  "specifiedIdentifierList", "specifiedIdentifier", "errorDeclaration",
  "matchKindDeclaration", "identifierList", "typedefDeclaration",
  "assignmentOrMethodCallStatement",
  "assignmentOrMethodCallStatementWithoutSemicolon", "emptyStatement",
  "exitStatement", "returnStatement", "conditionalStatement",
  "breakStatement", "continueStatement", "directApplication", "statement",
  "blockStatement", "$@21", "statOrDeclList", "switchStatement",
  "switchCases", "switchCase", "switchLabel", "statementOrDeclaration",
  "forStatement", "forInitStatements", "forInitStatementsNonEmpty",
  "declOrAssignmentOrMethodCallStatement", "forUpdateStatements",
  "forUpdateStatementsNonEmpty", "forCollectionExpr", "tableDeclaration",
  "tablePropertyList", "tableProperty", "keyElementList", "keyElement",
  "actionList", "actionRef", "entry", "entryPriority", "entriesList",
  "actionDeclaration", "variableDeclaration",
  "variableDeclarationWithoutSemicolon", "constantDeclaration",
  "optInitializer", "initializer", "functionDeclaration", "argumentList",
  "nonEmptyArgList", "argument", "expressionList", "prefixedNonTypeName",
  "dot_name", "$@22", "lvalue", "expression", "nonBraceExpression",
  "intOrStr", "intList", "intOrStrList", "strList", "l_angle", "r_angle", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  P4Parser::yyrline_[] =
  {
       0,   389,   389,   390,   395,   396,   397,   398,   399,   402,
     403,   404,   405,   408,   414,   420,   428,   435,   442,   452,
     465,   467,   470,   474,   477,   478,   479,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   496,   497,   498,
     499,   500,   501,   502,   503,   507,   508,   509,   513,   514,
     515,   516,   517,   518,   522,   523,   527,   528,   532,   538,
     547,   552,   554,   556,   560,   565,   566,   573,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   686,
     687,   688,   689,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   702,   703,   704,   705,   706,   707,   708,
     710,   711,   712,   713,   720,   721,   722,   723,   724,   725,
     726,   727,   729,   730,   731,   732,   733,   734,   735,   736,
     740,   741,   745,   749,   750,   754,   756,   760,   761,   765,
     766,   767,   768,   772,   773,   772,   783,   787,   790,   794,
     800,   800,   806,   807,   811,   812,   816,   817,   821,   827,
     836,   837,   841,   842,   843,   844,   849,   850,   848,   858,
     860,   864,   864,   871,   872,   876,   877,   878,   879,   880,
     881,   882,   886,   886,   891,   892,   896,   897,   901,   907,
     908,   912,   918,   919,   923,   925,   929,   930,   934,   935,
     940,   941,   942,   943,   947,   948,   949,   950,   951,   955,
     958,   961,   969,   978,   979,   977,   987,   988,   992,   993,
     994,   995,   996,  1000,  1007,  1008,  1006,  1012,  1016,  1024,
    1025,  1030,  1029,  1042,  1045,  1049,  1058,  1059,  1060,  1061,
    1062,  1063,  1067,  1068,  1072,  1073,  1078,  1082,  1086,  1090,
    1091,  1095,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1107,
    1109,  1112,  1114,  1116,  1121,  1122,  1123,  1128,  1129,  1133,
    1137,  1139,  1143,  1144,  1146,  1147,  1151,  1152,  1153,  1157,
    1158,  1159,  1165,  1166,  1170,  1171,  1172,  1173,  1174,  1178,
    1179,  1180,  1181,  1185,  1185,  1185,  1193,  1193,  1193,  1201,
    1201,  1201,  1209,  1210,  1214,  1219,  1218,  1221,  1221,  1229,
    1231,  1235,  1239,  1244,  1249,  1251,  1256,  1258,  1260,  1267,
    1272,  1277,  1282,  1285,  1287,  1289,  1291,  1293,  1295,  1297,
    1299,  1301,  1303,  1305,  1307,  1309,  1314,  1318,  1322,  1323,
    1327,  1329,  1334,  1338,  1343,  1348,  1356,  1357,  1358,  1359,
    1360,  1361,  1362,  1363,  1364,  1365,  1366,  1370,  1370,  1376,
    1377,  1381,  1386,  1387,  1391,  1392,  1396,  1397,  1401,  1402,
    1403,  1408,  1412,  1417,  1420,  1426,  1427,  1431,  1432,  1437,
    1438,  1442,  1443,  1447,  1449,  1454,  1455,  1456,  1462,  1468,
    1470,  1474,  1478,  1482,  1486,  1493,  1494,  1498,  1504,  1505,
    1510,  1512,  1517,  1528,  1542,  1543,  1547,  1548,  1554,  1562,
    1566,  1569,  1575,  1581,  1582,  1586,  1592,  1595,  1601,  1602,
    1606,  1608,  1612,  1613,  1614,  1615,  1619,  1620,  1622,  1626,
    1627,  1632,  1632,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1657,
    1659,  1660,  1661,  1663,  1670,  1671,  1672,  1673,  1674,  1675,
    1677,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,
    1689,  1691,  1692,  1693,  1695,  1696,  1697,  1698,  1699,  1700,
    1701,  1702,  1703,  1704,  1705,  1707,  1709,  1711,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  1722,  1724,  1726,  1727,  1728,
    1729,  1730,  1731,  1733,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1747,  1748,  1749,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1763,  1765,
    1767,  1771,  1772,  1776,  1779,  1785,  1788,  1794,  1797,  1802,
    1802,  1803,  1803
  };

  void
  P4Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  P4Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 23 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"
} // P4
#line 10104 "/builddir/build/BUILD/p4c-1.2.5.6/redhat-linux-build/frontends/parsers/p4/p4parser.cpp"

#line 1807 "/builddir/build/BUILD/p4c-1.2.5.6/frontends/parsers/p4/p4parser.ypp"


namespace P4 {

void P4Parser::error(const Util::SourceInfo& location,
                     const std::string& message) {
    driver.onParseError(location, message);
}

}  // namespace P4

#pragma GCC diagnostic pop
